/**
 * 
 */
package dialogs;

import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Text;

import spinworks.SW_main;

import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Label;

/**
 * @author marat
 *
 */
public class BinningParametersDialog extends Dialog 
{

	protected Object result;
	protected Shell shell;
	private Text textBinWidth;
	private Text textBinStart;
	private Text textBinEnd;

/**
 * Create the dialog.
 * @param parent
 * @param style
 */
	public BinningParametersDialog(Shell parent, int style) 
	{
		super(parent, style);
		setText("Binning Parameters");
	}

/**
 * Open the dialog.
 * @return the result
 */
	public Object open() 
	{
		createContents();
		shell.open();
		shell.layout();
		Display display = getParent().getDisplay();
		while (!shell.isDisposed()) 
		{
			if (!display.readAndDispatch()) 
			{
				display.sleep();
			}
		}
		return result;
	}

/**
 * Create contents of the dialog.
 */
	private void createContents() 
	{
		shell = new Shell(getParent(), getStyle());
		shell.setSize(233, 194);
		shell.setText(getText());
		
		Button buttonOK = new Button(shell, SWT.NONE);		
		buttonOK.setBounds(60, 131, 75, 25);
		buttonOK.setText("OK");
		
		Button buttonCancel = new Button(shell, SWT.NONE);
		buttonCancel.setBounds(141, 131, 75, 25);
		buttonCancel.setText("Cancel");
		
		textBinWidth = new Text(shell, SWT.BORDER);
		textBinWidth.setBounds(126, 10, 90, 21);
		textBinWidth.setText(String.format("%.3f", SW_main.gp.bin_width));
		
		textBinStart = new Text(shell, SWT.BORDER);
		textBinStart.setBounds(126, 37, 90, 21);
		textBinStart.setText(String.format("%.3f", SW_main.gp.bin_start));
		
		textBinEnd = new Text(shell, SWT.BORDER);
		textBinEnd.setBounds(126, 64, 91, 21);
		textBinEnd.setText(String.format("%.3f", SW_main.gp.bin_end));
		
		final Combo comboBinMethod = new Combo(shell, SWT.NONE);
		comboBinMethod.setItems(new String[] {"Integral", "Maximum", "Mean"});
		comboBinMethod.setBounds(126, 91, 91, 23);
		comboBinMethod.select(SW_main.gp.bin_method);
		
		Label lblBinWidthppm = new Label(shell, SWT.NONE);
		lblBinWidthppm.setAlignment(SWT.RIGHT);
		lblBinWidthppm.setBounds(10, 13, 110, 15);
		lblBinWidthppm.setText("Bin Width (ppm):");
		
		Label lblBinningStartppm = new Label(shell, SWT.NONE);
		lblBinningStartppm.setAlignment(SWT.RIGHT);
		lblBinningStartppm.setBounds(10, 40, 110, 15);
		lblBinningStartppm.setText("Binning Start (ppm):");
		
		Label lblBinningEndppm = new Label(shell, SWT.NONE);
		lblBinningEndppm.setAlignment(SWT.RIGHT);
		lblBinningEndppm.setBounds(10, 67, 110, 15);
		lblBinningEndppm.setText("Binning End (ppm):");
		
		Label lblMethod = new Label(shell, SWT.NONE);
		lblMethod.setAlignment(SWT.RIGHT);
		lblMethod.setBounds(65, 94, 55, 15);
		lblMethod.setText("Method:");
		
	// listeners
		buttonOK.addSelectionListener(new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				// retrieve values from dialog
				SW_main.gp.bin_width = Double.parseDouble(textBinWidth.getText());
				SW_main.gp.bin_start = Double.parseDouble(textBinStart.getText());
				SW_main.gp.bin_end = Double.parseDouble(textBinEnd.getText());
				SW_main.gp.bin_method = comboBinMethod.getSelectionIndex();
				
				shell.dispose();
			}
		});
		
		buttonCancel.addSelectionListener(new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				shell.dispose();
			}
		});
		
	}	// end createContents
//-------------------------------------------------------------------------------------------------
}	// end class
