
/// <copyright>
///	Copyright (c) 2006-2016

///	Kirk Marat
///	The University of Manitoba
///	Winnipeg, Manitoba, Canada
///	R3T 2N2

///	All rights reserved.

///	This source may be distributed, provided that the author and the University are 
/// appropriately acknowledged.  However, incorporation of any part into any commercial product 
/// is prohibited without prior written authorization. 
///
/// see:  http://www.gnu.org/licenses/gpl.html
///
/// Note:
/// Distribution of this source or any of its components into the People's Republic of China 
/// is strictly prohibited.
/// 
///	The author disclaims all warranties with regard to this software, including all implied 
///	warranties of merchantability and fitness. In no event, shall the author or the University of 
///	Manitoba be liable for any special, indirect or consequential damages, or any damages whatsoever 
///	resulting from loss of use, data or profits, whether in an action of contract, negligence or 
///	other tortuous action, arising out of or in connection with the use or performance of this 
///	software.

///	All trademarks mentioned (e.g. XwinNMR, VNMR(J), Windows, etc.) are property of their 
///	respective owners.
/// </copyright>

package dialogs;

import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Spinner;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Font;
import org.eclipse.wb.swt.SWTResourceManager;

import spinworks.SW_main;

public class DecimalDigitsDialog extends Dialog 
{
	protected Object result;
	protected Shell shell;	
	Font currentFont;

	/**
	 * Create the dialog.
	 * @param parent
	 * @param style
	 */
	public DecimalDigitsDialog(Shell parent, int style) 
	{
		super(parent, style);
		setText("Decimal digits");
	}

	/**
	 * Open the dialog.
	 * @return the result
	 */
	public Object open() 
	{
		createContents();
		shell.open();
		shell.layout();
		Display display = getParent().getDisplay();
		while (!shell.isDisposed()) 
		{
			if (!display.readAndDispatch())
			{
				display.sleep();
			}
		}
		return result;
	}

	/**
	 * Create contents of the dialog.
	 */
	private void createContents() 
	{
		shell = new Shell(getParent(), getStyle());
		shell.setSize(389, 128);
		shell.setText("Decimal Digits for Peaks and Integrals");
		
		final Spinner spinnerIntegrals = new Spinner(shell, SWT.BORDER);
		spinnerIntegrals.setMaximum(10);
		spinnerIntegrals.setBounds(94, 27, 65, 22);
		spinnerIntegrals.setSelection(SW_main.gp.int_digits);
		
		final Spinner spinnerPeaks = new Spinner(shell, SWT.BORDER);
		spinnerPeaks.setMaximum(10);
		spinnerPeaks.setBounds(94, 60, 65, 22);
		spinnerPeaks.setSelection(SW_main.gp.pp_digits);
		
		Label lblIntegrals = new Label(shell, SWT.NONE);
		lblIntegrals.setAlignment(SWT.RIGHT);
		lblIntegrals.setBounds(10, 30, 65, 15);
		lblIntegrals.setText("Integrals:");
		
		Label lblPeaks = new Label(shell, SWT.NONE);
		lblPeaks.setAlignment(SWT.RIGHT);
		lblPeaks.setBounds(20, 63, 55, 15);
		lblPeaks.setText("Peaks:");
		
		Button buttonOK = new Button(shell, SWT.NONE);	
		currentFont = buttonOK.getFont();
		buttonOK.setFont(SWTResourceManager.getBoldFont(currentFont));
		buttonOK.setBounds(202, 65, 80, 27);
		buttonOK.setBackground(SWTResourceManager.getColor(SWT.COLOR_GREEN));
		buttonOK.setText("OK");
		shell.setDefaultButton(buttonOK);
		
		Button buttonCancel = new Button(shell, SWT.NONE);		
		currentFont = buttonCancel.getFont();
		buttonCancel.setFont(SWTResourceManager.getBoldFont(currentFont));
		buttonCancel.setBounds(293, 65, 80, 27);
		buttonCancel.setBackground(SWTResourceManager.getColor(SWT.COLOR_RED));
		buttonCancel.setText("Cancel");

// widget listeners
		buttonOK.addSelectionListener(new SelectionAdapter()		// OK button
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				SW_main.gp.int_digits = spinnerIntegrals.getSelection();
				SW_main.gp.pp_digits = spinnerPeaks.getSelection();			
				shell.dispose();
				SW_main.update_spect = true;
				SW_main.canvas.redraw();
			}
		});
		
		buttonCancel.addSelectionListener(new SelectionAdapter() 	// cancel button
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				shell.dispose();
			}
		});		
	}
//------------------------------------------------------------------------------------------------
}
