package dialogs;

import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import decon.DeconUtil;
import simulation.SS_util;
import simulation.SimPar;
import spinworks.SW_main;
import spinworks.Util;

import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;

public class DeconPeaksDialog extends Dialog 
{

	protected Object result;
	protected Shell shell;
	private ScrolledComposite scrolledComposite;

	static Label[] labelPeakNumber = new Label[SW_main.MAX_DECON_PEAKS];
	
	static Text[] textFrequency= new Text[SW_main.MAX_DECON_PEAKS];
	static Button[] buttonIterateFrequency = new Button[SW_main.MAX_DECON_PEAKS];
	
	static Text[] textAmplitude = new Text[SW_main.MAX_DECON_PEAKS];
	static Button[] buttonIterateAmplitude = new Button[SW_main.MAX_DECON_PEAKS];
	
	static Text[] textWidth = new Text[SW_main.MAX_DECON_PEAKS];
	static Button[] buttonIterateWidth = new Button[SW_main.MAX_DECON_PEAKS];
	
	static Text[] textGaussian = new Text[SW_main.MAX_DECON_PEAKS];
	static Button[] buttonIterateGaussian = new Button[SW_main.MAX_DECON_PEAKS];
	
	/**
	 * Create the dialog.
	 * @param parent
	 * @param style
	 */
	public DeconPeaksDialog(Shell parent, int style) 
	{
		super(parent, style);
		setText("Enter or Edit Peaks for Deconvolution");
	}

	/**
	 * Open the dialog.
	 * @return the result
	 */
	public Object open() 
	{
		createContents();
		shell.open();
		shell.layout();
		Display display = getParent().getDisplay();
		while (!shell.isDisposed()) 
		{
			if (!display.readAndDispatch()) 
			{
				display.sleep();
			}
		}
		return result;
	}

	/**
	 * Create contents of the dialog.
	 */
	private void createContents() 
	{
		shell = new Shell(getParent(), getStyle());
		shell.setSize(838, 530);
		shell.setText("Enter or Edit Peaks for Deconvolution");
		
		Button buttonOK = new Button(shell, SWT.NONE);
		buttonOK.setBounds(666, 467, 75, 25);
		buttonOK.setBackground(shell.getDisplay().getSystemColor(SWT.COLOR_GREEN));
		buttonOK.setText("OK");
		
		Button buttonCancel = new Button(shell, SWT.NONE);
		buttonCancel.setBounds(747, 467, 75, 25);
		buttonCancel.setBackground(shell.getDisplay().getSystemColor(SWT.COLOR_RED));
		buttonCancel.setText("Cancel");
		
		scrolledComposite = new ScrolledComposite(shell, SWT.BORDER | SWT.V_SCROLL);
		scrolledComposite.setAlwaysShowScrollBars(true);
		scrolledComposite.setBounds(10, 10, 650, 495);
		
		Composite parent = createForm();
		scrolledComposite.setContent(parent);
		
		Button buttonApply = new Button(shell, SWT.NONE);		
		buttonApply.setBounds(666, 436, 75, 25);
		buttonApply.setText("Apply");

		buttonOK.addSelectionListener(new SelectionAdapter() // OK button
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{	
				for(int i = 0; i < SW_main.gp.n_decon_peaks; i++)
				{
					try
					{
						SW_main.gp.decon_peaks[i].freq =
	                        Double.parseDouble(textFrequency[i].getText()) * SW_main.q.SF;
					}
					catch (Exception ex)
					{
						Util.show_and_log("Error converting: " + textFrequency[i].getText() + " to Double", 
	                        ex.getMessage());
					}
					SW_main.gp.decon_peaks[i].freq_iterate = buttonIterateFrequency[i].getSelection();
					
					try
					{
						SW_main.gp.decon_peaks[i].intensity =
	                        Double.parseDouble(textAmplitude[i].getText());
					}
					catch (Exception ex)
					{
						Util.show_and_log("Error converting: " + textAmplitude[i].getText() + " to Double", 
	                        ex.getMessage());
					}
					SW_main.gp.decon_peaks[i].intensity_iterate = buttonIterateAmplitude[i].getSelection();
					
					try
					{
						SW_main.gp.decon_peaks[i].width =
	                        Double.parseDouble(textWidth[i].getText());
					}
					catch (Exception ex)
					{
						Util.show_and_log("Error converting: " + textWidth[i].getText() + " to Double", 
	                        ex.getMessage());
					}
					SW_main.gp.decon_peaks[i].width_iterate = buttonIterateWidth[i].getSelection();

					try
					{
						SW_main.gp.decon_peaks[i].gauss =
	                        Double.parseDouble(textGaussian[i].getText());
					}
					catch (Exception ex)
					{
						Util.show_and_log("Error converting: " + textGaussian[i].getText() + " to Double", 
	                        ex.getMessage());
					}
					SW_main.gp.decon_peaks[i].gauss_iterate = buttonIterateGaussian[i].getSelection();				
				}
				shell.dispose();
			}
		});

		buttonCancel.addSelectionListener(new SelectionAdapter() // Cancel button
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				shell.dispose();
			}
		});
		
		buttonApply.addSelectionListener(new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				SW_main.gp.n_decon_peaks = 0;
				
				for(int i = 0; i < SW_main.MAX_DECON_PEAKS; i++)
				{
					if(textFrequency[i].getText().length() > 0) 
						SW_main.gp.n_decon_peaks ++;
				}
				for(int i = 0; i < SW_main.gp.n_decon_peaks; i++)
				{
					try
					{
						SW_main.gp.decon_peaks[i].freq =
	                        Double.parseDouble(textFrequency[i].getText()) * SW_main.q.SF;
					}
					catch (Exception ex)
					{
						Util.show_and_log("Error converting: " + textFrequency[i].getText() + " to Double", 
	                        ex.getMessage());
					}
					SW_main.gp.decon_peaks[i].freq_iterate = buttonIterateFrequency[i].getSelection();
					
					try
					{
						SW_main.gp.decon_peaks[i].intensity =
	                        Double.parseDouble(textAmplitude[i].getText());
					}
					catch (Exception ex)
					{
						Util.show_and_log("Error converting: " + textAmplitude[i].getText() + " to Double", 
	                        ex.getMessage());
					}
					SW_main.gp.decon_peaks[i].intensity_iterate = buttonIterateAmplitude[i].getSelection();
					
					try
					{
						SW_main.gp.decon_peaks[i].width =
	                        Double.parseDouble(textWidth[i].getText());
					}
					catch (Exception ex)
					{
						Util.show_and_log("Error converting: " + textWidth[i].getText() + " to Double", 
	                        ex.getMessage());
					}
					SW_main.gp.decon_peaks[i].width_iterate = buttonIterateWidth[i].getSelection();

					try
					{
						SW_main.gp.decon_peaks[i].gauss =
	                        Double.parseDouble(textGaussian[i].getText());
					}
					catch (Exception ex)
					{
						Util.show_and_log("Error converting: " + textGaussian[i].getText() + " to Double", 
	                        ex.getMessage());
					}
					SW_main.gp.decon_peaks[i].gauss_iterate = buttonIterateGaussian[i].getSelection();
					
				}
				updateAll();
			}
		});
		
		shell.setDefaultButton(buttonApply);	
	}
	
//-------------------------------------------------------------------------------------------------	
	private Composite createForm()
	{
		Composite result = new Composite(scrolledComposite, SWT.NONE);
		result.setBounds(10, 10, 650, (SW_main.MAX_DECON_PEAKS + 1) * 25);

		Label labelFrequency = new Label(result, SWT.NONE);
		labelFrequency.setText("Shift (ppm)");
		labelFrequency.setBounds(50, 2, 80, 15);

		Label labelAmplitide = new Label(result, SWT.NONE);
		labelAmplitide.setText("Amplitude");
		labelAmplitide.setBounds(200, 2, 80, 15);

		Label labelWidth = new Label(result, SWT.NONE);
		labelWidth.setText("Width (Hz)");
		labelWidth.setBounds(350, 2, 80, 15);

		Label labelGaussian = new Label(result, SWT.NONE);
		labelGaussian.setText("% Gausssian");
		labelGaussian.setBounds(500, 2, 80, 15);

		for(int i = 0; i < SW_main.MAX_DECON_PEAKS; i++)
		{						
			labelPeakNumber[i] = new Label(result, SWT.NONE);
			labelPeakNumber[i].setBounds(10, 25 + i * 25, 30, 15);
			labelPeakNumber[i].setText(String.format("%d", i+1));

			textFrequency[i] = new Text(result, SWT.BORDER);
			textFrequency[i].setBounds(50, 25 + i * 25, 80, 21);				

			buttonIterateFrequency[i] = new Button(result, SWT.CHECK);
			buttonIterateFrequency[i].setBounds(140, 25 + i * 25, 30, 21);

			textAmplitude[i] = new Text(result, SWT.BORDER);
			textAmplitude[i].setBounds(200, 25 + i * 25, 80, 21);

			buttonIterateAmplitude[i] = new Button(result, SWT.CHECK);
			buttonIterateAmplitude[i].setBounds(290, 25 + i * 25, 30, 21);

			textWidth[i] = new Text(result, SWT.BORDER);
			textWidth[i].setBounds(350, 25 + i * 25, 80, 21);

			buttonIterateWidth[i] = new Button(result, SWT.CHECK);
			buttonIterateWidth[i].setBounds(440, 25 + i * 25, 30, 21);

			textGaussian[i] = new Text(result, SWT.BORDER);
			textGaussian[i].setBounds(500, 25 + i * 25, 80, 21);

			buttonIterateGaussian[i] = new Button(result, SWT.CHECK);
			buttonIterateGaussian[i].setBounds(590, 25 + i * 25, 30, 21);						
		}	

		for(int i = 0; i < SW_main.gp.n_decon_peaks; i++)
		{
			textFrequency[i].setText(String.format("%10.4f", SW_main.gp.decon_peaks[i].freq / 
					SW_main.q.SF));
			textAmplitude[i].setText(String.format("%.2f", SW_main.gp.decon_peaks[i].intensity));
			textWidth[i].setText(String.format("%10.4f", SW_main.gp.decon_peaks[i].width));			
			textGaussian[i].setText(String.format("%10.2f", SW_main.gp.decon_peaks[i].gauss));

			if(SW_main.gp.decon_peaks[i].freq_iterate) buttonIterateFrequency[i].setSelection(true);
			if(SW_main.gp.decon_peaks[i].intensity_iterate) buttonIterateAmplitude[i].setSelection(true);
			if(SW_main.gp.decon_peaks[i].width_iterate) buttonIterateWidth[i].setSelection(true);
			if(SW_main.gp.decon_peaks[i].gauss_iterate) buttonIterateGaussian[i].setSelection(true);
		}
		return result;
	}	// end createForm 

	private void updateAll()	// necessary??
	{
		DeconUtil.genspec(SW_main.gp, SW_main.q);

		for (int i = 0; i < SW_main.gp.n_peaks; i++)
		{
			SW_main.gp.peaks[i].freq = SW_main.gp.decon_peaks[i].freq;
		}

		SW_main.update_spect = true;
		SW_main.canvas.redraw();
	}
}
