/**
 * 
 */
package dialogs;

import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

import spinworks.ViewMenuListeners;

import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;

/**
 * @author Marat,
 * University of Manitoba
 */
public class ExnoRangeDialog extends Dialog 
{

	protected Object result;
	protected Shell shell;
	private Text textFirst;
	private Text textLast;

	/**
	 * Create the dialog.
	 * @param parent
	 * @param style
	 */
	public ExnoRangeDialog(Shell parent, int style) 
	{
		super(parent, style);
		setText("Experiment Number Range");
	}

	/**
	 * Open the dialog.
	 * @return the result
	 */
	public Object open() 
	{
		createContents();
		shell.open();
		shell.layout();
		Display display = getParent().getDisplay();
		while (!shell.isDisposed()) 
		{
			if (!display.readAndDispatch()) 
			{
				display.sleep();
			}
		}
		return result;
	}

	/**
	 * Create contents of the dialog.
	 */
	private void createContents() 
	{
		shell = new Shell(getParent(), getStyle());
		shell.setSize(264, 109);
		shell.setText(getText());
		
		Button buttonOK = new Button(shell, SWT.NONE);		
		buttonOK.setBounds(160, 45, 75, 25);
		buttonOK.setText("OK");
		buttonOK.addSelectionListener(new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				ViewMenuListeners.exno = Integer.parseInt(textFirst.getText());
				ViewMenuListeners.last_exno = Integer.parseInt(textLast.getText());
				shell.dispose();
			}
		});
		
		Label lblFirst = new Label(shell, SWT.NONE);
		lblFirst.setAlignment(SWT.RIGHT);
		lblFirst.setBounds(10, 22, 42, 15);
		lblFirst.setText("First:");
		
		Label lblNewLabel = new Label(shell, SWT.NONE);
		lblNewLabel.setAlignment(SWT.RIGHT);
		lblNewLabel.setBounds(132, 22, 42, 15);
		lblNewLabel.setText("Last:");
		
		textFirst = new Text(shell, SWT.BORDER);
		textFirst.setText(String.format("%d", ViewMenuListeners.exno));
		textFirst.setBounds(71, 16, 55, 21);
		
		textLast = new Text(shell, SWT.BORDER);
		textLast.setText(String.format("%d", ViewMenuListeners.last_exno));
		textLast.setBounds(180, 16, 55, 21);
		
		shell.setDefaultButton(buttonOK);
	}
}
