/**
 * 
 */
package dialogs;

import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Text;
import org.eclipse.wb.swt.SWTResourceManager;

import spinworks.SW_main;
import spinworks.SW_main.data_types;

import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Combo;

/**
 * @author marat
 *
 */
public class ParDirectAdvanced extends Dialog 
{

	protected Object result;
	protected Shell shell;
	private Text textPolyDegree;
	private Text textFilterWidth;
	private Text textThreshold;
	private Text textLambda;
	private Text textVirtualSpectFreq;
	private Text textPPmin;
	private Text textPPsens;

	/**
	 * Create the dialog.
	 * @param parent
	 * @param style
	 */
	public ParDirectAdvanced(Shell parent, int style) 
	{
		super(parent, style);
		setText("Advanced Processing Parameters (X)");
	}

	/**
	 * Open the dialog.
	 * @return the result
	 */
	public Object open() 
	{
		createContents();
		shell.open();
		shell.layout();
		Display display = getParent().getDisplay();
		while (!shell.isDisposed()) 
		{
			if (!display.readAndDispatch()) 
			{
				display.sleep();
			}
		}
		return result;
	}

	/**
	 * Create contents of the dialog.
	 */
	private void createContents() 
	{
		shell = new Shell(getParent(), getStyle());
		shell.setSize(339, 437);
		shell.setText("Advanced Processing Parameters (X)");
		
		Label lblVirtualSpectrometerFrequency = new Label(shell, SWT.NONE);
		lblVirtualSpectrometerFrequency.setAlignment(SWT.RIGHT);
		lblVirtualSpectrometerFrequency.setBounds(0, 70, 222, 15);
		lblVirtualSpectrometerFrequency.setText("Virtual Spectrometer Frequency (MHz):");
		
		Group groupBaseline = new Group(shell, SWT.NONE);
		groupBaseline.setText("Baseline");
		groupBaseline.setBounds(10, 105, 265, 153);
		
		Group groupPP = new Group(shell, SWT.NONE);
		groupPP.setText("Peak Picking");
		groupPP.setBounds(10, 276, 265, 88);
		
		Label lblBaselinePolyDegree = new Label(groupBaseline, SWT.NONE);
		lblBaselinePolyDegree.setAlignment(SWT.RIGHT);
		lblBaselinePolyDegree.setBounds(11, 30, 128, 15);
		lblBaselinePolyDegree.setText("Baseline Poly. Degree:");
		
		Label lblFilterWidth = new Label(groupBaseline, SWT.NONE);
		lblFilterWidth.setAlignment(SWT.RIGHT);
		lblFilterWidth.setBounds(49, 57, 90, 15);
		lblFilterWidth.setText("Filter Width:");
		
		Label lblTreshold = new Label(groupBaseline, SWT.NONE);
		lblTreshold.setAlignment(SWT.RIGHT);
		lblTreshold.setBounds(40, 84, 99, 15);
		lblTreshold.setText("Treshold:");
		
		Label lblLambda = new Label(groupBaseline, SWT.NONE);
		lblLambda.setAlignment(SWT.RIGHT);
		lblLambda.setBounds(63, 111, 76, 15);
		lblLambda.setText("Lambda:");
		
		Label lblPPmin = new Label(groupPP, SWT.NONE);
		lblPPmin.setAlignment(SWT.RIGHT);
		lblPPmin.setBounds(10, 25, 133, 15);
		lblPPmin.setText("Peak Pick Minimum:");
		
		Label lblPPsens = new Label(groupPP, SWT.NONE);
		lblPPsens.setAlignment(SWT.RIGHT);
		lblPPsens.setBounds(10, 54, 133, 15);
		lblPPsens.setText("Peak Pick Sensitivity:");
		
		textPolyDegree = new Text(groupBaseline, SWT.BORDER);
		textPolyDegree.setBounds(160, 27, 90, 21);
		textPolyDegree.setText(String.format("%d", SW_main.gp.abs_degree));
		
		textFilterWidth = new Text(groupBaseline, SWT.BORDER);
		textFilterWidth.setBounds(160, 54, 90, 21);
		textFilterWidth.setText(String.format("%d", SW_main.p.baseline_filter));
		
		textThreshold = new Text(groupBaseline, SWT.BORDER);
		textThreshold.setBounds(160, 81, 90, 21);
		textThreshold.setText(String.format("%.3f", SW_main.p.baseline_thresh));
		
		textLambda = new Text(groupBaseline, SWT.BORDER);
		textLambda.setBounds(160, 108, 90, 21);
		textLambda.setText(String.format("%.0f", SW_main.p.baseline_lambda));
		
		textVirtualSpectFreq = new Text(shell, SWT.BORDER);
		textVirtualSpectFreq.setBounds(233, 67, 90, 21);
		textVirtualSpectFreq.setText(String.format("%.6f", SW_main.q.SFO1));
		
		textPPmin = new Text(groupPP, SWT.BORDER);
		textPPmin.setBounds(160, 22, 90, 21);
		textPPmin.setText(String.format("%.4f", SW_main.gp.pp_thresh));
		
		textPPsens = new Text(groupPP, SWT.BORDER);
		textPPsens.setBounds(160, 51, 90, 21);
		textPPsens.setText(String.format("%.3f", SW_main.gp.pp_sens));
		
		Font currentFont;
		Button buttonOK = new Button(shell, SWT.NONE);	
		buttonOK.setBounds(157, 373, 80, 25);
		buttonOK.setText("OK");
		currentFont = buttonOK.getFont();
		buttonOK.setFont(SWTResourceManager.getBoldFont(currentFont));
		buttonOK.setBackground(SWTResourceManager.getColor(SWT.COLOR_GREEN));
		shell.setDefaultButton(buttonOK);	// Default is OK button	
		
		Button buttonCancel = new Button(shell, SWT.NONE);
		
		buttonCancel.setBounds(243, 373, 80, 25);
		currentFont = buttonCancel.getFont();
		buttonCancel.setFont(SWTResourceManager.getBoldFont(currentFont));
		buttonCancel.setBackground(SWTResourceManager.getColor(SWT.COLOR_RED));
		buttonCancel.setText("Cancel");
		
		Label lblAcquisitionSequenced = new Label(shell, SWT.NONE);
		lblAcquisitionSequenced.setAlignment(SWT.RIGHT);
		lblAcquisitionSequenced.setBounds(48, 36, 174, 15);
		lblAcquisitionSequenced.setText("Acquisition Sequence (3D):");
		
		final Combo comboSeq3D = new Combo(shell, SWT.NONE);	// TODO check
		comboSeq3D.setItems(new String[] {"321", "312"});
		comboSeq3D.setBounds(232, 28, 91, 23);
											
		 if (SW_main.q.data_type == data_types.BRUKER)
             comboSeq3D.select(SW_main.q.AQORDER);
         else if (SW_main.q.data_type == data_types.VNMR)
        	 comboSeq3D.select(SW_main.q.varian_array - 1);
	
//-------------------------------------------------------------------------------------------------
//	Listeners
		buttonOK.addSelectionListener(new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				SW_main.q.SFO1 = Double.parseDouble(textVirtualSpectFreq.getText());
				SW_main.p.baseline_filter = Integer.parseInt(textFilterWidth.getText());
				SW_main.p.baseline_lambda = Double.parseDouble(textLambda.getText());
				SW_main.p.baseline_thresh = Double.parseDouble(textThreshold.getText());
				SW_main.gp.abs_degree = Integer.parseInt(textPolyDegree.getText());
				SW_main.gp.pp_thresh = Double.parseDouble(textPPmin.getText());
				SW_main.gp.pp_sens = Double.parseDouble(textPPsens.getText());
				
				if (SW_main.q.data_type == data_types.BRUKER)	// TODO check
		             SW_main.q.AQORDER = comboSeq3D.getSelectionIndex();
		        else if (SW_main.q.data_type == data_types.VNMR)
		        	SW_main.q.varian_array = comboSeq3D.getSelectionIndex() + 1;
				
				shell.dispose();
			}
		});
		
		buttonCancel.addSelectionListener(new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				shell.dispose();
			}
		});
		
	}	// end createContents()
}
