package dialogs;

import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Text;

import spinworks.SW_main;
import spinworks.Util;
import spinworks.SW_main.modes;
import spinworks.SW_main.osTypes;

import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Font;
import org.eclipse.wb.swt.SWTResourceManager; 

public class ParEditor extends Dialog 
{
	protected Object result;
	protected Shell shell;
	private Text textSF;
	private Text textFPC;
	private Text textSF_F1;
	private Text textFPC_F1;
	private Text textSF_F2;
	private Text textFPC_F2;
	private Text textLB;
	private Text textLB_F1;
	private Text textLB_F2;
	private Text textGF;
	private Text textSSB;
	private Text textGF_F1;
	private Text textSSB_F1;
	private Text textGF_F2;
	private Text textSSB_F2;
	private Text textZeroOrder;
	private Text textZeroOrder_F2;
	private Text textZeroOrder_F1;
	private Text textFirstOrder;
	private Text textFirstOrder_F1;
	private Text textFirstOrder_F2;
	private Text textSolvFilter;
	private Text textLPcoef;
	private Text textLPinput;
	private Text textLPpred;
	private Text textLPcutoff;
	private Text textLPcoef_F1;
	private Text textLPinput_F1;
	private Text textLPpred_F1;
	private Text textLPcutoff_F1;
	private Text textLPcoef_F2;
	private Text textLPinput_F2;
	private Text textLPpred_F2;
	private Text textLPcutoff_F2;
	private Text textLeftShiftPoints;
	private Text textGroupDelay;
	private Label lblGroupDelay;	// so it can be switched on with det mode change

/**
 * Create the dialog.
 * @param parent
 * @param style
 */
	public ParEditor(Shell parent, int style) 
	{
		super(parent, style);
		setText("Edit Processing Parameters");
	}

/**
 * Open the dialog.
 * @return the result
 */
	public Object open() 
	{
		createContents();
		shell.open();
		shell.layout();
		Display display = getParent().getDisplay();
		while (!shell.isDisposed()) 
		{
			if (!display.readAndDispatch()) 
			{
				display.sleep();
			}
		}
		return result;
	}

/**
 * Create contents of the dialog.
 */
	private void createContents() 
	{
		shell = new Shell(getParent(), SWT.DIALOG_TRIM);
		shell.setSize(807, 740);
		shell.setText("Edit Processing Parameters");
		
		Font currentFont;
		
	// Acquisition dimension
		Group grpAcquisition = new Group(shell, SWT.BORDER);
		grpAcquisition.setBackground(SWTResourceManager.getColor(176, 196, 222));
		currentFont = grpAcquisition.getFont();
		grpAcquisition.setFont(SWTResourceManager.getBoldFont(currentFont));
		grpAcquisition.setBounds(160, 0, 200, 661);
		
		if(SW_main.q.data_mode == modes.MODE_1D)
			grpAcquisition.setText("Acquisition");
		else if(SW_main.q.data_mode == modes.MODE_2D)
				grpAcquisition.setText("Acquisition F2 (X)");
		else if(SW_main.q.data_mode == modes.MODE_3D)
			grpAcquisition.setText("Acquisition F3 (X)");
		
		final Combo comboSI = new Combo(grpAcquisition, SWT.NONE);
		comboSI.setItems(new String[] {"64", "128", "256", "512", "1024", "2048", 
				"4096", "8192", "16k", "32k", "64k", "128k", "256k", "512k"});
		
		if (SW_main.p.SI <= 64) comboSI.select(0);                        // acq "X" transform size
		else if (SW_main.p.SI == 128) comboSI.select(1);
		else if (SW_main.p.SI == 256) comboSI.select(2);
		else if (SW_main.p.SI == 512) comboSI.select(3);
		else if (SW_main.p.SI == 1024) comboSI.select(4);
		else if (SW_main.p.SI == 2048) comboSI.select(5);
		else if (SW_main.p.SI == 4096) comboSI.select(6);
		else if (SW_main.p.SI == 8192) comboSI.select(7);
		else if (SW_main.p.SI == 16384) comboSI.select(8);
		else if (SW_main.p.SI == 32768) comboSI.select(9);
		else if (SW_main.p.SI == 65536) comboSI.select(10);
		else if (SW_main.p.SI == 131072) comboSI.select(11);
		else if (SW_main.p.SI == 262144) comboSI.select(12);
		else if (SW_main.p.SI >= 524288) comboSI.select(13);
		else
		{
			Util.show_and_log(String.format("Invalid X (direct) size value of %d", SW_main.p.SI));
			comboSI.select(-1);
		}		
		comboSI.setBounds(10, 29, 100, 23);
		
		final Combo comboDetMode = new Combo(grpAcquisition, SWT.NONE);
		comboDetMode.setItems(new String[] {"Simultaneous", "Sequential", "DSP", "Custom DSP (JEOL, etc.)"}); 
		comboDetMode.select(SW_main.q.aq_mode.ordinal());
		comboDetMode.setBounds(10, 112, 150, 23);		
		
		textGroupDelay = new Text(grpAcquisition, SWT.BORDER);
		textGroupDelay.setText(String.format("%6.2f", SW_main.q.GRPDLY));
		textGroupDelay.setBounds(10, 141, 76, 21);
		if(SW_main.q.aq_mode != SW_main.det_modes.CUSTOM_DSP)
			textGroupDelay.setVisible(false);
		
		textSF = new Text(grpAcquisition, SWT.BORDER);
		textSF.setText(String.format("%11.7f", SW_main.q.SF));
		textSF.setBounds(10, 58, 76, 21);
		
		textFPC = new Text(grpAcquisition, SWT.BORDER);
		textFPC.setText(String.format("%8.4f", SW_main.p.fcor));
		textFPC.setBounds(10, 85, 76, 21);
		
		final Combo comboWindow = new Combo(grpAcquisition, SWT.NONE);
		comboWindow.setItems(new String[]{"No Window", "Lorentz (Exponential)", "Lorentz to Gauss (GM)", 
				                           "Sine", "Sine Squared", "TRAF", "TRAFS", "Gaussian"});
		comboWindow.select(SW_main.p.WDW.ordinal());
		comboWindow.setBounds(10, 252, 150, 23);
		
		textLB = new Text(grpAcquisition, SWT.BORDER);
		textLB.setText(String.format("%9.2f", SW_main.p.LB));
		textLB.setBounds(10, 281, 76, 21);
		
		textGF = new Text(grpAcquisition, SWT.BORDER);
		textGF.setText(String.format("%7.3f", SW_main.p.GB));
		textGF.setBounds(10, 308, 76, 21);
		
		textSSB = new Text(grpAcquisition, SWT.BORDER);
		textSSB.setText(String.format("%7.2f", SW_main.p.ssb));
		textSSB.setBounds(10, 335, 76, 21);
		
		final Combo comboPhasing = new Combo(grpAcquisition, SWT.NONE);
		comboPhasing.setItems(new String[]{"No phasing", "Constants", "Magnitude", "Power", "Auto"});
		comboPhasing.select(SW_main.p.PH_mod.ordinal());
		comboPhasing.setBounds(10, 362, 150, 23);
		
		textZeroOrder = new Text(grpAcquisition, SWT.BORDER);
		textZeroOrder.setText(String.format("%7.2f", SW_main.p.PHC0));
		textZeroOrder.setBounds(10, 391, 76, 21);
		
		textFirstOrder = new Text(grpAcquisition, SWT.BORDER);
		textFirstOrder.setText(String.format("%7.2f", SW_main.p.PHC1));
		textFirstOrder.setBounds(10, 418, 76, 21);
		
		final Combo comboSolvFilter = new Combo(grpAcquisition, SWT.NONE);
		comboSolvFilter.setItems(new String[] {"None", "Sine", "Gaussian", "Triangle"});
		comboSolvFilter.select(SW_main.p.filter_type.ordinal());
		comboSolvFilter.setBounds(10, 445, 150, 23);
		
		textSolvFilter = new Text(grpAcquisition, SWT.BORDER);
		textSolvFilter.setText(String.format("%d", SW_main.p.filter_points));
		textSolvFilter.setBounds(10, 474, 76, 21);
		
		final Combo comboLP = new Combo(grpAcquisition, SWT.NONE);
		comboLP.setItems(new String[] {"LP Off", "Forward Complex", "Forward Real", "Back Complex",
				"Back Real", "Zhu-Bax"});
		comboLP.select(SW_main.p.lp.ordinal());
		comboLP.setBounds(10, 501, 150, 23);
		
		textLPcoef = new Text(grpAcquisition, SWT.BORDER);
		textLPcoef.setText(String.format("%d", SW_main.p.lp_coef));
		textLPcoef.setBounds(10, 530, 76, 21);
		
		textLPinput = new Text(grpAcquisition, SWT.BORDER);
		textLPinput.setText(String.format("%d", SW_main.p.lp_input));
		textLPinput.setBounds(92, 530, 76, 21);
		
		textLPpred = new Text(grpAcquisition, SWT.BORDER);
		textLPpred.setText(String.format("%d", SW_main.p.lp_pred));
		textLPpred.setBounds(10, 557, 76, 21);
		
		textLPcutoff = new Text(grpAcquisition, SWT.BORDER);
		textLPcutoff.setText(String.format("%7.3f", SW_main.p.lp_cutoff));
		textLPcutoff.setBounds(92, 557, 76, 21);
		
		textLeftShiftPoints = new Text(grpAcquisition, SWT.BORDER);
		textLeftShiftPoints.setText(String.format("%d", SW_main.p.left_shift));
		textLeftShiftPoints.setBounds(10, 584, 76, 21);				
				
		final Button checkFID_Bias = new Button(grpAcquisition, SWT.CHECK);
		if(SW_main.p.fid_bias)
			checkFID_Bias.setSelection(true);
		checkFID_Bias.setBounds(10, 170, 20, 16);
		
		final Button checkReverse = new Button(grpAcquisition, SWT.CHECK);
		if(SW_main.p.REVERSE)
			checkReverse.setSelection(true);
		checkReverse.setBounds(10, 195, 20, 16);
		
		Button buttonAdvanced = new Button(grpAcquisition, SWT.NONE);	// Advanced button
		buttonAdvanced.setBounds(10, 611, 100, 25);
		buttonAdvanced.setText("Advanced");		
		
	// Indirect F1 (Y in 2D  or Z in 3D)
		Group grpIndirect = new Group(shell, SWT.BORDER);
		grpIndirect.setForeground(SWTResourceManager.getColor(SWT.COLOR_BLACK));
		grpIndirect.setBackground(SWTResourceManager.getColor(176, 196, 222));
		currentFont = grpIndirect.getFont();
		grpIndirect.setFont(SWTResourceManager.getBoldFont(currentFont));
		if(SW_main.q.data_mode == modes.MODE_2D)
			grpIndirect.setText("Indirect F1 (Y)");
		else if(SW_main.q.data_mode == modes.MODE_3D)
			grpIndirect.setText("Indirect F1 (Z)");
		grpIndirect.setBounds(370, 0, 200, 661);
		
		final Combo comboSI_F1 = new Combo(grpIndirect, SWT.NONE);
		comboSI_F1.setItems(new String[] {"64", "128", "256", "512", "1024", "2048", "4096", 
				"8192", "16k", "32k", "64k", "128k", "256k", "512k"});
		if (SW_main.p_f1.SI <= 64) comboSI_F1.select(0);                        // indirect "Y in 2D, Z" in 3D transform size
		else if (SW_main.p_f1.SI == 128) comboSI_F1.select(1);
		else if (SW_main.p_f1.SI == 256) comboSI_F1.select(2);
		else if (SW_main.p_f1.SI == 512) comboSI_F1.select(3);
		else if (SW_main.p_f1.SI == 1024) comboSI_F1.select(4);
		else if (SW_main.p_f1.SI == 2048) comboSI_F1.select(5);
		else if (SW_main.p_f1.SI == 4096) comboSI_F1.select(6);
		else if (SW_main.p_f1.SI == 8192) comboSI_F1.select(7);
		else if (SW_main.p_f1.SI == 16384) comboSI_F1.select(8);
		else if (SW_main.p_f1.SI == 32768) comboSI_F1.select(9);
		else if (SW_main.p_f1.SI == 65536) comboSI_F1.select(10);
		else if (SW_main.p_f1.SI == 131072) comboSI_F1.select(11);
		else if (SW_main.p_f1.SI == 262144) comboSI_F1.select(12);
		else if (SW_main.p_f1.SI >= 524288) comboSI_F1.select(13);
		else
		{
			Util.show_and_log(String.format("Invalid indirect (F1) size value of %d", SW_main.p_f1.SI));
			comboSI.select(-1);
		}		
		comboSI_F1.setBounds(10, 29, 100, 23);
		
		final Combo comboDetMode_F1 = new Combo(grpIndirect, SWT.NONE);
		comboDetMode_F1.setItems(new String[]{"Single (QF)", "Sequential", "TPPI", "States", 
				"States-TPPI", "Echo-Antiecho"});
		comboDetMode_F1.select(SW_main.p_f1.MC2.ordinal());
		comboDetMode_F1.setBounds(10, 112, 150, 23);
		
		textSF_F1 = new Text(grpIndirect, SWT.BORDER);
		textSF_F1.setText(String.format("%11.7f", SW_main.q_f1.SF));
		textSF_F1.setBounds(10, 58, 76, 21);
		
		textFPC_F1 = new Text(grpIndirect, SWT.BORDER);
		textFPC_F1.setText(String.format("%8.4f", SW_main.p_f1.fcor));
		textFPC_F1.setBounds(10, 85, 76, 21);
		
		final Combo comboWindow_F1 = new Combo(grpIndirect, SWT.NONE);
		comboWindow_F1.setItems(new String[]{"No Window", "Lorentz (Exponential)", "Lorentz to Gauss (GM)", 
                "Sine", "Sine Squared", "TRAF", "TRAFS", "Gaussian"});
		comboWindow_F1.select(SW_main.p_f1.WDW.ordinal());
		comboWindow_F1.setBounds(10, 254, 150, 23);
		
		textLB_F1 = new Text(grpIndirect, SWT.BORDER);
		textLB_F1.setText(String.format("%9.2f", SW_main.p_f1.LB));
		textLB_F1.setBounds(10, 283, 76, 21);
		
		textGF_F1 = new Text(grpIndirect, SWT.BORDER);
		textGF_F1.setText(String.format("%7.3f", SW_main.p_f1.GB));
		textGF_F1.setBounds(10, 310, 76, 21);
		
		textSSB_F1 = new Text(grpIndirect, SWT.BORDER);
		textSSB_F1.setText(String.format("%7.2f", SW_main.p_f1.ssb));
		textSSB_F1.setBounds(10, 337, 76, 21);
		
		final Combo comboPhasing_F1 = new Combo(grpIndirect, SWT.NONE);
		comboPhasing_F1.setItems(new String[]{"No phasing", "Constants", "Magnitude", "Power", "Auto"});
		comboPhasing_F1.select(SW_main.p_f1.PH_mod.ordinal());
		comboPhasing_F1.setBounds(10, 364, 150, 23);
		
		textZeroOrder_F1 = new Text(grpIndirect, SWT.BORDER);
		textZeroOrder_F1.setText(String.format("%7.2f", SW_main.p_f1.PHC0));
		textZeroOrder_F1.setBounds(10, 393, 76, 21);
		
		textFirstOrder_F1 = new Text(grpIndirect, SWT.BORDER);
		textFirstOrder_F1.setText(String.format("%7.2f", SW_main.p_f1.PHC1));
		textFirstOrder_F1.setBounds(10, 420, 76, 21);
		
		final Combo comboLP_F1 = new Combo(grpIndirect, SWT.NONE);
		comboLP_F1.setItems(new String[] {"LP Off", "Forward Complex", "Forward Real", "Back Complex",
				"Back Real", "Zhu-Bax"});
		comboLP_F1.select(SW_main.p_f1.lp.ordinal());
		comboLP_F1.setBounds(10, 501, 150, 23);
		
		textLPcoef_F1 = new Text(grpIndirect, SWT.BORDER);
		textLPcoef_F1.setText(String.format("%d", SW_main.p_f1.lp_coef));
		textLPcoef_F1.setBounds(10, 530, 76, 21);
		
		textLPinput_F1 = new Text(grpIndirect, SWT.BORDER);
		textLPinput_F1.setText(String.format("%d", SW_main.p_f1.lp_input));
		textLPinput_F1.setBounds(92, 530, 76, 21);
		
		textLPpred_F1 = new Text(grpIndirect, SWT.BORDER);
		textLPpred_F1.setText(String.format("%d", SW_main.p_f1.lp_pred));
		textLPpred_F1.setBounds(10, 557, 76, 21);
		
		textLPcutoff_F1 = new Text(grpIndirect, SWT.BORDER);
		textLPcutoff_F1.setText(String.format("%7.3f", SW_main.p_f1.lp_cutoff));
		textLPcutoff_F1.setBounds(92, 557, 76, 21);
			
		final Button checkFID_Bias_F1 = new Button(grpIndirect, SWT.CHECK);
		if(SW_main.p_f1.fid_bias)
			checkFID_Bias_F1.setSelection(true);
		checkFID_Bias_F1.setBounds(10, 170, 20, 16);
		
		final Button checkReverse_F1 = new Button(grpIndirect, SWT.CHECK);
		if(SW_main.p_f1.REVERSE)
			checkReverse_F1.setSelection(true);
		checkReverse_F1.setBounds(10, 195, 20, 16);
		
		Button buttonAdvanced_F1 = new Button(grpIndirect, SWT.NONE);
		buttonAdvanced_F1.setBounds(10, 612, 100, 25);
		buttonAdvanced_F1.setText("Advanced");	
				
	// Indirect F2 (Y in 3D)
		Group grpIndirectF2 = new Group(shell, SWT.BORDER);
		grpIndirectF2.setBackground(SWTResourceManager.getColor(176, 196, 222));
		currentFont = grpIndirectF2.getFont();
		grpIndirectF2.setFont(SWTResourceManager.getBoldFont(currentFont));
		if(SW_main.q.data_mode == modes.MODE_3D)
			grpIndirectF2.setText("Indirect F2 (Y)");
		else
			grpIndirectF2.setText("unused");
		
		grpIndirectF2.setBounds(580, 0, 200, 661);
		
		final Combo comboSI_F2 = new Combo(grpIndirectF2, SWT.NONE);	
		comboSI_F2.setItems(new String[] {"64", "128", "256", "512", "1024", "2048", "4096", 
				"8192", "16k", "32k", "64k", "128k", "256k", "512k"});	
		if (SW_main.p_f2.SI <= 64) comboSI_F2.select(0);                        // indirect "Y in 3D" transform size
		else if (SW_main.p_f2.SI == 128) comboSI_F2.select(1);
		else if (SW_main.p_f2.SI == 256) comboSI_F2.select(2);
		else if (SW_main.p_f2.SI == 512) comboSI_F2.select(3);
		else if (SW_main.p_f2.SI == 1024) comboSI_F2.select(4);
		else if (SW_main.p_f2.SI == 2048) comboSI_F2.select(5);
		else if (SW_main.p_f2.SI == 4096) comboSI_F2.select(6);
		else if (SW_main.p_f2.SI == 8192) comboSI_F2.select(7);
		else if (SW_main.p_f2.SI == 16384) comboSI_F2.select(8);
		else if (SW_main.p_f2.SI == 32768) comboSI_F2.select(9);
		else if (SW_main.p_f2.SI == 65536) comboSI_F2.select(10);
		else if (SW_main.p_f2.SI == 131072) comboSI_F2.select(11);
		else if (SW_main.p_f2.SI == 262144) comboSI_F2.select(12);
		else if (SW_main.p_f2.SI >= 524288) comboSI_F2.select(13);
		else
		{
			Util.show_and_log(String.format("Invalid indirect (F2) size value of %d", SW_main.p_f2.SI));
			comboSI.select(-1);
		}		
		comboSI_F2.setBounds(10, 29, 100, 23);
		
		textSF_F2 = new Text(grpIndirectF2, SWT.BORDER);
		textSF_F2.setText(String.format("%11.7f", SW_main.q_f2.SF));
		textSF_F2.setBounds(10, 58, 76, 21);
		
		textFPC_F2 = new Text(grpIndirectF2, SWT.BORDER);
		textFPC_F2.setText(String.format("%8.4f", SW_main.p_f2.fcor));
		textFPC_F2.setBounds(10, 85, 76, 21);
		
		final Combo comboDetMode_F2 = new Combo(grpIndirectF2, SWT.NONE);
		comboDetMode_F2.setItems(new String[]{"Single (QF)", "Sequential", "TPPI", "States", 
				"States-TPPI", "Echo-Antiecho"});
		comboDetMode_F2.select(SW_main.p_f2.MC2.ordinal());
		comboDetMode_F2.setBounds(10, 112, 150, 23);
		
		final Combo comboWindow_F2 = new Combo(grpIndirectF2, SWT.NONE);
		comboWindow_F2.setItems(new String[]{"No Window", "Lorentz (Exponential)", "Lorentz to Gauss (GM)", 
                "Sine", "Sine Squared", "TRAF", "TRAFS", "Gaussian"});
		comboWindow_F2.select(SW_main.p_f2.WDW.ordinal());
		comboWindow_F2.setBounds(10, 256, 150, 23);
		
		textLB_F2 = new Text(grpIndirectF2, SWT.BORDER);
		textLB_F2.setText(String.format("%9.2f", SW_main.p_f2.LB));
		textLB_F2.setBounds(10, 285, 76, 21);
		
		textGF_F2 = new Text(grpIndirectF2, SWT.BORDER);
		textGF_F2.setText(String.format("%7.3f", SW_main.p_f2.GB));
		textGF_F2.setBounds(10, 312, 76, 21);
		
		textSSB_F2 = new Text(grpIndirectF2, SWT.BORDER);
		textSSB_F2.setText(String.format("%7.2f", SW_main.p_f2.ssb));
		textSSB_F2.setBounds(10, 339, 76, 21);
		
		final Combo comboPhasing_F2 = new Combo(grpIndirectF2, SWT.NONE);
		comboPhasing_F2.setItems(new String[]{"No phasing", "Constants", "Magnitude", "Power", "Auto"});
		comboPhasing_F2.select(SW_main.p_f2.PH_mod.ordinal());
		comboPhasing_F2.setBounds(10, 366, 150, 23);
		
		textZeroOrder_F2 = new Text(grpIndirectF2, SWT.BORDER);
		textZeroOrder_F2.setText(String.format("%7.2f", SW_main.p_f2.PHC0));
		textZeroOrder_F2.setBounds(10, 395, 76, 21);
		
		textFirstOrder_F2 = new Text(grpIndirectF2, SWT.BORDER);
		textFirstOrder_F2.setText(String.format("%7.2f", SW_main.p_f2.PHC1));
		textFirstOrder_F2.setBounds(10, 422, 76, 21);
		
		final Combo comboLP_F2 = new Combo(grpIndirectF2, SWT.NONE);
		comboLP_F2.setItems(new String[] {"LP Off", "Forward Complex", "Forward Real", "Back Complex",
				"Back Real", "Zhu-Bax"});
		comboLP_F2.select(SW_main.p_f2.lp.ordinal());
		comboLP_F2.setBounds(10, 503, 150, 23);
		
		textLPcoef_F2 = new Text(grpIndirectF2, SWT.BORDER);
		textLPcoef_F2.setText(String.format("%d", SW_main.p_f2.lp_coef));
		textLPcoef_F2.setBounds(10, 532, 76, 21);
		
		textLPinput_F2 = new Text(grpIndirectF2, SWT.BORDER);
		textLPinput_F2.setText(String.format("%d", SW_main.p_f2.lp_input));
		textLPinput_F2.setBounds(92, 532, 76, 21);
		
		textLPpred_F2 = new Text(grpIndirectF2, SWT.BORDER);
		textLPpred_F2.setText(String.format("%d", SW_main.p_f2.lp_pred));
		textLPpred_F2.setBounds(10, 559, 76, 21);
		
		textLPcutoff_F2 = new Text(grpIndirectF2, SWT.BORDER);
		textLPcutoff_F2.setText(String.format("%7.3f", SW_main.p_f2.lp_cutoff));
		textLPcutoff_F2.setBounds(92, 559, 76, 21);
				
		final Button checkFID_Bias_F2 = new Button(grpIndirectF2, SWT.CHECK);
		if(SW_main.p_f2.fid_bias)
			checkFID_Bias_F2.setSelection(true);
		checkFID_Bias_F2.setBounds(10, 170, 20, 16);
		
		final Button checkReverse_F2 = new Button(grpIndirectF2, SWT.CHECK);
		if(SW_main.p_f2.REVERSE)
			checkReverse_F2.setSelection(true);
		checkReverse_F2.setBounds(10, 195, 20, 16);
		
		Button buttonAdvanced_F2 = new Button(grpIndirectF2, SWT.NONE);
		buttonAdvanced_F2.setBounds(10, 610, 100, 25);
		buttonAdvanced_F2.setText("Advanced");
							
	// Labels
		int lblOffset = 0;
		if(SW_main.currentOS == osTypes.MACOS)
			lblOffset = 10;
		else if(SW_main.currentOS == osTypes.LINUX)
			lblOffset = 10;
			
		Label lblSize = new Label(shell, SWT.NONE);
		lblSize.setAlignment(SWT.RIGHT);
		lblSize.setBounds(89, 37 + lblOffset, 55, 15);
		lblSize.setText("Size:");
		
		Label lblFreqOf = new Label(shell, SWT.NONE);
		lblFreqOf.setAlignment(SWT.RIGHT);
		lblFreqOf.setBounds(0, 64 + lblOffset, 144, 15);
		lblFreqOf.setText("Freq. of 0 ppm (MHz):");
		
		Label lblFirstPointCorrection = new Label(shell, SWT.NONE);
		lblFirstPointCorrection.setAlignment(SWT.RIGHT);
		lblFirstPointCorrection.setBounds(0, 91 + lblOffset, 144, 15);
		lblFirstPointCorrection.setText("First Point Correction:");
		
		Label lblDetectionMode = new Label(shell, SWT.RIGHT);
		lblDetectionMode.setBounds(30, 120 + lblOffset, 114, 15);
		lblDetectionMode.setText("Detection Mode:");
		
		Label lblWindowFunction = new Label(shell, SWT.NONE);
		currentFont = lblWindowFunction.getFont();
		lblWindowFunction.setFont(SWTResourceManager.getBoldFont(currentFont));
		lblWindowFunction.setAlignment(SWT.RIGHT);
		lblWindowFunction.setBounds(10, 261 + lblOffset, 134, 16);
		lblWindowFunction.setText("Window Function:");
		
		Label lblLb = new Label(shell, SWT.NONE);
		lblLb.setAlignment(SWT.RIGHT);
		lblLb.setBounds(89, 288 + lblOffset, 55, 15);
		lblLb.setText("LB:");
		
		Label lblGf = new Label(shell, SWT.NONE);
		lblGf.setAlignment(SWT.RIGHT);
		lblGf.setBounds(89, 315 + lblOffset, 55, 15);
		lblGf.setText("GF:");
		
		Label lblSineShiftdeg = new Label(shell, SWT.NONE);
		lblSineShiftdeg.setAlignment(SWT.RIGHT);
		lblSineShiftdeg.setBounds(30, 342 + lblOffset, 114, 15);
		lblSineShiftdeg.setText("Sine Shift (deg.):");
		
		Label lblPhasing = new Label(shell, SWT.NONE);
		currentFont = lblPhasing.getFont();
		lblPhasing.setFont(SWTResourceManager.getBoldFont(currentFont));
		lblPhasing.setAlignment(SWT.RIGHT);
		lblPhasing.setBounds(69, 371 + lblOffset, 75, 16);
		lblPhasing.setText("Phasing:");
		
		Label lblZeroOrder = new Label(shell, SWT.NONE);
		lblZeroOrder.setAlignment(SWT.RIGHT);
		lblZeroOrder.setBounds(10, 398 + lblOffset, 134, 15);
		lblZeroOrder.setText("Zero Order:");
		
		Label lblFirstOrder = new Label(shell, SWT.NONE);
		lblFirstOrder.setAlignment(SWT.RIGHT);
		lblFirstOrder.setBounds(10, 425 + lblOffset, 134, 15);
		lblFirstOrder.setText("First Order:");
		
		Label lblSolventFilter = new Label(shell, SWT.NONE);
		currentFont = lblSolventFilter.getFont();
		lblSolventFilter.setFont(SWTResourceManager.getBoldFont(currentFont));
		lblSolventFilter.setAlignment(SWT.RIGHT);
		lblSolventFilter.setBounds(34, 454 + lblOffset, 110, 16);
		lblSolventFilter.setText("Solvent Filter:");
		
		Label lblSolventFilterPoints = new Label(shell, SWT.NONE);
		lblSolventFilterPoints.setForeground(SWTResourceManager.getColor(SWT.COLOR_BLACK));
		lblSolventFilterPoints.setAlignment(SWT.RIGHT);
		lblSolventFilterPoints.setBounds(10, 481 + lblOffset, 134, 15);
		lblSolventFilterPoints.setText("Solvent Filter Points:");
		
		Label lblLinearPrediction = new Label(shell, SWT.NONE);
		currentFont = lblLinearPrediction.getFont();
		lblLinearPrediction.setFont(SWTResourceManager.getBoldFont(currentFont));
		lblLinearPrediction.setAlignment(SWT.RIGHT);
		lblLinearPrediction.setBounds(30, 509 + lblOffset, 114, 16);
		lblLinearPrediction.setText("Linear Prediction:");
		
		Label lblCoefInput = new Label(shell, SWT.NONE);
		lblCoefInput.setAlignment(SWT.RIGHT);
		lblCoefInput.setBounds(50, 536 + lblOffset, 94, 15);
		lblCoefInput.setText("Coef.  / Input:");
		
		Label lblPredCutoff = new Label(shell, SWT.NONE);
		lblPredCutoff.setAlignment(SWT.RIGHT);
		lblPredCutoff.setBounds(50, 563 + lblOffset, 94, 15);
		lblPredCutoff.setText("Pred. / Cutoff:");
		
		Label lblNewLabel = new Label(shell, SWT.NONE);
		lblNewLabel.setAlignment(SWT.RIGHT);
		lblNewLabel.setBounds(30, 590 + lblOffset, 114, 15);
		lblNewLabel.setText("Left Shift Points:");
		
	// update column headers depending on mode.
		if(SW_main.q.data_mode == SW_main.modes.MODE_1D)
		{
			grpIndirectF2.setText("unused");
			grpIndirect.setText("unused");
		}
				
	//OK and Cancel buttons
		Button buttonCancel = new Button(shell, SWT.NONE);	// Cancel
		if(SW_main.currentOS != SW_main.osTypes.MACOS)
		{
			currentFont = buttonCancel.getFont();
			buttonCancel.setFont(SWTResourceManager.getBoldFont(currentFont));
			buttonCancel.setBackground(SWTResourceManager.getColor(SWT.COLOR_RED));
		}
		buttonCancel.setBounds(704, 674, 80, 27);
		buttonCancel.setText("CANCEL");	
		
		Button buttonOK = new Button(shell, SWT.NONE);		// OK
		if(SW_main.currentOS != SW_main.osTypes.MACOS)
		{
			currentFont = buttonOK.getFont();
			buttonOK.setFont(SWTResourceManager.getBoldFont(currentFont));
			buttonOK.setBackground(SWTResourceManager.getColor(SWT.COLOR_GREEN));
		}
		buttonOK.setBounds(607, 674, 80, 27);
		buttonOK.setText("OK");
		shell.setDefaultButton(buttonOK);	// set the default button to "OK"
		
		lblGroupDelay = new Label(shell, SWT.NONE);
		lblGroupDelay.setAlignment(SWT.RIGHT);
		lblGroupDelay.setBounds(50, 147, 94, 15);
		lblGroupDelay.setText("Group Delay:");
		if(SW_main.q.aq_mode != SW_main.det_modes.CUSTOM_DSP)
			lblGroupDelay.setVisible(false);
		
		Label lblFidBiasCorrection = new Label(shell, SWT.NONE);
		lblFidBiasCorrection.setAlignment(SWT.RIGHT);
		lblFidBiasCorrection.setBounds(30, 171, 114, 15);
		lblFidBiasCorrection.setText("FID Bias Correction:");
		
		Label lblReverse = new Label(shell, SWT.NONE);
		lblReverse.setAlignment(SWT.RIGHT);
		lblReverse.setBounds(69, 196, 75, 15);
		lblReverse.setText("Reverse:");
		
		// unused (moved to Advanced, code maintained for spacing
		Label lblAcquisitionSeqd = new Label(shell, SWT.NONE);
		lblAcquisitionSeqd.setAlignment(SWT.RIGHT);
		lblAcquisitionSeqd.setBounds(10, 223, 134, 15);
		lblAcquisitionSeqd.setText("Acquisition Seq. (3D):");
		/*if(SW_main.q.data_mode != SW_main.modes.MODE_3D)*/
			lblAcquisitionSeqd.setVisible(false);
			
//	button listeners
		buttonOK.addSelectionListener(new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
			// Retrieve dialog results here
				try
				{
					SW_main.p.SI = (int)(Math.pow(2, comboSI.getSelectionIndex() + 6) + 0.1);  // acqquisition dimension			
					SW_main.q.aq_mode = SW_main.det_modes.values()[comboDetMode.getSelectionIndex()];		
					SW_main.q.GRPDLY = Double.parseDouble(textGroupDelay.getText());
					SW_main.q.SF = Double.parseDouble(textSF.getText()); SW_main.p.SF = SW_main.q.SF;
					// TODO add  referencing issues	for SF here.			
					SW_main.p.fcor = Double.parseDouble(textFPC.getText());	
					SW_main.p.REVERSE = checkReverse.getSelection();
					SW_main.p.fid_bias = checkFID_Bias.getSelection();

					SW_main.p.WDW = SW_main.windows.values()[comboWindow.getSelectionIndex()];							
					SW_main.p.LB = Double.parseDouble(textLB.getText());
					SW_main.p.GB = Double.parseDouble(textGF.getText());
					SW_main.p.ssb = Double.parseDouble(textSSB.getText());

					SW_main.p.PH_mod = SW_main.phasing.values()[comboPhasing.getSelectionIndex()];
					SW_main.p.PHC0 = Double.parseDouble(textZeroOrder.getText());
					SW_main.p.PHC1 = Double.parseDouble(textFirstOrder.getText());
					
					SW_main.p.filter_type = SW_main.filters.values()[comboSolvFilter.getSelectionIndex()];
					
					SW_main.p.lp = SW_main.LP_modes.values()[comboLP.getSelectionIndex()];
					SW_main.p.lp_coef = Integer.parseInt(textLPcoef.getText());
					SW_main.p.lp_input = Integer.parseInt(textLPinput.getText());
					SW_main.p.lp_pred = Integer.parseInt(textLPpred.getText());
					SW_main.p.lp_cutoff = Double.parseDouble(textLPcutoff.getText());
					SW_main.p.left_shift = Integer.parseInt(textLeftShiftPoints.getText());
				}
				catch (Exception ex)
				{
					Util.show_and_log("Error extracting acquisition dimension parameters, check your input!", 
							ex.getMessage());
				}
				
				//------------------
					
				// F1 (Y in 2D, Z in 3D)
				if(SW_main.q.data_mode == modes.MODE_2D || SW_main.q.data_mode == modes.MODE_3D)
				{
					try
					{
						SW_main.p_f1.SI = (int)(Math.pow(2, comboSI_F1.getSelectionIndex() + 6) + 0.1);  // indirect F1 dimension
						SW_main.p_f1.MC2 = SW_main.det_modes_IND.values()[comboDetMode_F1.getSelectionIndex()];
						SW_main.q_f1.SF = Double.parseDouble(textSF_F1.getText()); SW_main.p_f1.SF = SW_main.q_f1.SF;
						// add exception handling and referencing issues				
						SW_main.p_f1.fcor = Double.parseDouble(textFPC_F1.getText());
						SW_main.p_f1.REVERSE = checkReverse_F1.getSelection();
						SW_main.p_f1.fid_bias = checkFID_Bias_F1.getSelection();

						SW_main.p_f1.WDW = SW_main.windows.values()[comboWindow_F1.getSelectionIndex()];
						SW_main.p_f1.LB = Double.parseDouble(textLB_F1.getText());
						SW_main.p_f1.GB = Double.parseDouble(textGF_F1.getText());
						SW_main.p_f1.ssb = Double.parseDouble(textSSB_F1.getText());

						SW_main.p_f1.PH_mod = SW_main.phasing.values()[comboPhasing_F1.getSelectionIndex()];
						SW_main.p_f1.PHC0 = Double.parseDouble(textZeroOrder_F1.getText());
						SW_main.p_f1.PHC1 = Double.parseDouble(textFirstOrder_F1.getText());
						
						SW_main.p_f1.lp = SW_main.LP_modes.values()[comboLP_F1.getSelectionIndex()];
						SW_main.p_f1.lp_coef = Integer.parseInt(textLPcoef_F1.getText());
						SW_main.p_f1.lp_input = Integer.parseInt(textLPinput_F1.getText());
						SW_main.p_f1.lp_pred = Integer.parseInt(textLPpred_F1.getText());
						SW_main.p_f1.lp_cutoff = Double.parseDouble(textLPcutoff_F1.getText());
					}
					catch (Exception ex)
					{
						Util.show_and_log("Error extracting F1 processing parameters, check your input!", 
								ex.getMessage());
					}
				}
				//------------------
				
				// F2 (Y in 3D)
				if(SW_main.q.data_mode == modes.MODE_3D)
				{
					try
					{
						SW_main.p_f2.SI = (int)(Math.pow(2, comboSI_F2.getSelectionIndex() + 6) + 0.1);  // indirect F2 dimension
						SW_main.p_f2.MC2 = SW_main.det_modes_IND.values()[comboDetMode_F2.getSelectionIndex()];
						SW_main.q_f2.SF = Double.parseDouble(textSF_F2.getText()); SW_main.p_f2.SF = SW_main.q_f2.SF;
						// add exception handling and referencing issues				
						SW_main.p_f2.fcor = Double.parseDouble(textFPC_F2.getText());
						SW_main.p_f2.REVERSE = checkReverse_F2.getSelection();
						SW_main.p_f2.fid_bias = checkFID_Bias_F2.getSelection();

						SW_main.p_f2.WDW = SW_main.windows.values()[comboWindow_F2.getSelectionIndex()];
						SW_main.p_f2.LB = Double.parseDouble(textLB_F2.getText());
						SW_main.p_f2.GB = Double.parseDouble(textGF_F2.getText());
						SW_main.p_f2.ssb = Double.parseDouble(textSSB_F2.getText());

						SW_main.p_f2.PH_mod = SW_main.phasing.values()[comboPhasing_F2.getSelectionIndex()];
						SW_main.p_f2.PHC0 = Double.parseDouble(textZeroOrder_F2.getText());
						SW_main.p_f2.PHC1 = Double.parseDouble(textFirstOrder_F2.getText());
						
						SW_main.p_f2.lp = SW_main.LP_modes.values()[comboLP_F2.getSelectionIndex()];
						SW_main.p_f2.lp_coef = Integer.parseInt(textLPcoef_F2.getText());
						SW_main.p_f2.lp_input = Integer.parseInt(textLPinput_F2.getText());
						SW_main.p_f2.lp_pred = Integer.parseInt(textLPpred_F2.getText());
						SW_main.p_f2.lp_cutoff = Double.parseDouble(textLPcutoff_F2.getText());
					}
					catch (Exception ex)
					{
						Util.show_and_log("Error extracting F1 processing parameters, check your input!", 
								ex.getMessage());
					}
				}				
				shell.dispose();
			}
		});	// end buttonOK.addSelectionListener	
		
		buttonCancel.addSelectionListener(new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				shell.dispose();
			}
		});	// end buttonCancel.addSelectionListener
		
		// if detection mode is changed to CUSTOM_DSP, turn on Group delay
		comboDetMode.addSelectionListener(new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				SW_main.det_modes mode = SW_main.det_modes.values()[comboDetMode.getSelectionIndex()];
				if(mode == SW_main.det_modes.CUSTOM_DSP)
				{
					textGroupDelay.setVisible(true);
					lblGroupDelay.setVisible(true);
				}
			}
		});	
				
		//	Advanced processing parameters, acquisition dimension
		buttonAdvanced.addSelectionListener(new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				ParDirectAdvanced dlg = new ParDirectAdvanced(shell, 
       				 SWT.APPLICATION_MODAL | SWT.TITLE | SWT.BORDER );
				dlg.open();
			}
		});

		buttonAdvanced_F1.addSelectionListener(new SelectionAdapter() 	// Advanced button F1
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				ParF1Advanced dlg = new ParF1Advanced(shell, 
	       				 SWT.APPLICATION_MODAL | SWT.TITLE | SWT.BORDER );
					dlg.open();
			}
		});
		
		buttonAdvanced_F2.addSelectionListener(new SelectionAdapter() 	// Advanced button F2
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{ 
				ParF2Advanced dlg = new ParF2Advanced(shell, 
	       				 SWT.APPLICATION_MODAL | SWT.TITLE | SWT.BORDER );
					dlg.open();
			}
		});	
		
	}	// end CreateContents()
//-------------------------------------------------------------------------------------------------
}	// end class
