/**
 * 
 */
package dialogs;

import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Text;

import spinworks.FileUtil;
import spinworks.MouseHandler;
import spinworks.PeakInfo;
import spinworks.PeakPick;
import spinworks.SW_main;
import spinworks.Util_2D;
import spinworks.SW_main.corr;

/**
 * @author Kirk Marat, University of Manitoba
 *
 */
public class PeakAssignmentDialog extends Dialog 
{
	protected Object result;
	protected Shell shell;
	private Text textAssignment;
	public Text textCOSY;
	public Text textTOCSY;
	public Text textNOESY;
	public Text textHMBC;
	
	private int index;
	private double f2, f1;

/**
 * Create the dialog.
 * @param parent
 * @param style
 * @param index  index on the peak to edit.  -1 ia a new peak
 */
	public PeakAssignmentDialog(Shell parent, int style, int _index, double _f2, double _f1) 
	{
		super(parent, style);
		setText("Peak Assignment Dialog");
		index = _index; 	f2 = _f2; 	f1 = _f1;	// kludgey, find a better way
	}

/**
 * Open the dialog.
 * @return the result
 */
	public Object open() 
	{
		createContents();
		shell.open();
		shell.layout();
		Display display = getParent().getDisplay();
		
		SW_main.update_spect = true;
		SW_main.canvas.redraw();
		
		while (!shell.isDisposed()) 
		{
			if (!display.readAndDispatch()) 
			{
				display.sleep();
			}
		}		
		return result;
	}

/**
 * Create contents of the dialog.
 */
	private void createContents() 
	{
		shell = new Shell(getParent(), getStyle());
		shell.setSize(310, 386);
		shell.setText(getText());
		
		Label labelF2Shift = new Label(shell, SWT.NONE);
		labelF2Shift.setBounds(10, 10, 100, 15);
						
		Label labelF1Shift = new Label(shell, SWT.NONE);
		labelF1Shift.setBounds(141, 10, 100, 15);
						
		Button buttonOK = new Button(shell, SWT.NONE);				
		buttonOK.setBounds(123, 322, 75, 25);
		buttonOK.setText("OK");
		shell.setDefaultButton(buttonOK);	// set the default button to "OK"
		
		Button buttonCancel = new Button(shell, SWT.NONE);
		buttonCancel.setBounds(204, 322, 75, 25);
		buttonCancel.setText("Cancel");
		
		Label labelAssignment = new Label(shell, SWT.NONE);
		labelAssignment.setAlignment(SWT.RIGHT);
		labelAssignment.setBounds(10, 37, 75, 15);
		labelAssignment.setText("Assignment:");
		
		textAssignment = new Text(shell, SWT.BORDER);
		textAssignment.setBounds(101, 31, 75, 21);
		
		textCOSY = new Text(shell, SWT.BORDER | SWT.V_SCROLL | SWT.MULTI);
		textCOSY.setBounds(101, 61, 127, 60);
		
		textTOCSY = new Text(shell, SWT.BORDER | SWT.V_SCROLL | SWT.MULTI);
		textTOCSY.setBounds(101, 127, 127, 60);
		
		textNOESY = new Text(shell, SWT.BORDER | SWT.V_SCROLL | SWT.MULTI);
		textNOESY.setBounds(101, 193, 127, 60);
		
		textHMBC = new Text(shell, SWT.BORDER | SWT.V_SCROLL | SWT.MULTI);
		textHMBC.setBounds(101, 259, 127, 58);
		
		Label labelCOSY = new Label(shell, SWT.RIGHT);
		labelCOSY.setBounds(30, 64, 55, 15);
		labelCOSY.setText("COSY:");
		
		Label labelTOCSY = new Label(shell, SWT.NONE);
		labelTOCSY.setAlignment(SWT.RIGHT);
		labelTOCSY.setBounds(30, 130, 55, 15);
		labelTOCSY.setText("TOCSY:");
		
		Label labelNOESY = new Label(shell, SWT.NONE);
		labelNOESY.setAlignment(SWT.RIGHT);
		labelNOESY.setBounds(30, 196, 55, 15);
		labelNOESY.setText("NOESY:");
		
		Label labelHMBC = new Label(shell, SWT.NONE);
		labelHMBC.setAlignment(SWT.RIGHT);
		labelHMBC.setBounds(30, 262, 55, 15);
		labelHMBC.setText("HMBC:");
		
		Button buttonAddCOSY = new Button(shell, SWT.NONE);		
		buttonAddCOSY.setBounds(234, 64, 65, 25);
		buttonAddCOSY.setText("Add");
		
		Button buttonAddTOCSY = new Button(shell, SWT.NONE);		
		buttonAddTOCSY.setText("Add");
		buttonAddTOCSY.setBounds(234, 130, 65, 25);
		
		Button buttonAddNOESY = new Button(shell, SWT.NONE);		
		buttonAddNOESY.setText("Add");
		buttonAddNOESY.setBounds(234, 196, 65, 25);
		
		Button buttonAddHMBC = new Button(shell, SWT.NONE);		
		buttonAddHMBC.setText("Add");
		buttonAddHMBC.setBounds(234, 262, 65, 25);
		
		if(index == -1)	// new peak
		{
			shell.setText("New Peak Assignment");
			labelF2Shift.setText( String.format("F2 = %.4f ppm", f2 / SW_main.q.SF));
			labelF1Shift.setText( String.format("F1 = %.4f ppm", f1 / SW_main.q_f1.SF));
			
			int i = (int) Math.round((SW_main.q.offset - (SW_main.gp.freq1 
					- (double)(SW_main.cursor_x - SW_main.gp.left_2D) * SW_main.gp.hzperpix)) 
					/ SW_main.q.hzperpt);

			if (i < 0) i = 0; if (i >= SW_main.q.SI) i = SW_main.q.SI - 1;

			int j = (int) Math.round((SW_main.q_f1.offset - (SW_main.gp.freq1_indirect 
					- (double)(SW_main.gp.dysize - SW_main.gp.bottom_2D - SW_main.cursor_y) * SW_main.gp.hzperpix_f1)) 
					/ SW_main.q_f1.hzperpt);

			if (j < 0) j = 0; if (j >= SW_main.q_f1.SI) j = SW_main.q_f1.SI - 1;
        
			SW_main.gp.peaks[SW_main.gp.n_peaks] 
					= new PeakInfo(f2, f1, j, i,
							Util_2D.find_peak(SW_main.gp.rows_real, j, i, 2, SW_main.q, SW_main.q_f1), 
							"");
			SW_main.gp.n_peaks++;
		}
		else // editing old peak, load existing values
		{
			shell.setText("Edit Peak Assignment");
			labelF2Shift.setText( String.format("F2 = %.4f ppm", 
					SW_main.gp.peaks[index].freq / SW_main.q.SF));
			labelF1Shift.setText( String.format("F1 = %.4f ppm", 
					SW_main.gp.peaks[index].freq_f1 / SW_main.q_f1.SF));
			
			SW_main.gp.active_peak = index;

            textAssignment.setText(SW_main.gp.peaks[index].label);
                       
            labelF2Shift.setText( String.format("F2 = %.4f ppm", 
            		SW_main.gp.peaks[index].freq / SW_main.q.SF));
			labelF1Shift.setText( String.format("F1 = %.4f ppm", 
					SW_main.gp.peaks[index].freq_f1 / SW_main.q_f1.SF));

            for (int i = 0; i < SW_main.gp.peaks[index].n_cosy; i++)
            {
            	if(SW_main.gp.peaks[index].cosy_f1[i] == 0.0)
            		textCOSY.setText(textCOSY.getText() + String.format("%.4f\r\n",
            				SW_main.gp.peaks[index].cosy[i]));
            	else
            		textCOSY.setText(textCOSY.getText() + String.format("%.4f, %.4f\r\n",
            				SW_main.gp.peaks[index].cosy[i], SW_main.gp.peaks[index].cosy_f1[i]));
            }

			for (int i = 0; i < SW_main.gp.peaks[index].n_tocsy; i++)
			{
				if(SW_main.gp.peaks[index].tocsy_f1[i] == 0.0)
					textTOCSY.setText(textTOCSY.getText() + String.format("%.4f\r\n",
							SW_main.gp.peaks[index].tocsy[i]));
				else
            		textTOCSY.setText(textTOCSY.getText() + String.format("%.4f, %.4f\r\n",
            				SW_main.gp.peaks[index].tocsy[i], SW_main.gp.peaks[index].tocsy_f1[i]));
			}

			for (int i = 0; i < SW_main.gp.peaks[index].n_noesy; i++)
			{
				if(SW_main.gp.peaks[index].noesy_f1[i] == 0.0)
	                textNOESY.setText(textNOESY.getText() + String.format("%.4f\r\n",
	                		SW_main.gp.peaks[index].noesy[i]));
				else
            		textNOESY.setText(textNOESY.getText() + String.format("%.4f, %.4f\r\n",
            				SW_main.gp.peaks[index].noesy[i], SW_main.gp.peaks[index].noesy_f1[i]));
			}

			for (int i = 0; i < SW_main.gp.peaks[index].n_hmbc; i++)
			{
				if(SW_main.gp.peaks[index].hmbc_f1[i] == 0.0)
	                textHMBC.setText(textHMBC.getText() + String.format("%.4f\r\n",
	                		SW_main.gp.peaks[index].hmbc[i]));  
				else
            		textHMBC.setText(textHMBC.getText() + String.format("%.4f, %.4f\r\n",
            				SW_main.gp.peaks[index].hmbc[i], SW_main.gp.peaks[index].hmbc_f1[i]));
			}
		}
		
	//	listeners
		buttonAddCOSY.addSelectionListener(new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				MouseHandler.assignCOSY = true;
			}
		});
		
		buttonAddTOCSY.addSelectionListener(new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				MouseHandler.assignTOCSY = true;
			}
		});
		
		buttonAddNOESY.addSelectionListener(new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				MouseHandler.assignNOESY = true;
			}
		});
		
		buttonAddHMBC.addSelectionListener(new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				MouseHandler.assignHMBC = true;
			}
		});
		
		buttonOK.addSelectionListener(new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				if(index == -1)	// a new peak assignment
				{				
					SW_main.gp.peaks[SW_main.gp.n_peaks - 1].label = textAssignment.getText();													 
					PeakPick.parseAssignments(textCOSY.getText(), 
							SW_main.gp.peaks[SW_main.gp.n_peaks - 1], corr.COSY);
					PeakPick.parseAssignments(textTOCSY.getText(), 
							SW_main.gp.peaks[SW_main.gp.n_peaks - 1], corr.TOCSY);
					PeakPick.parseAssignments(textNOESY.getText(), 
							SW_main.gp.peaks[SW_main.gp.n_peaks - 1], corr.NOESY);
					PeakPick.parseAssignments(textHMBC.getText(), 
							SW_main.gp.peaks[SW_main.gp.n_peaks - 1], corr.HMBC);
				}
				else	// editing an old assignment
				{		// edit assignments but don't change shifts, etc.
					SW_main.gp.peaks[index].label = textAssignment.getText();				 
					PeakPick.parseAssignments(textCOSY.getText(), 
							SW_main.gp.peaks[index], corr.COSY);
					PeakPick.parseAssignments(textTOCSY.getText(), 
							SW_main.gp.peaks[index], corr.TOCSY);
					PeakPick.parseAssignments(textNOESY.getText(), 
							SW_main.gp.peaks[index], corr.NOESY);
					PeakPick.parseAssignments(textHMBC.getText(), 
							SW_main.gp.peaks[index], corr.HMBC);
				}
				
				FileUtil.savePeaks2D(SW_main.gp, SW_main.q);
				
				MouseHandler.assignCOSY = false;
				MouseHandler.assignTOCSY = false;
				MouseHandler.assignNOESY = false;
				MouseHandler.assignHMBC = false;
				
				MouseHandler.dlg = null;		// not sure why this is necessary
				shell.dispose();				// thought dispose would null the dialog
			}
		});
				
		buttonCancel.addSelectionListener(new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				MouseHandler.assignCOSY = false;
				MouseHandler.assignTOCSY = false;
				MouseHandler.assignNOESY = false;
				MouseHandler.assignHMBC = false;
				
				// since peaks object was created at start of dialog
				SW_main.gp.peaks[SW_main.gp.n_peaks] = null;						
				MouseHandler.dlg = null;		// not sure why this is necessary
				shell.dispose();				// thought dispose would null the dialog
			}
		});
		
//-------------------------------------------------------------------------------------------------	
	}	// createContents
}	// end class
