/**
 * 
 */
package dialogs;

import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.eclipse.wb.swt.SWTResourceManager;

import spinworks.PeakPick;
import spinworks.SW_main;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;

/**
 * @author marat
 *
 */
public class PeakLabelDialog extends Dialog 
{

	protected Object result;
	protected Shell shell;
	private Text text;
	private int peak = 0;

/**
 * Create the dialog.
 * @param parent
 * @param style
 * @param _peak the peak index to assign the label to
 */
	public PeakLabelDialog(Shell parent, int style, int _peak) 
	{
		super(parent, style);
		setText("Label");
		peak = _peak;
	}

/**
 * Open the dialog.
 * @return the result
 */
	public Object open() 
	{
		createContents();
		shell.open();
		shell.layout();
		Display display = getParent().getDisplay();
		while (!shell.isDisposed()) 
		{
			if (!display.readAndDispatch()) 
			{
				display.sleep();
			}
		}
		return result;
	}

/**
 * Create contents of the dialog.
 */
	private void createContents() 
	{
		shell = new Shell(getParent(), getStyle());
		shell.setBounds(SW_main.cursor_x + SW_main.windowLocation.x, SW_main.cursor_y + SW_main.windowLocation.y, 188, 50);
		shell.setText(getText());
		
		text = new Text(shell, SWT.BORDER);
		text.setBounds(10, 10, 110, 21);
		text.setText(SW_main.gp.peaks[peak].label);
		
		Button buttonOK = new Button(shell, SWT.NONE);		
		buttonOK.setBounds(126, 6, 44, 25);
		buttonOK.setText("OK");
		buttonOK.setBackground(SWTResourceManager.getColor(SWT.COLOR_GREEN));
		shell.setDefaultButton(buttonOK);
		
		buttonOK.addSelectionListener(new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				SW_main.gp.peaks[peak].label = new String(text.getText());
				SW_main.update_spect = true;
				SW_main.gp.cursor_flag = 0;
				PeakPick.savePeaks(SW_main.gp, SW_main.q);
				shell.dispose();			
			}
		});
	}
}
