package dialogs;

import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Text;
//import org.eclipse.wb.swt.SWTResourceManager;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Font;
import org.eclipse.wb.swt.SWTResourceManager;

import spinworks.SW_main;

public class PlotTitleEditor extends Dialog 
{

	protected Object result;
	protected String value;
	protected Shell shell;
	private Text text;
	private Font currentFont;

	/**
	 * Create the dialog.
	 * @param parent
	 * @param style
	 */
	public PlotTitleEditor(Shell parent, int style) 
	{
		super(parent, style);
		setText("Edit Plot Title");
	}

	/**
	 * Open the dialog.
	 * @return the result
	 */
	public Object open() 
	{
		createContents();
		shell.open();
		shell.layout();
		Display display = getParent().getDisplay();
		while (!shell.isDisposed()) 
		{
			if (!display.readAndDispatch()) 
			{
				display.sleep();
			}
		}
		return result;
	}

	/**
	 * Create contents of the dialog.
	 */
	private void createContents() 
	{
		shell = new Shell(getParent(), getStyle());
		shell.setSize(450, 150);
		shell.setText(getText());
		
// OK button
		final Button buttonOK = new Button(shell, SWT.NONE);
		if(SW_main.currentOS != SW_main.osTypes.MACOS)
		{
			currentFont = buttonOK.getFont();
			buttonOK.setFont(SWTResourceManager.getBoldFont(currentFont));
			buttonOK.setBackground(shell.getDisplay().getSystemColor(SWT.COLOR_GREEN));
		}
		buttonOK.setBounds(268, 86, 80, 27);		
		buttonOK.setText("OK");
		
		buttonOK.addSelectionListener(new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				SW_main.gp.plot_title = value;
				shell.dispose();
			}
		});
						
// Cancel button
		final Button buttonCancel = new Button(shell, SWT.BORDER | SWT.FLAT);
		if(SW_main.currentOS != SW_main.osTypes.MACOS)
		{
			currentFont = buttonCancel.getFont();
			buttonCancel.setFont(SWTResourceManager.getBoldFont(currentFont));		
			buttonCancel.setBackground(shell.getDisplay().getSystemColor(SWT.COLOR_RED));
		}
		buttonCancel.setBounds(354, 86, 80, 27);
		buttonCancel.setText("Cancel");
		
		buttonCancel.addSelectionListener(new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
		        shell.dispose();
			}
		});
				
// Text
		text = new Text(shell, SWT.BORDER | SWT.WRAP | SWT.MULTI);
		// TODO Problem with MACOS here??
		if(SW_main.currentOS != SW_main.osTypes.MACOS)
			text.setFont(SWTResourceManager.getFont("Segoe UI", 10, SWT.NORMAL));
		text.setText(SW_main.gp.plot_title);
		value = new String(SW_main.gp.plot_title);
		text.setBounds(21, 10, 413, 70);
		
		text.addListener(SWT.Modify, new Listener() 
		{
		      public void handleEvent(Event event) 
		      {
		        try 
		        {
		          value = new String(text.getText());
		          buttonOK.setEnabled(true);
		        } 
		        catch (Exception e) 
		        {
		          buttonOK.setEnabled(false);
		        }
		      }
		 });
		
		shell.setDefaultButton(buttonOK);
		
	}	// create contents
}	// class
