package dialogs;

import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;

import spinworks.SW_main;

import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.List;

public class RecentFilesDialog extends Dialog 
{

	protected Object result;		// can we just return int???
	protected Shell shlRecentFilesList;

	/**
	 * Create the recent files dialog.
	 * @param parent
	 * @param style
	 */
	public RecentFilesDialog(Shell parent, int style) 
	{
		super(parent, style);
		setText("Recent Data Sets");
	}

	/**
	 * Open the dialog.
	 * @return the result
	 */
	public Object open() 
	{
		createContents();
		shlRecentFilesList.open();
		shlRecentFilesList.layout();
		Display display = getParent().getDisplay();
		while (!shlRecentFilesList.isDisposed()) 
		{
			if (!display.readAndDispatch()) 
			{
				display.sleep();
			}
		}
		return result;
	}

	/**
	 * Create contents of the dialog.
	 */
	private void createContents() 
	{
		shlRecentFilesList = new Shell(getParent(), getStyle());
		shlRecentFilesList.setSize(828, 277);
		shlRecentFilesList.setText("Recent Files List");
		
		Button buttonOK = new Button(shlRecentFilesList, SWT.NONE);		
		buttonOK.setBounds(656, 192, 75, 25);
		buttonOK.setText("OK");
		if(SW_main.currentOS != SW_main.osTypes.MACOS)
			buttonOK.setBackground(shlRecentFilesList.getDisplay().getSystemColor(SWT.COLOR_GREEN));
		
		Button buttonCancel = new Button(shlRecentFilesList, SWT.NONE);		
		buttonCancel.setBounds(737, 192, 75, 25);
		buttonCancel.setText("Cancel");
		if(SW_main.currentOS != SW_main.osTypes.MACOS)
			buttonCancel.setBackground(shlRecentFilesList.getDisplay().getSystemColor(SWT.COLOR_RED));
		
		final List list = new List(shlRecentFilesList, SWT.BORDER);	
		
		int nItems = 1;
		for(int i = 0; i < SW_main.file_obj.file_path.length - 1; i++)
		{
			if(SW_main.file_obj.file_path[i] != null) nItems++;
		}
				
		try
		{
			for(int i = 0; i < nItems; i++)
			{
				list.add(SW_main.file_obj.file_path[i] + "       "
						+ SW_main.file_obj.seq_name[i] + "       "
						+ SW_main.file_obj.short_text[i]);
			}
		}
		catch(Exception ex)	{ex.printStackTrace();}
			
		list.setBounds(10, 10, 802, 176);
		
		list.addMouseListener(new MouseListener() // for double-click selection from list
		{
			@Override
			public void mouseDoubleClick(MouseEvent event) 
			{
				result = (Object)list.getSelectionIndex();
				shlRecentFilesList.dispose();
			}

			@Override
			public void mouseDown(MouseEvent event) {	// unused			
			}
			@Override
			public void mouseUp(MouseEvent event) {		// unused			
			}		
		});
				
		buttonOK.addSelectionListener(new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				result = (Object)list.getSelectionIndex();
				shlRecentFilesList.dispose();
			}
		});
		
		buttonCancel.addSelectionListener(new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				shlRecentFilesList.dispose();
			}
		});
	}
}
