package dialogs;

import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.ColorDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.RGB;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

import spinworks.SW_main;

import org.eclipse.swt.widgets.Spinner;
import org.eclipse.swt.widgets.Combo;

public class StackTraceDialog extends Dialog 
{
	protected Object result;
	protected Shell shell;
	private Text textYoffset;
	private Text textXoffset;
	private Text textXsize;

	/**
	 * Create the dialog.
	 * @param parent
	 * @param style
	 */
	public StackTraceDialog(Shell parent, int style) 
	{
		super(parent, style);
		setText("Stack Trace Dialog");
	}

	/**
	 * Open the dialog.
	 * @return the result
	 */
	public Object open() 
	{
		createContents();
		shell.open();
		shell.layout();
		Display display = getParent().getDisplay();
		while (!shell.isDisposed()) 
		{
			if (!display.readAndDispatch()) 
			{
				display.sleep();
			}
		}
		return result;
	}

	/**
	 * Create contents of the dialog.
	 */
	private void createContents() 
	{
		SW_main.gp.stack_dlg_on = true;
		shell = new Shell(getParent(), SWT.BORDER | SWT.TITLE);
		shell.setSize(292, 417);
		shell.setText(getText());
				
		Button buttonClose = new Button(shell, SWT.NONE);		
		buttonClose.setBounds(199, 353, 75, 25);
		buttonClose.setText("Close");
		
		Label lblStackedTraceY = new Label(shell, SWT.NONE);
		lblStackedTraceY.setAlignment(SWT.RIGHT);
		lblStackedTraceY.setBounds(12, 32, 168, 15);
		lblStackedTraceY.setText("Stacked Trace Y Offset (pixels):");
		
		Label lblStackedTraceX = new Label(shell, SWT.NONE);
		lblStackedTraceX.setAlignment(SWT.RIGHT);
		lblStackedTraceX.setBounds(12, 56, 168, 15);
		lblStackedTraceX.setText("Stacked Trace X Offset (pixels):");
		
		Label lblStackedTraceX_1 = new Label(shell, SWT.NONE);
		lblStackedTraceX_1.setAlignment(SWT.RIGHT);
		lblStackedTraceX_1.setBounds(33, 84, 147, 15);
		lblStackedTraceX_1.setText("Stacked Trace X size (pixels):");
		
		textYoffset = new Text(shell, SWT.BORDER);
		textYoffset.setBounds(198, 26, 76, 21);
		textYoffset.setText(String.format("%d", SW_main.gp.stack_y_offset));
		
		textXoffset = new Text(shell, SWT.BORDER);
		textXoffset.setBounds(198, 53, 76, 21);
		textXoffset.setText(String.format("%d", SW_main.gp.stack_x_offset));
		
		textXsize = new Text(shell, SWT.BORDER);
		textXsize.setBounds(198, 81, 76, 21);
		textXsize.setText(String.format("%d", SW_main.gp.stack_x_size));
		textXsize.setEnabled(!SW_main.gp.stack_x_size_auto);
		
		final Button checkAutoXsize = new Button(shell, SWT.CHECK);
		checkAutoXsize.setBounds(10, 115, 93, 16);
		checkAutoXsize.setText("Auto X size");
		checkAutoXsize.setSelection(SW_main.gp.stack_x_size_auto);
		
		final Button checkWhitewash = new Button(shell, SWT.CHECK);
		checkWhitewash.setBounds(10, 143, 93, 16);
		checkWhitewash.setText("Whitewash");
		checkWhitewash.setSelection(SW_main.gp.stack_whitewash);
		
		final Spinner spinnerActiveTrace = new Spinner(shell, SWT.BORDER);
		spinnerActiveTrace.setToolTipText("which of the stacked traces to scale");
		spinnerActiveTrace.setMinimum(1);
		spinnerActiveTrace.setMaximum(10);
		//spinnerActiveTrace.setMaximum(SW_main.gp.n_traces);
		spinnerActiveTrace.setBounds(109, 192, 47, 22);
		
		Label lblActiveTrace = new Label(shell, SWT.RIGHT);
		lblActiveTrace.setBounds(10, 195, 84, 15);
		lblActiveTrace.setText("Active Trace:");
		
		final Button checkAll = new Button(shell, SWT.CHECK);
		checkAll.setToolTipText("if checked,\r\nscale all stacked traces");
		checkAll.setBounds(197, 195, 47, 15);
		checkAll.setText("All");
		
		Button buttonScaleDown = new Button(shell, SWT.NONE);
		buttonScaleDown.setBounds(109, 220, 34, 25);
		buttonScaleDown.setText("-");
		
		Button buttonScaleUp = new Button(shell, SWT.NONE);
		buttonScaleUp.setBounds(158, 220, 34, 25);
		buttonScaleUp.setText("+");
		
		Label lblVerticalScaling = new Label(shell, SWT.NONE);
		lblVerticalScaling.setAlignment(SWT.RIGHT);
		lblVerticalScaling.setBounds(1, 225, 93, 15);
		lblVerticalScaling.setText("Vertical Scaling:");
		
		Button buttonResetAll = new Button(shell, SWT.NONE);
		buttonResetAll.setToolTipText("scale all stacked traces to main trace");
		buttonResetAll.setBounds(109, 251, 83, 25);
		buttonResetAll.setText("Reset All");
		
		Button buttonDisplayColour = new Button(shell, SWT.NONE);
		buttonDisplayColour.setBounds(109, 282, 75, 25);
		buttonDisplayColour.setText("Display");
		
		Button buttonPrintColour = new Button(shell, SWT.NONE);
		buttonPrintColour.setBounds(197, 282, 75, 25);
		buttonPrintColour.setText("Print");
		
		Label lblColour = new Label(shell, SWT.NONE);
		lblColour.setAlignment(SWT.RIGHT);
		lblColour.setBounds(39, 292, 55, 15);
		lblColour.setText("Colour:");
		
		final Combo comboLabel = new Combo(shell, SWT.NONE);
		comboLabel.setItems(new String[] {"None", "Numeric", "Title", "File Path"});
		comboLabel.setBounds(109, 313, 163, 23);
		comboLabel.select(0);
		
		Label lblLabeling = new Label(shell, SWT.NONE);
		lblLabeling.setAlignment(SWT.RIGHT);
		lblLabeling.setBounds(39, 321, 55, 15);
		lblLabeling.setText("Labeling:");
		
		Button buttonApply = new Button(shell, SWT.NONE);
		buttonApply.setBounds(109, 353, 75, 25);
		buttonApply.setText("Apply");
		
//Listeners below
				
		checkAutoXsize.addSelectionListener(new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				if(checkAutoXsize.getSelection() == false)
				{
					SW_main.gp.stack_x_size_auto = false;
					textXsize.setEnabled(true);
				}
				else	// must be true
				{
					SW_main.gp.stack_x_size_auto = true;
					textXsize.setEnabled(false);
				}
			}
		});
		
		checkWhitewash.addSelectionListener(new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				if(checkWhitewash.getSelection() == false)
					SW_main.gp.stack_whitewash = false;
				else	// must be true
					SW_main.gp.stack_whitewash = true;
				
				SW_main.update_spect = true;	// update display
				SW_main.canvas.redraw();
			}
		});
		
		buttonScaleDown.addSelectionListener(new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				if(checkAll.getSelection())
					for(int i = 0; i < SW_main.gp.n_traces; i++)
						SW_main.gp.stack_trace[i].yscale *= 0.95238; // 1/1.05
				else
					SW_main.gp.stack_trace[spinnerActiveTrace.getSelection() - 1].yscale *= 0.95238;		
						
				SW_main.update_spect = true;
				SW_main.canvas.redraw();
			}
		});
		
		buttonScaleUp.addSelectionListener(new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				if(checkAll.getSelection())
					for(int i = 0; i < SW_main.gp.n_traces; i++)
						SW_main.gp.stack_trace[i].yscale *= 1.05;
				else
					SW_main.gp.stack_trace[spinnerActiveTrace.getSelection() - 1].yscale *= 1.05;	

				SW_main.update_spect = true;
				SW_main.canvas.redraw();
			}
		});
		
		checkAll.addSelectionListener(new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
					spinnerActiveTrace.setEnabled(!checkAll.getSelection());
			}
		});
		
		buttonResetAll.addSelectionListener(new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				for(int i = 0; i < SW_main.gp.n_traces; i++)
					SW_main.gp.stack_trace[i].yscale = SW_main.gp.expt_scale;
				
				SW_main.update_spect = true;
				SW_main.canvas.redraw();
			}
		});
		
		buttonDisplayColour.addSelectionListener(new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				ColorDialog dlg = new ColorDialog(shell);
				RGB rgb = dlg.open();
				
				if(checkAll.getSelection())
					for(int i = 0; i < SW_main.gp.n_traces; i++)
						SW_main.gp.stack_trace[i].colour 
						= new Color(Display.getCurrent(), rgb);
				else	
					SW_main.gp.stack_trace[spinnerActiveTrace.getSelection() - 1].colour 
						= new Color(Display.getCurrent(), rgb);
			}
		});
		
		buttonPrintColour.addSelectionListener(new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				ColorDialog dlg = new ColorDialog(shell);
				RGB rgb = dlg.open();
				
				if(checkAll.getSelection())
					for(int i = 0; i < SW_main.gp.n_traces; i++)
						SW_main.gp.stack_trace[i].print_colour 
						= new Color(Display.getCurrent(), rgb);
				else	
					SW_main.gp.stack_trace[spinnerActiveTrace.getSelection() - 1].print_colour 
						= new Color(Display.getCurrent(), rgb);
			}
		});
		
		// Apply button
		buttonApply.addSelectionListener(new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				SW_main.gp.stack_x_offset = Integer.parseInt(textXoffset.getText());
				SW_main.gp.stack_y_offset = Integer.parseInt(textYoffset.getText());
				SW_main.gp.stack_x_size = Integer.parseInt(textXsize.getText());
				SW_main.gp.stack_label_type = comboLabel.getSelectionIndex();
				
				SW_main.update_spect = true;
				SW_main.canvas.redraw();
			}
		});
		
		// Close button
		buttonClose.addSelectionListener(new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				shell.dispose();
				SW_main.gp.stack_dlg_on = false;
				SW_main.gp.cursor_flag = 0;
				SW_main.update_spect = true; // necesasary???
				SW_main.canvas.redraw();
			}
		});
	    
		shell.setDefaultButton(buttonApply);
				
	}
}
