package dialogs;

import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.wb.swt.SWTResourceManager;

import spinworks.PreferenceUtil;
import spinworks.SW_main;

import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Group;

public class StartupOptionsDialog extends Dialog 
{

	protected Object result;
	protected Shell shell;
	private Text DefaultDataFolderText;
	private Text textScratchFolder;
	private Text textModulePath;

	/**
	 * Create the dialog.
	 * @param parent
	 * @param style
	 */
	public StartupOptionsDialog(Shell parent, int style) 
	{
		super(parent, style);
		setText("Edit Startup Options");
	}

	/**
	 * Open the dialog.
	 * @return the result
	 */
	public Object open() 
	{
		createContents();
		shell.open();
		shell.layout();
		Display display = getParent().getDisplay();
		while (!shell.isDisposed()) 
		{
			if (!display.readAndDispatch()) 
			{
				display.sleep();
			}
		}
		return result;
	}

	/**
	 * Create contents of the dialog.
	 */
	private void createContents() 
	{
		//Shell
		shell = new Shell(getParent(), SWT.DIALOG_TRIM);
		shell.setSize(440, 363);
		shell.setText(getText());
		
		// OK Button
		Button OK_Button = new Button(shell, SWT.NONE);	
		if(SW_main.currentOS != SW_main.osTypes.MACOS)
			OK_Button.setFont(SWTResourceManager.getFont("Segoe UI", 10, SWT.NORMAL));
		OK_Button.setBounds(269, 299, 75, 25);
		OK_Button.setText("OK");
		OK_Button.setBackground(shell.getDisplay().getSystemColor(SWT.COLOR_GREEN));
		
		// Cancel Button
		Button CancelButton = new Button(shell, SWT.NONE);
		if(SW_main.currentOS != SW_main.osTypes.MACOS)
			CancelButton.setFont(SWTResourceManager.getFont("Segoe UI", 10, SWT.NORMAL));
		CancelButton.setBounds(349, 299, 75, 25);
		CancelButton.setText("Cancel");
		CancelButton.setBackground(shell.getDisplay().getSystemColor(SWT.COLOR_RED));
		
		Label lblDefaultDataFolder = new Label(shell, SWT.NONE);
		lblDefaultDataFolder.setAlignment(SWT.RIGHT);
		lblDefaultDataFolder.setBounds(10, 28, 144, 15);
		lblDefaultDataFolder.setText("Default Data Folder:");
		
		DefaultDataFolderText = new Text(shell, SWT.BORDER);
		DefaultDataFolderText.setBounds(160, 22, 264, 21);
		if(SW_main.gp.default_folder != null)
			DefaultDataFolderText.setText(SW_main.gp.default_folder);
		
		Group ProcessedDataGroup = new Group(shell, SWT.NONE);
		ProcessedDataGroup.setText("Processed Data");
		ProcessedDataGroup.setBounds(34, 143, 390, 72);
		
		final Button AutoSaveButton = new Button(ProcessedDataGroup, SWT.CHECK);
		AutoSaveButton.setBounds(10, 24, 93, 16);
		AutoSaveButton.setText("Auto Save");
		AutoSaveButton.setSelection(SW_main.gp.auto_save);
		
		final Button AutoLoadButton = new Button(ProcessedDataGroup, SWT.CHECK);
		AutoLoadButton.setBounds(126, 24, 93, 16);
		AutoLoadButton.setText("Auto Load");
		AutoLoadButton.setSelection(SW_main.gp.auto_load);
		
		Group FontSizeGroup = new Group(shell, SWT.NONE);
		FontSizeGroup.setText("Display Font Size");
		FontSizeGroup.setBounds(34, 221, 390, 72);
		
		final Button smallFontRadioButton = new Button(FontSizeGroup, SWT.RADIO);
		smallFontRadioButton.setBounds(6, 31, 90, 16);
		smallFontRadioButton.setText("Small");
		
		final Button mediumFontRadioButton = new Button(FontSizeGroup, SWT.RADIO);
		mediumFontRadioButton.setBounds(102, 31, 90, 16);
		mediumFontRadioButton.setText("Medium");
		
		final Button largerFontRadioButton = new Button(FontSizeGroup, SWT.RADIO);
		largerFontRadioButton.setBounds(198, 31, 90, 16);
		largerFontRadioButton.setText("Larger");
		
		final Button largestFontRadioButton = new Button(FontSizeGroup, SWT.RADIO);
		largestFontRadioButton.setBounds(294, 31, 90, 16);
		largestFontRadioButton.setText("Largest");
		
		textScratchFolder = new Text(shell, SWT.BORDER);
		textScratchFolder.setBounds(160, 49, 264, 21);
		textScratchFolder.setText(SW_main.gp.scratch_folder);
		
		textModulePath = new Text(shell, SWT.BORDER);
		textModulePath.setBounds(160, 76, 264, 21);
		textModulePath.setText(SW_main.gp.module_folder);
		
		Label lblWritableScratchFolder = new Label(shell, SWT.NONE);
		lblWritableScratchFolder.setAlignment(SWT.RIGHT);
		lblWritableScratchFolder.setBounds(10, 55, 144, 15);
		lblWritableScratchFolder.setText("Writable Scratch Folder:");
		
		Label lblModulePath = new Label(shell, SWT.NONE);
		lblModulePath.setAlignment(SWT.RIGHT);
		lblModulePath.setBounds(47, 82, 107, 15);
		lblModulePath.setText("Module Path:");
		
		if(SW_main.gp.displayFontSize == 0)
			smallFontRadioButton.setSelection(true);
		else if(SW_main.gp.displayFontSize == 1)
			mediumFontRadioButton.setSelection(true);
		else if(SW_main.gp.displayFontSize == 2)
			largerFontRadioButton.setSelection(true);
		else if(SW_main.gp.displayFontSize == 3)
			largestFontRadioButton.setSelection(true);
		else
			mediumFontRadioButton.setSelection(true);
		
		// Button Listeners
		OK_Button.addSelectionListener(new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				SW_main.gp.default_folder = DefaultDataFolderText.getText();
				SW_main.gp.scratch_folder = textScratchFolder.getText();
				SW_main.gp.module_folder = textModulePath.getText();
				SW_main.gp.auto_save = AutoSaveButton.getSelection();
				SW_main.gp.auto_load = AutoLoadButton.getSelection();
				
				if(smallFontRadioButton.getSelection())
				{
					SW_main.gp.displayFontSize = 0;		
					SW_main.SMALL_FONT = 10;	SW_main.MEDIUM_FONT = 12; 	SW_main.BIG_FONT = 14;
				}
				else if(mediumFontRadioButton.getSelection())
				{
					SW_main.gp.displayFontSize = 1;
					SW_main.SMALL_FONT = 12;	SW_main.MEDIUM_FONT = 14; 	SW_main.BIG_FONT = 16;
				}
				else if(largerFontRadioButton.getSelection())
				{
					SW_main.gp.displayFontSize = 2;
					SW_main.SMALL_FONT = 14;	SW_main.MEDIUM_FONT = 16; 	SW_main.BIG_FONT = 18;
				}
				else if(largestFontRadioButton.getSelection())
				{
					SW_main.gp.displayFontSize = 3;
					SW_main.SMALL_FONT = 16;	SW_main.MEDIUM_FONT = 18; 	SW_main.BIG_FONT = 20;
				}
							
				PreferenceUtil.setPrefs();			// save choice in registry
				shell.dispose();
				SW_main.update_spect = true;		// update display to reflect changes
				SW_main.canvas.redraw();
			}
		});
		
		CancelButton.addSelectionListener(new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				shell.dispose();
			}
		});

	}
}
