/**
 * 
 */
package simulation;

import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.events.FocusListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Text;
import org.eclipse.wb.swt.SWTResourceManager;

import spinworks.SW_main;
import spinworks.Util;

import org.eclipse.swt.widgets.Label;

/**
 * @author marat
 *
 */
public class SimOptionsDialog extends Dialog 
{
	protected Object result;
	protected Shell shell;
	private Text textDisplayLinewidth;
	private Text textGrouping;
	private Text textTransitionThreshold;
	private Text textSize;
	private Text textDisplayWidth;
	private Text textOffset;
	private Text textSpectFreq;
	private Text textMaxIter;
	private Text textRMS_Convergence;
	private Text textRMS_Autoassign;
	private Text textAllowVar;
	private Text textRMS_FactorAutoassign;
	private Text textRMS_FactorAutoignore;
	private Text textIterationsBetween;
	private Text textDisplayWidthPPM;
	private Text textOffsetPPM;
	private Label lblMaximumIterations;
	private Label lblRmsForConvergence;
	private Label lblRmsForAutoassign;
	private Label lblAllowableVarIn;
	private Label lblRmsFactorFor;
	private Label lblRmsFactorFor_1;
	private Label lblIterationsBetweenEach;

	/**
	 * Create the dialog.
	 * @param parent
	 * @param style
	 */
	public SimOptionsDialog(Shell parent, int style) 
	{
		super(parent, style);
		setText("SWT Dialog");
	}

	/**
	 * Open the dialog.
	 * @return the result
	 */
	public Object open() 
	{
		createContents();
		shell.open();
		shell.layout();
		Display display = getParent().getDisplay();
		while (!shell.isDisposed()) 
		{
			if (!display.readAndDispatch()) 
			{
				display.sleep();
			}
		}
		return result;
	}

	/**
	 * Create contents of the dialog.
	 */
	private void createContents() 
	{
		shell = new Shell(getParent(), getStyle());
		shell.setSize(486, 583);
		shell.setText("Simulation Options");
		
//	First Group (Display Parameters)
		Group groupSimulationDisplay = new Group(shell, SWT.BORDER);
		groupSimulationDisplay.setText("Simulation Display");
		groupSimulationDisplay.setBounds(10, 10, 460, 239);
		
		textDisplayLinewidth = new Text(groupSimulationDisplay, SWT.BORDER);
		textDisplayLinewidth.setBounds(233, 26, 76, 21);
		textDisplayLinewidth.setText(String.format("%.3f", SW_main.sp.linewidth));
		
		textGrouping = new Text(groupSimulationDisplay, SWT.BORDER);
		textGrouping.setBounds(233, 53, 76, 21);
		textGrouping.setText(String.format("%.3f", SW_main.sp.group_linewidth));
		
		textTransitionThreshold = new Text(groupSimulationDisplay, SWT.BORDER);
		textTransitionThreshold.setBounds(233, 80, 76, 21);
		textTransitionThreshold.setText(String.format("%.5f", SW_main.sp.trans_thresh));
		
		textSize = new Text(groupSimulationDisplay, SWT.BORDER);
		textSize.setBounds(233, 107, 76, 21);
		
		textDisplayWidth = new Text(groupSimulationDisplay, SWT.BORDER);
		textDisplayWidth.setBounds(233, 134, 76, 21);
		
		textOffset = new Text(groupSimulationDisplay, SWT.BORDER);
		textOffset.setBounds(233, 161, 76, 21);
		
		textSpectFreq = new Text(groupSimulationDisplay, SWT.BORDER);
		textSpectFreq.setBounds(233, 188, 76, 21);
		
		textDisplayWidthPPM = new Text(groupSimulationDisplay, SWT.BORDER);
		textDisplayWidthPPM.setBounds(325, 134, 76, 21);
		
		textOffsetPPM = new Text(groupSimulationDisplay, SWT.BORDER);
		textOffsetPPM.setBounds(325, 161, 76, 21);
		
		
		/*if (!expt_exists)	// from .NET version  why???
		{
            dlg.offset = String.Format(num_format, "{0:F3}", q.offset);
            dlg.sw = String.Format(num_format, "{0:F3}", q.SFO1 * q.SW);
            dlg.sf = String.Format(num_format, "{0:F7}", q.SFO1);
            dlg.size = String.Format(num_format, "{0}", q.SI);
		}*/
		
		// in an if block??? is no expt data???
		textSize.setText(String.format("%d", SW_main.q.SI));		
		textDisplayWidth.setText(String.format("%.3f", SW_main.q.SFO1 * SW_main.q.SW));								
		textDisplayWidthPPM.setText(String.format("%.3f", SW_main.q.SW));		
		textOffset.setText(String.format("%.3f", SW_main.q.offset));
		textOffsetPPM.setText(String.format("%.3f", SW_main.q.offset / SW_main.q.SFO1));
		textSpectFreq.setText(String.format("%.7f", SW_main.q.SFO1));
		
		// changes in par with two freq units
		textDisplayWidth.addFocusListener(new FocusListener() 
		{			
			@Override
			public void focusGained(FocusEvent arg0) 
			{				}	// Why necessary??

			@Override
			public void focusLost(FocusEvent arg0) 
			{
				try
				{	
					double temp = Double.parseDouble(textDisplayWidth.getText());	
					textDisplayWidthPPM.setText(String.format("%.3f", temp / SW_main.q.SFO1));
				}
				catch(Exception ex){  ex.printStackTrace();	}			
			}
		});
		
		textDisplayWidthPPM.addFocusListener(new FocusListener() 
		{			
			@Override
			public void focusGained(FocusEvent arg0) 
			{				}	// Why necessary??

			@Override
			public void focusLost(FocusEvent arg0) 
			{
				try
				{	
					double temp = Double.parseDouble(textDisplayWidthPPM.getText());	
					textDisplayWidth.setText(String.format("%.3f", temp * SW_main.q.SFO1));
				}
				catch(Exception ex){	ex.printStackTrace();	}		
			}
		});

		textOffset.addFocusListener(new FocusListener() 
		{			
			@Override
			public void focusGained(FocusEvent arg0) 
			{				}	// Why necessary??

			@Override
			public void focusLost(FocusEvent arg0) 
			{
				try
				{	
					double temp = Double.parseDouble(textOffset.getText());	
					textOffsetPPM.setText(String.format("%.3f", temp / SW_main.q.SFO1));
				}
				catch(Exception ex){	ex.printStackTrace();	}			
			}
		});
		

		textOffsetPPM.addFocusListener(new FocusListener() 
		{			
			@Override
			public void focusGained(FocusEvent arg0) 
			{				}	// Why necessary??

			@Override
			public void focusLost(FocusEvent arg0) 
			{
				try
				{
					double temp = Double.parseDouble(textOffsetPPM.getText());
					textOffset.setText(String.format("%.3f", temp * SW_main.q.SFO1));
				}
				catch(Exception ex){	ex.printStackTrace();	}
			}
		});
		
		final Button buttonLorentz = new Button(groupSimulationDisplay, SWT.RADIO);
		buttonLorentz.setBounds(325, 31, 90, 16);
		buttonLorentz.setText("Lorentzian");
		if(SW_main.sp.lineshape == 0)
			buttonLorentz.setSelection(true);
		
		final Button buttonGauss = new Button(groupSimulationDisplay, SWT.RADIO);
		buttonGauss.setBounds(325, 58, 90, 16);
		buttonGauss.setText("Gaussian");
		if(SW_main.sp.lineshape == 1)
			buttonGauss.setSelection(true);
		
//	Labels		
		Label lblDisplayLinewidthhz = new Label(groupSimulationDisplay, SWT.NONE);
		lblDisplayLinewidthhz.setAlignment(SWT.RIGHT);
		lblDisplayLinewidthhz.setBounds(54, 29, 160, 15);
		lblDisplayLinewidthhz.setText("Display Linewidth (Hz):");
		
		Label lblGroupinghz = new Label(groupSimulationDisplay, SWT.NONE);
		lblGroupinghz.setAlignment(SWT.RIGHT);
		lblGroupinghz.setBounds(79, 56, 135, 15);
		lblGroupinghz.setText("Grouping (Hz):");
		
		Label lblTransitionThreshold = new Label(groupSimulationDisplay, SWT.NONE);
		lblTransitionThreshold.setAlignment(SWT.RIGHT);
		lblTransitionThreshold.setBounds(69, 83, 145, 15);
		lblTransitionThreshold.setText("Transition Threshold:");
		
		Label lblSizepoints = new Label(groupSimulationDisplay, SWT.NONE);
		lblSizepoints.setAlignment(SWT.RIGHT);
		lblSizepoints.setBounds(69, 110, 145, 15);
		lblSizepoints.setText("Size (points):");
		
		Label lblDisplayWidthhzppm = new Label(groupSimulationDisplay, SWT.NONE);
		lblDisplayWidthhzppm.setAlignment(SWT.RIGHT);
		lblDisplayWidthhzppm.setBounds(44, 137, 170, 15);
		lblDisplayWidthhzppm.setText("Display Width (Hz/PPM):");
		
		Label lblFreqOfLeftmost = new Label(groupSimulationDisplay, SWT.NONE);
		lblFreqOfLeftmost.setAlignment(SWT.RIGHT);
		lblFreqOfLeftmost.setBounds(0, 164, 214, 15);
		lblFreqOfLeftmost.setText("Freq. of Leftmost Point (Hz/PPM):");
		
		Label lblSpectrometerFrequencymhz = new Label(groupSimulationDisplay, SWT.NONE);
		lblSpectrometerFrequencymhz.setAlignment(SWT.RIGHT);
		lblSpectrometerFrequencymhz.setBounds(0, 191, 214, 15);
		lblSpectrometerFrequencymhz.setText("Spectrometer Frequency (MHz):");

		
//	Second Group (Iteration Parameters)
		Group groupIterationParameters = new Group(shell, SWT.BORDER);
		groupIterationParameters.setText("Iteration Parameters");
		groupIterationParameters.setBounds(10, 264, 460, 239);
		
		textMaxIter = new Text(groupIterationParameters, SWT.BORDER);
		textMaxIter.setBounds(233, 22, 76, 21);
		textMaxIter.setText(String.format("%d", SW_main.sp.itrlim));
		
		textRMS_Convergence = new Text(groupIterationParameters, SWT.BORDER);
		textRMS_Convergence.setBounds(233, 49, 76, 21);
		textRMS_Convergence.setText(String.format("%.4f", SW_main.sp.rmslim));
		
		textRMS_Autoassign = new Text(groupIterationParameters, SWT.BORDER);
		textRMS_Autoassign.setBounds(233, 76, 76, 21);
		textRMS_Autoassign.setText(String.format("%.4f", SW_main.sp.asnrms));
		
		textAllowVar = new Text(groupIterationParameters, SWT.BORDER);
		textAllowVar.setBounds(233, 103, 76, 21);
		textAllowVar.setText(String.format("%.1f", SW_main.sp.rngfra * 100.0)); // as %
		
		textRMS_FactorAutoassign = new Text(groupIterationParameters, SWT.BORDER);
		textRMS_FactorAutoassign.setBounds(233, 130, 76, 21);
		textRMS_FactorAutoassign.setText(String.format("%.3f", SW_main.sp.asnlim));
		
		textRMS_FactorAutoignore = new Text(groupIterationParameters, SWT.BORDER);
		textRMS_FactorAutoignore.setBounds(233, 157, 76, 21);
		textRMS_FactorAutoignore.setText(String.format("%.3f", SW_main.sp.ignlim));
		
		textIterationsBetween = new Text(groupIterationParameters, SWT.BORDER);
		textIterationsBetween.setBounds(233, 184, 76, 21);
		textIterationsBetween.setText(String.format("%d", SW_main.sp.asnmod));
		
		final Button buttonOptimize = new Button(groupIterationParameters, SWT.CHECK);
		buttonOptimize.setBounds(325, 24, 93, 16);
		buttonOptimize.setText("Optimize");
		if(SW_main.sp.optmiz == 1)
			buttonOptimize.setSelection(true);
		
		final Button buttonAutoassign = new Button(groupIterationParameters, SWT.CHECK);
		buttonAutoassign.setBounds(325, 51, 93, 16);
		buttonAutoassign.setText("Autoassign");
		if(SW_main.sp.autasn == 1)
			buttonAutoassign.setSelection(true);
		
		final Button buttonAutoignore = new Button(groupIterationParameters, SWT.CHECK);
		buttonAutoignore.setBounds(325, 78, 93, 16);
		buttonAutoignore.setText("Autoignore");
		if(SW_main.sp.autdel == 1)
			buttonAutoignore.setSelection(true);

//	Labels
		lblMaximumIterations = new Label(groupIterationParameters, SWT.RIGHT);
		lblMaximumIterations.setBounds(61, 25, 153, 15);
		lblMaximumIterations.setText("Maximum Iterations:");
		
		lblRmsForConvergence = new Label(groupIterationParameters, SWT.RIGHT);
		lblRmsForConvergence.setBounds(45, 52, 169, 15);
		lblRmsForConvergence.setText("RMS for Convergence:");
		
		lblRmsForAutoassign = new Label(groupIterationParameters, SWT.RIGHT);
		lblRmsForAutoassign.setBounds(45, 79, 169, 15);
		lblRmsForAutoassign.setText("RMS for Autoassign:");
		
		lblAllowableVarIn = new Label(groupIterationParameters, SWT.NONE);
		lblAllowableVarIn.setAlignment(SWT.RIGHT);
		lblAllowableVarIn.setBounds(13, 106, 201, 15);
		lblAllowableVarIn.setText("Allowable Var. in Parameters (%):");
		
		lblRmsFactorFor = new Label(groupIterationParameters, SWT.NONE);
		lblRmsFactorFor.setAlignment(SWT.RIGHT);
		lblRmsFactorFor.setBounds(23, 133, 191, 15);
		lblRmsFactorFor.setText("RMS Factor for Autoassign:");
		
		lblRmsFactorFor_1 = new Label(groupIterationParameters, SWT.NONE);
		lblRmsFactorFor_1.setAlignment(SWT.RIGHT);
		lblRmsFactorFor_1.setBounds(10, 160, 204, 15);
		lblRmsFactorFor_1.setText("RMS Factor for Autoignore:");
		
		lblIterationsBetweenEach = new Label(groupIterationParameters, SWT.NONE);
		lblIterationsBetweenEach.setAlignment(SWT.RIGHT);
		lblIterationsBetweenEach.setBounds(13, 187, 201, 15);
		lblIterationsBetweenEach.setText("Iterations Between Each Auto:");

//-------------------------------------------------------------------------------------------------
		Button buttonOK = new Button(shell, SWT.NONE);		
		buttonOK.setBounds(314, 519, 75, 25);
		buttonOK.setFont(SWTResourceManager.getBoldFont(buttonOK.getFont()));
		buttonOK.setBackground(shell.getDisplay().getSystemColor(SWT.COLOR_GREEN));
		buttonOK.setText("OK");
		shell.setDefaultButton(buttonOK);
		
		buttonOK.addSelectionListener(new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				// retrieve 1st group results here
				
				try
				{
					SW_main.sp.linewidth = Double.parseDouble(textDisplayLinewidth.getText());
					SW_main.sp.group_linewidth = Double.parseDouble(textGrouping.getText());
					SW_main.sp.trans_thresh = Double.parseDouble(textTransitionThreshold.getText());	
					if(SW_main.gp.data_array == null)	// no experimental data available
					{
						// get spectrometer frequency first, because of calculation of SW
						SW_main.q.SFO1 = Double.parseDouble(textSpectFreq.getText());
						SW_main.q.SI = Integer.parseInt(textSize.getText());
						SW_main.q.SW = Double.parseDouble(textDisplayWidth.getText()) 
								/ SW_main.q.SFO1;
						SW_main.q.offset = Double.parseDouble(textOffset.getText());					
					}

					if(buttonLorentz.getSelection())
						SW_main.sp.lineshape = 0;
					else if(buttonGauss.getSelection())
						SW_main.sp.lineshape = 1;

					// now the second group
					SW_main.sp.itrlim = Integer.parseInt(textMaxIter.getText());
					SW_main.sp.rmslim = Double.parseDouble(textRMS_Convergence.getText());
					SW_main.sp.asnrms = Double.parseDouble(textRMS_Autoassign.getText());
					SW_main.sp.rngfra = Double.parseDouble(textAllowVar.getText()) / 100.0;
					SW_main.sp.asnlim = Double.parseDouble(textRMS_FactorAutoassign.getText());
					SW_main.sp.ignlim = Double.parseDouble(textRMS_FactorAutoignore.getText());
					SW_main.sp.asnmod = Integer.parseInt(textIterationsBetween.getText());

					if(buttonOptimize.getSelection())
						SW_main.sp.optmiz = 1;
					else
						SW_main.sp.optmiz = 0;

					if(buttonAutoassign.getSelection())
						SW_main.sp.autasn = 1;
					else
						SW_main.sp.autasn = 0;

					if(buttonAutoignore.getSelection())
						SW_main.sp.autdel = 1;
					else
						SW_main.sp.autdel = 0;

					// update "current" spin system
					String target;
					if (SW_main.gp.data_array == null || SW_main.q.data_folder.length() < 2)
						target = SW_main.gp.scratch_folder + "/spin_system";
					else
						target = 	SW_main.q.data_folder + "spin_system";	// data_folder already has trailing "/"
					if (SW_main.gp.log_on) Util.log_error("Edit Chemical Shifts: writing spin system to: " + target);	            
					SS_util.write_spins(target, SW_main.gp, SW_main.sp, SW_main.q);
				}
				catch(Exception ex)
				{
					ex.printStackTrace();
					Util.show_and_log("Error decoding entry, check your input", ex.getMessage());
				}
		            
				shell.dispose();
			}
		});
		
//-------------------------------------------------------------------------------------------------
		Button buttonCancel = new Button(shell, SWT.NONE);	
		buttonCancel.setBounds(395, 519, 75, 25);
		buttonCancel.setFont(SWTResourceManager.getBoldFont(buttonCancel.getFont()));
		buttonCancel.setBackground(shell.getDisplay().getSystemColor(SWT.COLOR_RED));
		buttonCancel.setText("Cancel");
		
		buttonCancel.addSelectionListener(new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				shell.dispose();
			}
		});
		
	}	// end createContents
//-------------------------------------------------------------------------------------------------
}	// end class
