/**
 * 
 */
package spinworks;

import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;

import simulation.SimPar;
import spinworks.SW_main.modes;
import spinworks.SW_main.modes_3D;

import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.events.FocusListener;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseWheelListener;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.widgets.Button;

/**
 * @author marat
 *
 */
public class ChildDataWindow extends Dialog 
{
	protected Object result;
	protected Shell shell;
	protected Canvas canvas;
	
	private global_par gp;							// local global parameter structure
	private data_par q;								// link (pointer) to data parameters	
	private data_par q_ind;							// data parameters in the current indirect dimension
	private boolean update_spect;
	private boolean linkExpansion = true;
	
	/*static*/ Image image;			// Could possible be made static to save memory?
	/*static*/ GC gcImage;
	
	private int cursor_x = 0, cursor_y = 0;
	private int windowNumber = 0;
	private int workSpace = 0;
	private int cursorAxis = 2;						// which axis to use for linked cursor
	
/**
 * Create the dialog.
 * @param parent
 * @param style
 */
	public ChildDataWindow(Shell parent, int _windowNumber, int _workSpace, int style) 
	{
		super(parent, style);
		windowNumber = _windowNumber;	
		workSpace = _workSpace;
			
//		somewhat wasteful, but create a separate global parameter structure for each
//		child window
		
		try {	gp = (global_par) SW_main.gp.clone();	} 
		catch (CloneNotSupportedException ex) {	 ex.printStackTrace(); 	}
		
		// duplicate contouring levels and other objects here, as clone copies references to objects
		// perhaps move this to a method?
		gp.pos_level = new Level[16];
		gp.neg_level = new Level[16];
				
		for (int i = 0; i < SW_main.MAX_LEVELS; i++)	// duplicate contouring levels
		{
			try
			{								
				gp.pos_level[i] = new Level();
				gp.neg_level[i] = new Level();
				
				gp.pos_level[i].red = SW_main.gp.pos_level[i].red;
				gp.pos_level[i].green = SW_main.gp.pos_level[i].green;
				gp.pos_level[i].blue = SW_main.gp.pos_level[i].blue;
				gp.pos_level[i].value = SW_main.gp.pos_level[i].value;
							
				gp.neg_level[i].red = SW_main.gp.neg_level[i].red;
				gp.neg_level[i].green = SW_main.gp.neg_level[i].green;
				gp.neg_level[i].blue = SW_main.gp.neg_level[i].blue;
				gp.neg_level[i].value = SW_main.gp.neg_level[i].value;
			}
			catch(Exception ex)
			{
				ex.printStackTrace();
				return;
			}
		}
			
		gp.peaks = new PeakInfo[gp.n_peaks];
		for(int i = 0; i < gp.n_peaks; i++)
		{
			gp.peaks[i] = new PeakInfo();
			gp.peaks[i].col = SW_main.gp.peaks[i].col;
			gp.peaks[i].cosy = SW_main.gp.peaks[i].cosy;
			gp.peaks[i].cosy_f1 = SW_main.gp.peaks[i].cosy_f1;
			gp.peaks[i].freq = SW_main.gp.peaks[i].freq;
			gp.peaks[i].freq_f1 = SW_main.gp.peaks[i].freq_f1;
			gp.peaks[i].freq_iterate = SW_main.gp.peaks[i].freq_iterate;
			gp.peaks[i].gauss = SW_main.gp.peaks[i].gauss;
			gp.peaks[i].gauss_iterate = SW_main.gp.peaks[i].gauss_iterate;
			gp.peaks[i].hmbc = SW_main.gp.peaks[i].hmbc;
			gp.peaks[i].hmbc_f1 = SW_main.gp.peaks[i].hmbc_f1;
			gp.peaks[i].intensity = SW_main.gp.peaks[i].intensity;
			gp.peaks[i].intensity_iterate = SW_main.gp.peaks[i].intensity_iterate;
			gp.peaks[i].label = SW_main.gp.peaks[i].label;
			gp.peaks[i].n_cosy = SW_main.gp.peaks[i].n_cosy;
			gp.peaks[i].n_hmbc = SW_main.gp.peaks[i].n_hmbc;
			gp.peaks[i].n_tocsy = SW_main.gp.peaks[i].n_tocsy;
			gp.peaks[i].noesy = SW_main.gp.peaks[i].noesy;
			gp.peaks[i].noesy_f1 = SW_main.gp.peaks[i].noesy_f1;
			gp.peaks[i].tocsy = SW_main.gp.peaks[i].tocsy;
			gp.peaks[i].tocsy_f1 = SW_main.gp.peaks[i].tocsy_f1;
			gp.peaks[i].width = SW_main.gp.peaks[i].width;
			gp.peaks[i].width_iterate = SW_main.gp.peaks[i].width_iterate;
		}
		
		gp.integrals = new IntegInfo[gp.n_integrals];
		for(int i = 0; i < gp.n_integrals; i++)
		{
			gp.integrals[i] = new IntegInfo();
			gp.integrals[i].bias = SW_main.gp.integrals[i].bias;
			gp.integrals[i].end = SW_main.gp.integrals[i].end;
			gp.integrals[i].end_f1 = SW_main.gp.integrals[i].end_f1;
			gp.integrals[i].label = SW_main.gp.integrals[i].label;
			gp.integrals[i].point1 = SW_main.gp.integrals[i].point1;
			gp.integrals[i].point2 = SW_main.gp.integrals[i].point2;
			gp.integrals[i].point1_f1 = SW_main.gp.integrals[i].point1_f1;
			gp.integrals[i].point2_f1 = SW_main.gp.integrals[i].point2_f1;
			gp.integrals[i].scaled = SW_main.gp.integrals[i].scaled;
			gp.integrals[i].slope = SW_main.gp.integrals[i].slope;
			gp.integrals[i].start = SW_main.gp.integrals[i].start;
			gp.integrals[i].start_f1 = SW_main.gp.integrals[i].start_f1;
			gp.integrals[i].value = SW_main.gp.integrals[i].value;
		}
		
		// clone data parameters
		try {	q = (data_par) SW_main.q.clone();	} 
		catch (CloneNotSupportedException ex) {	 ex.printStackTrace(); 	}
		
		try
		{
			if(q.data_mode == SW_main.modes.MODE_3D && SW_main.gp.mode_3D == modes_3D.XY )
				q_ind = (data_par) SW_main.q_f2.clone();	// 3D in XY mode
			else
				q_ind = (data_par) SW_main.q_f1.clone();	// 1D, 2D, or 3D in XZ mode
		}		
		catch (CloneNotSupportedException ex) {	ex.printStackTrace();	}
		
		//TODO clone sp as well		
		
		setText(String.format("Window %d   Workspace %d    %s", windowNumber + 1, workSpace + 1,
				q.data_folder));		
								
		gp.cursor_flag = 0;	// so no stray cursors
	}

/**
 * Open the dialog.
 * @return the result
 */
	public Object open() 
	{
		SW_main.nChildWindows++;
		SW_main.childWindowActive[windowNumber] = true;
		
		createContents();
		shell.open();
		shell.layout();
		Display display = getParent().getDisplay();
		
		while (!shell.isDisposed()) 
		{
			if (!display.readAndDispatch()) 
			{
				display.sleep();
			}
		}		
		return result;
	}

/**
 * Create contents of the dialog.
 */
	private void createContents() 
	{
		shell = new Shell(getParent(), SWT.DIALOG_TRIM | SWT.RESIZE | SWT.MIN);
		shell.setSize(gp.dxsize + 15, gp.dysize + 40);	//TODO need better way to do this
		shell.setText(getText());
		
		//	The graphics canvas
		canvas = new Canvas(shell, SWT.NO_BACKGROUND | SWT.BORDER);
		canvas.setBounds(0, 0, 595, 542);	// will be reset with resize event
		
		//	Buttons used to specify which axis to link cursor 1D to 2D
		final Button cursorAxisButton = new Button(canvas, SWT.NONE);
		cursorAxisButton.setBounds(gp.dxsize - 50, 0, 50, 25);
		cursorAxisButton.setText("F1");
		cursorAxisButton.setToolTipText("Use as F1 reference");
		if(gp.display_mode == modes.MODE_2D)
			cursorAxisButton.setVisible(false); 	// only applicable in 1D
		
		//	Listener for the cursorAxisButton
		cursorAxisButton.addSelectionListener(new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				if(cursorAxis == 2)
				{
					cursorAxis = 1;
					cursorAxisButton.setText("F2");
					cursorAxisButton.setToolTipText("Use as F2 reference");
				}
				else
				{
					cursorAxis = 2;
					cursorAxisButton.setText("F1");
					cursorAxisButton.setToolTipText("Use as F1 reference");
				}				
			}
		});	
				
//		Buttons used to specify which axis to link cursor 1D to 2D
		final Button linkExpansionButton = new Button(canvas, SWT.NONE);
		linkExpansionButton.setBounds(gp.dxsize - 126, 0, 75, 25);
		linkExpansionButton.setText("Unlink");
		linkExpansionButton.setToolTipText("Unlink expansion from main window");
			
		// listener for link expansion button
		linkExpansionButton.addSelectionListener(new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				if(linkExpansion)
				{
					linkExpansion = false;
					linkExpansionButton.setText("Link");
					linkExpansionButton.setToolTipText("Link expansion from main window");
				}
				else
				{
					linkExpansion = true;
					linkExpansionButton.setText("Unink");
					linkExpansionButton.setToolTipText("Unlink expansion from main window");
				}
			}
		});
			
		// paint listener, updates graphics canvas
        canvas.addPaintListener(new PaintListener()
        { 
            public void paintControl(PaintEvent e)
            {                   
                if(update_spect)
                {            	
                	//	Fix for MacOS Graphics bug! //////////////
                	//	necessary to dispose and re-create spectral bitmap every time spectrum is updated.
                	if(image != null) image.dispose();
            		if(gcImage != null)gcImage.dispose();
            		image = new Image(shell.getDisplay(), canvas.getBounds());
            		gcImage = new GC(image);
            		///////////////////
            		
                	// drawing routines here
            		
            		if(update_spect)
            		{
            			if(gp.display_mode == modes.MODE_1D)
            			{       
            				// TODO pass actual cloned SimPar
            				GraphUtil.draw_1D_view(gcImage, gp, new SimPar(), q, q_ind); 
            			}
            			else if(gp.display_mode == modes.MODE_2D)
            			{
            				GraphUtil2D.draw_2D_view(gcImage,  gp,  q,  q_ind,  false);
            			}
            		}
            		
                	update_spect = false;
                }
 
                e.gc.drawImage(image, 0, 0);				// map bitmap to screen
                
                e.gc.setForeground(gp.cursor_colour);
                if(gp.display_mode == modes.MODE_1D)
                {
                	e.gc.drawLine(cursor_x,  0, cursor_x, gp.dysize);
                	e.gc.setBackground(gp.back_colour);
                	
                	int i = (int) Math.round((q.offset
    						- (gp.freq1 - (double)cursor_x * gp.hzperpix)) / q.hzperpt);
    				if(i < 0) i = 0;
    				else if(i >= q.SI) i = q.SI -1;
    				
                	String msg;
                	if (gp.axis_unit == SW_main.units.HZ)
						msg = String.format("shift = %.3f Hz   inten. = %6.4f   abs. = %d",
								Util.pt_to_freq(cursor_x, gp), gp.data_array[i] / gp.data_max,
								(int)gp.data_array[i]);
					else
						msg = String.format("shift = %.4f ppm   inten. = %6.4f   abs. = %d",
								(Util.pt_to_freq(cursor_x, gp) / q.SF), (gp.data_array[i] / gp.data_max),
								(int)gp.data_array[i]);
                	
                	e.gc.drawText(msg, 2, 80);
                }
                else if(gp.display_mode == modes.MODE_2D)
                {
                	e.gc.drawLine(cursor_x,  gp.top_2D + 1, cursor_x, gp.dysize - gp.bottom_2D - 1);
                	e.gc.drawLine(gp.left_2D + 1,  cursor_y, gp.dxsize - gp.right_2D - 1, cursor_y);
                	
                	int i = (int) Math.round((q.offset
							- (gp.freq1 - (double)(cursor_x - gp.left_2D) * gp.hzperpix)) / q.hzperpt);
					if (i < 0) i = 0; if (i >= q.SI) i = q.SI - 1;

					int j = (int) Math.round((q_ind.offset
							- (gp.freq1_indirect - (double)(gp.dysize - gp.bottom_2D - cursor_y) 
									* gp.hzperpix_f1)) / q_ind.hzperpt);
					if (j < 0) j = 0; if (j >= q_ind.SI) j = q_ind.SI - 1;		
					
					String msg = "";
					
					if (gp.axis_unit == SW_main.units.HZ)
					{
						if(q.data_mode == modes.MODE_2D)
							msg = String.format(
									"F2 (Hz) = %.3f   F1 (Hz) = %.3f   inten. = %.3f  index: F2 = %d  F1 = %d",
									(gp.freq1 - (double)(cursor_x - gp.left_2D) * gp.hzperpix),
									(gp.freq1_indirect - (double)(gp.dysize - gp.bottom_2D - cursor_y) 
											* gp.hzperpix_f1),
									(gp.rows_real[j][i] / 1000.0), i, j);
						
						else if(q.data_mode == modes.MODE_3D && gp.mode_3D == modes_3D.XY)
							msg = String.format(
									"F3 (Hz) = %.3f   F2 (Hz) = %.3f   inten. = %.3f  index: F3 = %d  F2 = %d",
									(gp.freq1 - (double)(cursor_x - gp.left_2D) * gp.hzperpix),
									(gp.freq1_indirect - (double)(gp.dysize - gp.bottom_2D - cursor_y) 
											* gp.hzperpix_f1),
									(gp.rows_real[j][i] / 1000.0), i, j);
						
						else if(q.data_mode == modes.MODE_3D && gp.mode_3D == modes_3D.XZ)
							msg = String.format(
									"F3 (Hz) = %.3f   F1 (Hz) = %.3f   inten. = %.3f  index: F2 = %d  F1 = %d",
									(gp.freq1 - (double)(cursor_x - gp.left_2D) * gp.hzperpix),
									(gp.freq1_indirect - (double)(gp.dysize - gp.bottom_2D - cursor_y) 
											* gp.hzperpix_f1),
									(gp.rows_real[j][i] / 1000.0), i, j);
					}	// Hz
					else	// PPM
					{
						if(q.data_mode == modes.MODE_2D)
							msg = String.format(
									"F2 (ppm) = %.4f   F1 (ppm) = %.4f  inten. = %.3f  index: F2 = %d  F1 = %d",
									((gp.freq1 - (double)(cursor_x- gp.left_2D) * gp.hzperpix) / q.SF),
									((gp.freq1_indirect - (double)(gp.dysize - gp.bottom_2D - cursor_y) 
											* gp.hzperpix_f1) / q_ind.SF),
									(gp.rows_real[j][i] / 1000.0), i, j);
						
						else if(q.data_mode == modes.MODE_3D && gp.mode_3D == modes_3D.XY)
							msg = String.format(
									"F3 (ppm) = %.4f   F2 (ppm) = %.4f  inten. = %.3f  index: F3 = %d  F2 = %d",
									((gp.freq1 - (double)(cursor_x- gp.left_2D) * gp.hzperpix) / q.SF),
									((gp.freq1_indirect - (double)(gp.dysize - gp.bottom_2D - cursor_y) 
											* gp.hzperpix_f1) / q_ind.SF),
									(gp.rows_real[j][i] / 1000.0), i, j);
						
						else if(q.data_mode == modes.MODE_3D && gp.mode_3D == modes_3D.XZ)
							msg = String.format(
									"F3 (ppm) = %.4f   F1 (ppm) = %.4f  inten. = %.3f  index: F3 = %d  F1 = %d",
									((gp.freq1 - (double)(cursor_x- gp.left_2D) * gp.hzperpix) / q.SF),
									((gp.freq1_indirect - (double)(gp.dysize - gp.bottom_2D - cursor_y) 
											* gp.hzperpix_f1) / q_ind.SF),
									(gp.rows_real[j][i] / 1000.0), i, j);
					}	// PPM
					
					// draw the information
					e.gc.setBackground(gp.back_colour);
					e.gc.drawText(msg, gp.left_2D + 5, 60);
                }
            }     
        }); 
        
		// window has been resized
        shell.addListener (SWT.Resize,  new Listener () 
        {   
        	/**
        	 * @param arg0
        	 */
        	@Override
        	public void handleEvent(Event arg0)
        	{ 
        		Rectangle rect = shell.getClientArea();            		
        		gp.dxsize = rect.width; gp.dysize = rect.height;   
        		cursorAxisButton.setBounds(gp.dxsize - 50, 0, 50, 25);
        		linkExpansionButton.setBounds(gp.dxsize - 126, 0, 75, 25);
        		canvas.setBounds(0, 0, gp.dxsize, gp.dysize);   			  	
        		gp.new_2D_view = true;
        		update_spect = true;
        		canvas.redraw();  		// triggers paint listener
        	}
        });
        
        // window has been moved (necessary??)
        shell.addListener (SWT.Move,  new Listener () 
        {   
        	/**
        	 * @param arg0
        	 */
        	@Override
        	public void handleEvent(Event arg0)
        	{    			
        	}
        }); 

        // this child window has been closed (necessary?)
        shell.addListener (SWT.Close,  new Listener () 
        {   
        	/**
        	 * @param arg0
        	 */
        	@Override
        	public void handleEvent(Event arg0)
        	{  
        		SW_main.childWindowActive[windowNumber] = false;
        	}
        });      
               
        // mouse wheel listener (vertical scale in 1D and 2D)
        canvas.addMouseWheelListener(new MouseWheelListener() 
        {
			@Override
			public void mouseScrolled(MouseEvent e) 
			{     
				if(gp.display_mode == modes.MODE_1D)
				{
					if(e.count > 0)
						gp.expt_scale *= 1.10;
					else
						gp.expt_scale /= 1.10;

					gp.new_2D_view = true;
					update_spect = true;
					canvas.redraw();
				}
        		
				else if(gp.display_mode == modes.MODE_2D)
				{
					if (e.y > gp.top_2D && e.y < (gp.dysize - gp.top_2D)
							&& e.x > gp.left_2D && e.x < (gp.dxsize - gp.right_2D))
					{	// in data area
						if (e.count < 0)
						{
							Util_2D.rescale_floor_2D(1.20, gp);
							Util_2D.rescale_ceiling_2D(1.20, gp);
						}
						else
						{
							Util_2D.rescale_floor_2D(0.8333, gp);
							Util_2D.rescale_ceiling_2D(0.8333, gp);
						}

						gp.new_2D_view = true;	// need to re-contour
						update_spect = true;
						canvas.redraw();
						return;
					} 
				}    		
			}	// public void mouseScrolled(MouseEvent e)
        });   
         
        // focus listeners
        canvas.addFocusListener(new FocusListener()
        {	
        	@Override
        	public void focusGained(FocusEvent event) 
        	{
        	  // TODO currently unused
            }

			@Override
			public void focusLost(FocusEvent arg0) 
			{
				// TODO currently unused	
			}
        });
        
	}	// end createContents()
	
	// The limits in the main window have been updated, apply to child window
	public void updateLimits()
	{	
		if(!linkExpansion) return;		// bail out if 
		
		gp.freq1 = SW_main.gp.freq1;
		gp.freq2 = SW_main.gp.freq2;
		
		if(gp.display_mode == modes.MODE_1D && cursorAxis == 1)
		{
			gp.freq1 = SW_main.gp.freq1_indirect;
			gp.freq2 = SW_main.gp.freq2_indirect;
		}
		
		if(gp.display_mode == modes.MODE_2D)
		{
			gp.freq1_indirect = SW_main.gp.freq1_indirect;
			gp.freq2_indirect = SW_main.gp.freq2_indirect;
		}
		
		gp.new_2D_view = true;
		update_spect = true;
		canvas.redraw();
	}
	
	//	cursor moved in main window (1D).  Update child window.
	public void updateCursors(double freq)
	{
		cursor_x = Util.freq_to_pt(freq, gp.freq1, gp.hzperpix, gp.dxsize);
		//freq1 = freq;
		canvas.redraw();
	}
	
//	cursor moved in main window (2D).  Update child window.
	public void updateCursors(double freq, double freq_indirect)
	{
		if(gp.display_mode == modes.MODE_2D)	// 2D linked to 2D
		{
			cursor_x = (int)((gp.freq1 - freq) / gp.hzperpix) + gp.left_2D ;
			cursor_y = gp.dysize - gp.bottom_2D 
					- (int)((gp.freq1_indirect - freq_indirect)/gp.hzperpix_f1);
		}
		else if(gp.display_mode == modes.MODE_1D)	// 2D linked to 1D
		{
			if(cursorAxis == 2)
				cursor_x = Util.freq_to_pt(freq, gp.freq1, gp.hzperpix, gp.dxsize);
			else if(cursorAxis == 1)
				cursor_x = Util.freq_to_pt(freq_indirect, gp.freq1, gp.hzperpix, gp.dxsize);
			
			cursor_y = 0;
		}
		
		canvas.redraw();
	}
}	// end class
