package spinworks;

import java.awt.Desktop;
import java.io.File;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.MessageBox;

public class HelpMenuListeners extends SW_main
{
	public static void addHelpMenuListeners()
	{
		// display the pdf version of the manual
		helpManualItem.addSelectionListener  (new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				if (Desktop.isDesktopSupported()) // new way!  portable??
				{
				    try 
				    {
				        Desktop.getDesktop().open(new File(SW_main.parentFolder + 
				        		"/docs/SpinWorksJ.pdf"));
				    }  
				    catch (Exception ex) // IO Exception and nullPointerException??
				    {
				        Util.show_and_log("no application for this file type?? " +
				             SW_main.parentFolder + "/docs/SpinWorksJ.pdf", ex.getMessage());
				    }			    
				}
				else
					Util.show_and_log("Current desktop not supported");
			}
		});

//-------------------------------------------------------------------------------------------------
		// display a pdf fime for Help -> About
		helpAboutItem.addSelectionListener  (new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				if (Desktop.isDesktopSupported()) // new way!  portable??
				{
				    try 
				    {
				        Desktop.getDesktop().open(new File(SW_main.parentFolder + "/docs/About.pdf"));
				    }  
				    catch (Exception ex) // IO Exception and nullPointerException??
				    {
				        Util.show_and_log("no application for this file type?? " +
				             SW_main.parentFolder + "/docs/About.pdf", ex.getMessage());
				    }			    
				}
				else
					Util.show_and_log("Current desktop not supported");
			}
		});

//-------------------------------------------------------------------------------------------------
//	Show some possibly useful installation information
		
		helpPathInfoItem.addSelectionListener  (new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{	
				MessageBox messageBox = new MessageBox(shell, SWT.ICON_INFORMATION
	           			 | SWT.OK);
           	    messageBox.setMessage("parentFolder = " + SW_main.parentFolder + 
           	    		"\nJRE = " + System.getProperty("java.version") +
           	    		"\nUser home = " + System.getProperty("user.home") +
           	    		"\nJava class path = \n" + System.getProperty("java.class.path") +
           	    		"\n" + String.format("heapsize = %d", Runtime.getRuntime().totalMemory()));
           	    messageBox.setText("SpinWorks Java: Runtime Info");
           	    messageBox.open();	
			}
		});
//-------------------------------------------------------------------------------------------------
	}
}
