package spinworks;

public class InterfaceUtil extends SW_main
{
//-------------------------------------------------------------------------------------------------

//	Change to 1D mode, and set Display/Processing buttons as required
//  Note that button labels correspond to the action of the button, not the current state

		public static void set1D()
		{
			q.data_mode = modes.MODE_1D;

			rangeScaleUpButton.setVisible(false);
			vertScaleDownButton.setToolTipText("Decrease vertical scaling");
			rangeScaleDownButton.setVisible(false);
	        vertScaleUpButton.setToolTipText("Increase vertical scaling");
			disp2DButton.setVisible(false);
			posOnlyButton.setVisible(false);
			contourButton.setVisible(false);
			colButton.setVisible(false);
			clearButton.setVisible(false);
			toolbar3DMinus.setEnabled(false);
			toolbar3DPlus.setEnabled(false);
			toolbarF2scan.setEnabled(false);
			toolbarF1scan.setEnabled(false);

            if ((q.data_type == data_types.VNMR) || (q.data_type == data_types.CDFF)
                && q.nblocks > 1)
			{
            	 nextBlockButton.setVisible(true);
                 prevBlockButton.setVisible(true);
			}
			else
			{
				 nextBlockButton.setVisible(false);
		         prevBlockButton.setVisible(false);
			}
            
            scale1D_UpButton.setVisible(false);
            scale1D_DownButton.setVisible(false);

            if(gp.calc_array != null)
                statusStripLabel4.setText("  Mouse:  (set cursor,  zoom,  assign line)");
            else
                statusStripLabel4.setText("  Mouse:  (set cursor,  zoom,  pick nearest peak)");
            
            processButton.setText("Process");
            processButton.setToolTipText("Process the FID (EM + FT + Phase)");

			softButton1.setVisible(false);
			softButton2.setVisible(false);
			softButton6.setVisible(true);
			
			blPointButton.setVisible(true);

			softButton3.setText("Apply Ph");
			softButton4.setText("AutoPhase");
			softButton5.setText("Magnitude");
			softButton6.setText("PP Min.");

			set_tool_tips();
			updateToolbar();
			slider.setVisible(true);
		}
		
//-------------------------------------------------------------------------------------------------
		public static void set2D()
		{
			q.data_mode = modes.MODE_2D;

			vertScaleDownButton.setToolTipText("Decrease lowest displayed level");
			vertScaleUpButton.setToolTipText("Increase lowest displayed level");
			
			rangeScaleUpButton.setVisible(true);
			rangeScaleDownButton.setVisible(true);
			rangeScaleDownButton.setToolTipText("Decrease contour range");
			rangeScaleUpButton.setToolTipText("Increase contour range");
			
			nextBlockButton.setVisible(true);
	        prevBlockButton.setVisible(true);
	        nextBlockButton.setToolTipText("Select next 1D trace");
	        prevBlockButton.setToolTipText("Select previous 1D trace");
	            
			scale1D_UpButton.setVisible(true);
            scale1D_DownButton.setVisible(true);
            scale1D_UpButton.setToolTipText("Increase scaling of active 1D trace");
            scale1D_DownButton.setToolTipText("Decrease scaling of active 1D trace");
			
            contourButton.setVisible(true);
            disp2DButton.setVisible(true);
            
            toolbar3DMinus.setEnabled(false);
			toolbar3DPlus.setEnabled(false);
			
            toolbarF2scan.setEnabled(true);
			toolbarF1scan.setEnabled(true);
          
            if (gp.display_2D == display_modes.IMAGE)
                contourButton.setText("Contour");
            else
                contourButton.setText("Image");

            if (gp.pos_only)
                posOnlyButton.setText("Pos/Neg");
            else
                posOnlyButton.setText("Pos Only");

            disp2DButton.setText("1D Display");

            if (gp.row_col == trace_modes.ROWS)     //  now a three state button
            {
                colButton.setText("Col");
                if(gp.nslices < 1 )
                	statusStripLabel4.setText("  Mouse:  (set cursor,  zoom,  select row)");
                else
                	statusStripLabel4.setText("  Mouse:  (set cursor / select trace,  zoom,  select row)");
            }
            else if (gp.row_col == trace_modes.COLUMNS)
            {
                colButton.setText("Label");
                if(gp.nslices < 1 )
                	statusStripLabel4.setText("  Mouse:  (set cursor,  zoom,  select column)");
                else
                	statusStripLabel4.setText("  Mouse:  (set cursor / select trace,  zoom,  select column)");
            }
            else if (gp.row_col == trace_modes.LABEL)
            {
                colButton.setText("Row");
                if(gp.nslices < 1 )
                	statusStripLabel4.setText("  Mouse:  (set cursor,  zoom,  label peak)");
                else
                	statusStripLabel4.setText("  Mouse:  (set cursor / select trace,  zoom,  label peak)");
            }

           // SimButton.Visible = false;

            posOnlyButton.setVisible(true);
            colButton.setVisible(true);
            clearButton.setVisible(true);

            softButton1.setVisible(true);
            softButton2.setVisible(true);
            softButton3.setVisible(true);
            softButton4.setVisible(true);
            softButton5.setVisible(true);

            softButton6.setVisible(false);

            if (gp.display_mode == modes.MODE_2D)
            	blPointButton.setVisible(false);
            else
            	blPointButton.setVisible(false);

            processButton.setText("Proc. Both");
            processButton.setToolTipText("Process both dimensions");

            softButton1.setText("F2 Only");
            softButton2.setText("F1 Only");
            softButton3.setText("Apply Ph F2");
            softButton4.setText("Apply Ph F1");
            softButton5.setText("Magnitude");

            set_tool_tips();
            updateToolbar();
            gp.new_2D_view = true;
            slider.setVisible(false);		// no scrollbar in 2D/3D
		}
		
//-------------------------------------------------------------------------------------------------
		public static void set3D()	// TODO Update
		{
			q.data_mode = modes.MODE_3D;

			vertScaleDownButton.setToolTipText("Decrease lowest displayed level");
			vertScaleUpButton.setToolTipText("Increase lowest displayed level");
			
			rangeScaleUpButton.setVisible(true);
			rangeScaleDownButton.setVisible(true);
			rangeScaleDownButton.setToolTipText("Decrease contour range");
			rangeScaleUpButton.setToolTipText("Increase contour range");
			
			nextBlockButton.setVisible(true);
	        prevBlockButton.setVisible(true);
	        nextBlockButton.setToolTipText("Select next 1D trace");
	        prevBlockButton.setToolTipText("Select previous 1D trace");
	            
			scale1D_UpButton.setVisible(true);
            scale1D_DownButton.setVisible(true);
            scale1D_UpButton.setToolTipText("Increase scaling of active 1D trace");
            scale1D_DownButton.setToolTipText("Decrease scaling of active 1D trace");
			
            contourButton.setVisible(true);
            disp2DButton.setVisible(true);
            
            toolbar3DMinus.setEnabled(true);
			toolbar3DPlus.setEnabled(true);
			
            toolbarF2scan.setEnabled(true);
			toolbarF1scan.setEnabled(true);
          
            if (gp.display_2D == display_modes.IMAGE)
                contourButton.setText("Contour");
            else
                contourButton.setText("Image");

            if (gp.pos_only)
                posOnlyButton.setText("Pos/Neg");
            else
                posOnlyButton.setText("Pos Only");

            disp2DButton.setText("1D Display");

            if (gp.row_col == trace_modes.ROWS)     //  now a three state button
            {
                colButton.setText("Col");
                statusStripLabel4.setText("  Mouse:  (set cursor,  zoom,  select row)");
            }
            else if (gp.row_col == trace_modes.COLUMNS)
            {
                colButton.setText("Label");
                statusStripLabel4.setText("  Mouse:  (set cursor,  zoom,  select column)");
            }
            else if (gp.row_col == trace_modes.LABEL)
            {
                colButton.setText("Row");
                statusStripLabel4.setText("  Mouse:  (set cursor,  zoom,  label peak)");
            }

           // SimButton.Visible = false;

            posOnlyButton.setVisible(true);
            colButton.setVisible(true);
            clearButton.setVisible(true);

            softButton1.setVisible(true);
            softButton2.setVisible(true);
            softButton3.setVisible(true);
            softButton4.setVisible(true);
            softButton5.setVisible(true);

            softButton6.setVisible(false);

            if (gp.display_mode == modes.MODE_2D)
            	blPointButton.setVisible(false);
            else
            	blPointButton.setVisible(false);

            processButton.setText("Proc. Both");
            processButton.setToolTipText("Process both dimensions");

            softButton1.setText("F2 Only");
            softButton2.setText("F1 Only");
            softButton3.setText("Apply Ph F2");
            softButton4.setText("Apply Ph F1");
            softButton5.setText("Magnitude");

            set_tool_tips();
            updateToolbar();
            gp.new_2D_view = true;
            slider.setVisible(false);		// no scrollbar in 2D/3D
		}

//-------------------------------------------------------------------------------------------------
		public static void set_tool_tips()	// TODO not needed??
		{
			// Necessary?  better done in set1D, etc???
		}
//-------------------------------------------------------------------------------------------------
		public static void updateToolbar()	// TODO
		{
			toolBarWorkspace[aws].setToolTipText(gp.plot_title);
			
			if(q.data_type == data_types.BRUKER)
			{
				toolbarPrev.setEnabled(true);
				toolbarNext.setEnabled(true);
			}
			else
			{
				toolbarPrev.setEnabled(false);
				toolbarNext.setEnabled(false);
			}
			
			if((q.data_mode == modes.MODE_1D && gp.data_array != null)
			 ||(q.data_mode == modes.MODE_2D && gp.rows_real != null)
			 && gp.display_mode != modes.MODE_FID)
				toolbarSave.setEnabled(true);
			else
				toolbarSave.setEnabled(false);
			
			if(gp.f2_from_scan)
				SW_main.toolbarF2scan.setSelection(true);
			else
				SW_main.toolbarF2scan.setSelection(false);
			
			if(gp.f1_from_scan)
				SW_main.toolbarF1scan.setSelection(true);
			else
				SW_main.toolbarF1scan.setSelection(false);
		}
}
