package spinworks;

public class JDF_Header extends JDF_Util
{
	public JDF_Header()					// constructor, initialize defaults
    {
        data_points = new int[8];
        data_axis_type = new byte[8];
        translate = new byte[8];
        data_units = new short[8];
        data_offset_start = new int[8];
        data_offset_stop = new int[8];
        data_axis_start = new double[8];
        data_axis_stop = new double[8];
        base_freq = new double[8];
        zero_point = new double[8];
        reversed = new boolean[8];
    }

    // member variables
    public String file_identifier;	    // JEOL.NMR
    public byte endian;                 // byte ordering                (8)
    public byte major_version;
    public int minor_version;
    public byte data_dimension_number;  // number of dimension in       (12)
    public byte data_dimension_exist;   // 1 bit boolean per axis       (13)
    public byte data_type;	            // 2 bits type, 6 bits format   (14)
    public byte[] translate;            // 1 byte per axis              (16)
    public byte instrument;
    public byte[] data_axis_type;	    // 1-byte Enum per axis         (24)
    public short[] data_units;	        // Unit structure per axis
    public String title;                // Experiment title             (48)
    public byte[] data_axis_ranged;     // 4-bit Enum per axis
    public int[] data_points;	        // 4-byte unsigned per axis     (176)
    public int[] data_offset_start;     // 4-byte unsigned per axis     (208)
    public int[] data_offset_stop;      // 4-byte unsigned per axis     (240)
    public double[] data_axis_start;	// double per axis              (272)
    public double[] data_axis_stop;	    // double per axis              (336)
    public short creation_date;
    public short creation_time;
    public short revision_date;
    public short revision_time;
    public String node_name;
    public String site;
    public String author;
    public String comment;              // 128 byte comment             (680)
    public String data_axis_title1;	    // 32-byte string per axis
    public String data_axis_title2;
    public String data_axis_title3;
    public String data_axis_title4;
    public String data_axis_title5;
    public String data_axis_title6;
    public String data_axis_title7;
    public String data_axis_title8;
    public double[] base_freq;	        // double per axis              (1064)
    public double[] zero_point;	        // double per axis              (1128)
    public boolean[] reversed;	        // boolean per axis             (1192)
    public byte reserved;
    public boolean annotation_ok;	    // 1-bit boolean 
    public int history_used;
    public int history_length;
    public int param_start;             // offset of parameter block    (1212)
    public int param_length;            // length of parameter block    (1216)
    public int[] list_start;
    public int[] list_length;
    public int data_start;              // start of the data block      (1284)
    public long data_length;            // length of the data block     (1288)
    public int context_start;
    public int context_length;
    public int annote_start;
    public int annote_length;
    public int total_size;
    public byte[] unit_location;	    // 1-byte unsigned per axis 
    public byte[] extended_units1;	    // 2 12-byte unit structures 
    public byte[] extended_units2;
    // SpinWorks added
    public int n_sections;              // number of data sections
}
