package spinworks;

import java.awt.Desktop;
import java.io.File;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.KeyEvent;

import spinworks.SW_main.modes;

public class KeyHandler 
{
	public static void keyPressed(KeyEvent e)
	{
		//System.out.println(e.keyCode);
		
		if(e.character == 'f')	// full spectrum
		{
			DisplayButtons.fullButtonClick();
		}
		
		if(e.character == 'z')	// zoom between cursors
		{
			DisplayButtons.zoomButtonClick();
		}
		
		if(e.character == 'l')	// last expanded region
		{
			DisplayButtons.lastButtonClick();
		}
		
		if(e.character == 'a')	// autoassign transitions
		{
			SW_main.gp.calc_peaks[SW_main.gp.trans_index].obs_freq
				= PeakPick.autoPick(SW_main.gp.calc_peaks[SW_main.gp.trans_index].calc_freq, 
						SW_main.gp, SW_main.q, SW_main.sp);
			SW_main.update_spect = true;
			SW_main.canvas.redraw();
		}
		
		if(e.character == 'd')	// delete the currently pointed to assignment
		{
			SW_main.gp.calc_peaks[SW_main.gp.trans_index].obs_freq = 0.0;
			SW_main.update_spect = true;
			SW_main.canvas.redraw();
		}
		
		if(e.keyCode == SWT.ARROW_UP)			//  up arrow
		{
			if(SW_main.gp.display_mode == modes.MODE_1D)
				SW_main.gp.expt_scale *= 1.05;
			else	// 2D/3D
			{
				Util_2D.rescale_floor_2D(0.83333, SW_main.gp);
                Util_2D.rescale_ceiling_2D(0.83333, SW_main.gp);
				SW_main.gp.new_2D_view = true;
			}
			SW_main.update_spect = true;
			SW_main.canvas.redraw();
		}
		
		if(e.keyCode == SWT.ARROW_DOWN)			//  down arrow
		{
			if(SW_main.gp.display_mode == modes.MODE_1D)
				SW_main.gp.expt_scale /= 1.05;
			else	// 2D/3D
			{
				Util_2D.rescale_floor_2D(1.20, SW_main.gp);
                Util_2D.rescale_ceiling_2D(1.20, SW_main.gp);
				SW_main.gp.new_2D_view = true;
			}
			SW_main.update_spect = true;
			SW_main.canvas.redraw();
		}
		
		if(e.keyCode == SWT.ARROW_LEFT)			//  left arrow
		{
			SW_main.gp.trans_index = SW_main.gp.trans_index + 1;
			if (SW_main.gp.trans_index >= SW_main.sp.n_trans) SW_main.gp.trans_index = SW_main.sp.n_trans - 1;
			SW_main.update_spect = true;
			SW_main.canvas.redraw();
		}
		
		if((e.stateMask & SWT.CTRL) != 0 && (e.keyCode == SWT.ARROW_LEFT))		//  left arrow
		{																		//  bigger steps
			SW_main.gp.trans_index = SW_main.gp.trans_index + 5;
			if (SW_main.gp.trans_index >= SW_main.sp.n_trans) SW_main.gp.trans_index = SW_main.sp.n_trans - 1;
			SW_main.update_spect = true;
			SW_main.canvas.redraw();
		}
		
		if(e.keyCode == SWT.ARROW_RIGHT)		//  right arrow
		{
			SW_main.gp.trans_index = SW_main.gp.trans_index - 1;
			if (SW_main.gp.trans_index <= 0) SW_main.gp.trans_index = 0;
			SW_main.update_spect = true;
			SW_main.canvas.redraw();
		}
		
		if((e.stateMask & SWT.CTRL) != 0 && (e.keyCode == SWT.ARROW_RIGHT))		//  right arrow
		{																		// bigger steps
			SW_main.gp.trans_index = SW_main.gp.trans_index - 5;
			if (SW_main.gp.trans_index <= 0) SW_main.gp.trans_index = 0;
			SW_main.update_spect = true;
			SW_main.canvas.redraw();
		}
		
		if(e.keyCode == SWT.F1)			//  F1 (help)
		{
			if (Desktop.isDesktopSupported()) 
			{
			    try 
			    {
			        Desktop.getDesktop().open(new File(SW_main.parentFolder + "/docs/SpinWorksJ.pdf"));
			    }  
			    catch (Exception ex) // IO Exception and nullPointerException??
			    {
			        Util.show_and_log("no application for this file type?? " +
			             SW_main.parentFolder + "/docs/SpinWorksJ.pdf", ex.getMessage());
			    }			    
			}
			else
				Util.show_and_log("Current desktop not supported");
		}
		
		// set and show regions of interest
		if((e.stateMask & SWT.CTRL) != 0 && (e.keyCode == '1'))
		{
			//System.out.println("ctrl 1 was pressed");
			SW_main.gp.roi_1_f2_left = SW_main.gp.freq1;
			SW_main.gp.roi_1_f2_right = SW_main.gp.freq2;

			SW_main.gp.roi_1_f1_left = SW_main.gp.freq1_indirect;
			SW_main.gp.roi_1_f1_right = SW_main.gp.freq2_indirect;
		}
		
		if((e.stateMask & SWT.CTRL) != 0 && (e.keyCode == '2'))
		{
			//System.out.println("ctrl 2 was pressed");
			SW_main.gp.roi_2_f2_left = SW_main.gp.freq1;
			SW_main.gp.roi_2_f2_right = SW_main.gp.freq2;

			SW_main.gp.roi_2_f1_left = SW_main.gp.freq1_indirect;
			SW_main.gp.roi_2_f1_right = SW_main.gp.freq2_indirect;
		}
		
		if((e.stateMask & SWT.CTRL) != 0 && (e.keyCode == '3'))
		{
			//System.out.println("ctrl 3 was pressed");
			SW_main.gp.roi_3_f2_left = SW_main.gp.freq1;
			SW_main.gp.roi_3_f2_right = SW_main.gp.freq2;

			SW_main.gp.roi_3_f1_left = SW_main.gp.freq1_indirect;
			SW_main.gp.roi_3_f1_right = SW_main.gp.freq2_indirect;
		}
		
		if((e.stateMask & SWT.ALT) != 0 && (e.keyCode == '1'))
		{
			//System.out.println("alt 1 was pressed");
			SW_main.gp.last_freq1 = SW_main.gp.freq1;
			SW_main.gp.last_freq2 = SW_main.gp.freq2;

			SW_main.gp.freq1 = SW_main.gp.roi_1_f2_left;
			SW_main.gp.freq2 = SW_main.gp.roi_1_f2_right;

			SW_main.gp.last_freq1_indirect = SW_main.gp.freq1_indirect;
			SW_main.gp.last_freq2_indirect = SW_main.gp.freq2_indirect;

			SW_main.gp.freq1_indirect = SW_main.gp.roi_1_f1_left;
			SW_main.gp.freq2_indirect = SW_main.gp.roi_1_f1_right;

			SW_main.gp.new_2D_view = true;
			SW_main.update_spect = true;
			SW_main.canvas.redraw();
		}
		
		if((e.stateMask & SWT.ALT) != 0 && (e.keyCode == '2'))
		{
			//System.out.println("alt 2 was pressed");
			SW_main.gp.last_freq1 = SW_main.gp.freq1;
			SW_main.gp.last_freq2 = SW_main.gp.freq2;

			SW_main.gp.freq1 = SW_main.gp.roi_2_f2_left;
			SW_main.gp.freq2 = SW_main.gp.roi_2_f2_right;

			SW_main.gp.last_freq1_indirect = SW_main.gp.freq1_indirect;
			SW_main.gp.last_freq2_indirect = SW_main.gp.freq2_indirect;

			SW_main.gp.freq1_indirect = SW_main.gp.roi_2_f1_left;
			SW_main.gp.freq2_indirect = SW_main.gp.roi_2_f1_right;

			SW_main.gp.new_2D_view = true;
			SW_main.update_spect = true;
			SW_main.canvas.redraw();
		}
		
		if((e.stateMask & SWT.ALT) != 0 && (e.keyCode == '3'))
		{
			//System.out.println("alt 3 was pressed");
			SW_main.gp.last_freq1 = SW_main.gp.freq1;
			SW_main.gp.last_freq2 = SW_main.gp.freq2;

			SW_main.gp.freq1 = SW_main.gp.roi_3_f2_left;
			SW_main.gp.freq2 = SW_main.gp.roi_3_f2_right;

			SW_main.gp.last_freq1_indirect = SW_main.gp.freq1_indirect;
			SW_main.gp.last_freq2_indirect = SW_main.gp.freq2_indirect;

			SW_main.gp.freq1_indirect = SW_main.gp.roi_3_f1_left;
			SW_main.gp.freq2_indirect = SW_main.gp.roi_3_f1_right;

			SW_main.gp.new_2D_view = true;
			SW_main.update_spect = true;
			SW_main.canvas.redraw();
		}
	}
}
