/**
 * 
 */
package spinworks;

/**
 * @author Kirk Marat
 *
 */

public class MultipletInfo 
{		
/**
 * constructor for multiplet object
 * @param _shift chemical shift in Hz
 * @param _mult multiplicity
 * @param _count proton count
 * @param _label label for the multiplet
 */
	public MultipletInfo(double _shift, multiplicity _mult, double _count,
			String _label)
	{		
		shift = _shift;			// chemical shift in Hz.
		mult = _mult;			// multiplicity
		count = _count;			// proton count
		label = _label;			// label for the multiplet
		j = new double[10];		// the splittings in the multiplet
	}

//-------------------------------------------------------------------------------------------------
	protected Object clone() throws CloneNotSupportedException 
	{
		return super.clone();
	}
	
//-------------------------------------------------------------------------------------------------		
	public void dispose()		// TODO
	{
	}
	    
//-------------------------------------------------------------------------------------------------
//	data members
	
	public enum multiplicity {SINGLET, DOUBLET, TRIPLET, QUARTET, PENTET, HEXTET, SEPTET, OCTET,
		  DOUBLE_DOUBLET, DOUBLE_DOUBLE_DOUBLET, DOUBLE_DOUBLE_DOUBLE_DOUBLET,
		  DOUBLE_TRIPLET, DOUBLE_DOUBLE_TRIPLET, DOUBLE_QUARTET,
		  DOUBLE_DOUBLE_QUARTET, TRIPLE_DOUBLET, QUARTET_DOUBLET, MULTIPLET, UNKNOWN};
		  
	public double shift;			// Chemical shift in Hz.
	public multiplicity mult;		// multiplicity
	public double[] j;				// splittings
	public double count;			// count of protons
	public String label;			// a label for the multiplet
	
}	// end class
