package spinworks;

import java.awt.Desktop;
import java.io.File;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;

import dialogs.StartupOptionsDialog;

public class OptionsMenuListeners extends SW_main
{
	public static void addOptionsMenuListeners()
	{			
		dataTypeAutoItem.addSelectionListener  (new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				if(!auto_data_format)
				{
					auto_data_format = true;
					dataTypeVNMRItem.setSelection(false);
					dataTypeBrukerItem.setSelection(false);
					dataTypeJEOLItem.setSelection(false);
					dataTypeJDXItem.setSelection(false);
				}
				else	// for now make BRUKER defaut format
				{
					auto_data_format = false;
					q.data_type = data_types.BRUKER;
					dataTypeBrukerItem.setSelection(true);
				}
			}
		});
		
		dataTypeBrukerItem.addSelectionListener  (new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				auto_data_format = false;
				q.data_type = data_types.BRUKER;
				dataTypeAutoItem.setSelection(false);
				dataTypeVNMRItem.setSelection(false);
				dataTypeJEOLItem.setSelection(false);
				dataTypeJDXItem.setSelection(false);
			}
		});

		dataTypeVNMRItem.addSelectionListener  (new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				auto_data_format = false;
				q.data_type = data_types.VNMR;
				dataTypeAutoItem.setSelection(false);
				dataTypeBrukerItem.setSelection(false);
				dataTypeJEOLItem.setSelection(false);
				dataTypeJDXItem.setSelection(false);
			}
		});
		
		dataTypeJEOLItem.addSelectionListener  (new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				auto_data_format = false;
				q.data_type = data_types.JEOL;
				dataTypeAutoItem.setSelection(false);
				dataTypeBrukerItem.setSelection(false);
				dataTypeVNMRItem.setSelection(false);
				dataTypeJDXItem.setSelection(false);
			}
		});
		
		dataTypeJDXItem.addSelectionListener  (new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				auto_data_format = false;
				q.data_type = data_types.JCAMP_DX;
				dataTypeAutoItem.setSelection(false);
				dataTypeBrukerItem.setSelection(false);
				dataTypeVNMRItem.setSelection(false);
				dataTypeJEOLItem.setSelection(false);
			}
		});
		
		dataType1DItem.addSelectionListener  (new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				auto_data_format = false;
				dataType2DItem.setSelection(false);
				dataType3DItem.setSelection(false);
			}
		});
		
		dataType2DItem.addSelectionListener  (new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				auto_data_format = false;
				dataType1DItem.setSelection(false);
				dataType3DItem.setSelection(false);
			}
		});
		
		dataType2DItem.addSelectionListener  (new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				auto_data_format = false;
				dataType1DItem.setSelection(false);
				dataType2DItem.setSelection(false);
			}
		});
								
		startUpOptionsItem.addSelectionListener  (new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				 StartupOptionsDialog dlg 
	  				= new StartupOptionsDialog(shell, 
	  						SWT.APPLICATION_MODAL | SWT.TITLE | SWT.BORDER );

	  				dlg.open();
			}
		});	
		
		extendedDebugLoggingItem.addSelectionListener  (new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				if(gp.log_on)
				{
					gp.log_on = false;
					extendedDebugLoggingItem.setSelection(false);
				}
				else	
				{
					gp.log_on = true;
					extendedDebugLoggingItem.setSelection(true);
				}
			}
		});
		
		showLogFileItem.addSelectionListener  (new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				if (Desktop.isDesktopSupported())
				{
				    try 
				    {
				        Desktop.getDesktop().open(new File(SW_main.gp.scratch_folder + "/SWJ_Error.log"));
				    } 
				    catch (SecurityException ex)
				    {
				    	Util.show_and_log("Secutity Exception opening: " +
				        		SW_main.gp.scratch_folder + "/SWJ_Error.log", ex.getMessage());
				    }
				    catch (Exception ex) 
				    {
				        Util.show_and_log("no application for this file type or file not found " +
				        		SW_main.gp.scratch_folder + "/SWJ_Error.log", ex.getMessage());
				    }
				}
				else
					Util.show_and_log("Desktop not supported");
			}
		});
		
		clearLogFileItem.addSelectionListener  (new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				try
				{
					File fi = new File(SW_main.gp.scratch_folder + "/SWJ_Error.log");
					fi.delete();
				}
				catch(NullPointerException ex)
				{	Util.log_error("NullPointer deleting file" , ex.getMessage());	}
				catch(SecurityException ex)
				{	Util.log_error("Security exception deleting file" , ex.getMessage());	}
			}
		});
	}
//-------------------------------------------------------------------------------------------------
}
