package spinworks;

import org.eclipse.swt.SWT;

import dialogs.PhaseDialog;

// TODO perhaps rename this class to PhaseButton to be consistent with the rest

public class PhaseHandler extends SW_main
{	
	public static void PhaseButton_Click()
    {
//catch assorted stupid user errors

		// Can't process JCAMP-DX if only reals were stored
		if (q.data_type == SW_main.data_types.JCAMP_DX && gp.i_data_array == null)	
		{
			Util.show_and_log("You can't phase JCAMP-DX data with no imaginary part \nUse Hilbert transform (Proc. menu) first");
			return;
		}

		if ((SW_main.gp.data_array == null || gp.i_data_array == null) 
			&& q.data_mode == SW_main.modes.MODE_1D)		// no  data !
		{
			Util.show_and_log("There are no data to phase, please re-process");
			return;
		}

		if  ((q_f1.MC2 == det_modes_IND.QF || q_f1.PH_mod == phasing.MAGNITUDE) 
			&& q.data_mode == modes.MODE_2D && gp.dimensions_processed == 2)
		{	// can't phase mag mode 2D !
			Util.show_and_log("Can't phase magnitude mode 2D data");
			return;
		}

		if((q.data_mode == modes.MODE_2D || q.data_mode == modes.MODE_3D)
			&& (gp.rows_imag == null || gp.irows_real == null || gp.irows_imag == null))
		{	// can't phase if imaginaries are deleted!
			Util.show_and_log("No imaginary data!\nPlease re-process, read processed data or Hilbert Taransform");
			return;
		}

		if (gp.display_mode == SW_main.modes.MODE_2D && gp.rotate_2D)
		{
			Util.show_and_log("Can't phase 2D data in rotated (F1 horizontal) mode\nPlease rotate back to F2 horizontal (View menu)");
			return;
		}

		if (gp.display_mode == SW_main.modes.MODE_2D && gp.nslices == 0)
		{
			Util.show_and_log("Please select some rows or columns for phasing");
			return;
		}
		
//load 1D data into temporary arrays	
		if(gp.display_mode == modes.MODE_1D)
		{
	        GraphUtil.tempr = new double[q.SI];
	        GraphUtil.tempi = new double[q.SI];
	               
	        for (int i = 0; i < q.SI; i++)
	        {
	            GraphUtil.tempr[i] = gp.data_array[i];
	            GraphUtil.tempi[i] = gp.i_data_array[i];
	        }
		}

//use cursor point for pivot in cursor set
        if (gp.cursor_flag == 1)
        {
            gp.pivot = (int)((q.offset - gp.new_freq1) / q.hzperpt);
            if (gp.display_mode == modes.MODE_2D)
            {
                if(q.data_mode == modes.MODE_3D && gp.mode_3D == modes_3D.XY)
                    gp.pivot_ind = (int)((q_f2.offset - gp.new_freq1_indirect) / q_f2.hzperpt);
                else
                    gp.pivot_ind = (int)((q_f1.offset - gp.new_freq1_indirect) / q_f1.hzperpt);
            }
        }

//otherwise, use max point in power spectrum
        else if (gp.cursor_flag == 0)
        {
            gp.pivot = 0;
            double max = 0.0;
            if (gp.display_mode == modes.MODE_1D)
            {
                for (int i = 0; i < q.SI; i++)
                {
                    if ((gp.data_array[i] * gp.data_array[i]
                      + gp.i_data_array[i] * gp.i_data_array[i]) > max)
                    {
                        max = (gp.data_array[i] * gp.data_array[i]
                              + gp.i_data_array[i] * gp.i_data_array[i]);
                        gp.pivot = i;
                    }
                }
            }
            else if (gp.display_mode == modes.MODE_2D) 
            {
                int l = 0, m = 0;
                if (gp.row_col == trace_modes.ROWS)
                {
                    l = Util.freq_to_index(gp.freq1, q);
                    m = Util.freq_to_index(gp.freq2, q);
                    gp.pivot = Util_2D.scan_rows(gp, l, m);
                }
                else if (gp.row_col == trace_modes.COLUMNS)
                {
                    if (q.data_mode == modes.MODE_3D && gp.mode_3D == modes_3D.XY)
                    {
                        l = Util.freq_to_index(gp.freq1_indirect, q_f2);
                        m = Util.freq_to_index(gp.freq2_indirect, q_f2);
                        gp.pivot_ind = Util_2D.scan_columns(gp, l, m);
                    }
                    else  // 2D or 3D XZ
                    {
                        l = Util.freq_to_index(gp.freq1_indirect, q_f1);
                        m = Util.freq_to_index(gp.freq2_indirect, q_f1);
                        gp.pivot_ind = Util_2D.scan_columns(gp, l, m);
                    }
                }
            }
        }	// cursor_flag = 0
       
        PhaseDialog dlg = new PhaseDialog(shell, SWT.NONE | SWT.TITLE | SWT.BORDER );
        
        gp.ph0 = 0.0; gp.ph1 = 0.0;
        gp.phase_mode = true;
		gp.cursor_flag = 0;
		update_spect = true;
		canvas.redraw();		// to get pivot line
		
        dlg.open();    			//display dialog (modeless)
    }
//-------------------------------------------------------------------------------------------------
	
}
