package spinworks;

import java.io.File;
import java.util.prefs.Preferences;

import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.widgets.Display;
/**
 * write preferences to Windows registry or whaever mechanism exists in other OSs
 * @author kirk marat
 * 
 */
public class PreferenceUtil 
{
  
//-------------------------------------------------------------------------------------------------
    /**
     * Write Preferences information to HKCU\Software\JavaSoft\Prefs\spinworks
     */
    public static void setPrefs() 
    {
        Preferences userPref = Preferences.userRoot().node("spinworks");
        
        if(SW_main.gp.default_folder != null)
        {
        	try{	userPref.put("default_folder", SW_main.gp.default_folder);	}
        	catch(Exception ex)
        	{
        		Util.show_and_log("setPrefs(): " + ex.getMessage());
        		ex.printStackTrace();
        	}
        }
        
        if(SW_main.gp.scratch_folder != null)
        {
        	try{	userPref.put("scratch_folder", SW_main.gp.scratch_folder);	}
        	catch(Exception ex)
        	{
        		Util.show_and_log("setPrefs(): " + ex.getMessage());
        		ex.printStackTrace();
        	}	// set cursor
        }
        
        if(SW_main.gp.module_folder != null)
        {
        	try{	userPref.put("module_folder", SW_main.gp.module_folder);	}
        	catch(Exception ex)
        	{
        		Util.show_and_log("setPrefs(): " + ex.getMessage());
        		ex.printStackTrace();
        	}
        }
        
        try{	userPref.putBoolean("auto_load", SW_main.gp.auto_load);   }
        catch(Exception ex)
        {
        	Util.show_and_log("setPrefs(): " + ex.getMessage());
    		ex.printStackTrace();
        }
        
        try{	userPref.putBoolean("auto_save", SW_main.gp.auto_save);	}
        catch(Exception ex)
        {
        	Util.show_and_log("setPrefs(): " + ex.getMessage());
    		ex.printStackTrace();
        }   
        
        try{	userPref.putInt("display_font_size", SW_main.gp.displayFontSize);	}
        catch(Exception ex)
        {
        	Util.show_and_log("setPrefs(): " + ex.getMessage());
    		ex.printStackTrace();
        } 
        
    }
    
//-------------------------------------------------------------------------------------------------
    /**
     * Write colour preferences information to HKCU\Software\JavaSoft\Prefs\spinworks
     */
    public static void setColours()
    {
    	Preferences userPref = Preferences.userRoot().node("spinworks");
    	try
        {
        	userPref.put("back_colour", String.format("%d  %d  %d",
        			SW_main.gp.back_colour.getRed(),
        			SW_main.gp.back_colour.getGreen(),
        			SW_main.gp.back_colour.getBlue()));
        }
        catch(Exception ex)
        {
        	Util.show_and_log("setPrefs(): " + ex.getMessage());
    		ex.printStackTrace();
        } 
        
        try
        {
        	userPref.put("spect_colour", String.format("%d  %d  %d",
        			SW_main.gp.spect_colour.getRed(),
        			SW_main.gp.spect_colour.getGreen(),
        			SW_main.gp.spect_colour.getBlue()));
        }
        catch(Exception ex)
        {
        	Util.show_and_log("setPrefs(): " + ex.getMessage());
    		ex.printStackTrace();
        } 
        
        try
        {
        	userPref.put("sim_colour", String.format("%d  %d  %d",
        			SW_main.gp.sim_colour.getRed(),
        			SW_main.gp.sim_colour.getGreen(),
        			SW_main.gp.sim_colour.getBlue()));
        }
        catch(Exception ex)
        {
        	Util.show_and_log("setPrefs(): " + ex.getMessage());
    		ex.printStackTrace();
        } 
        
        try
        {
        	userPref.put("axis_colour", String.format("%d  %d  %d",
        			SW_main.gp.axis_colour.getRed(),
        			SW_main.gp.axis_colour.getGreen(),
        			SW_main.gp.axis_colour.getBlue()));
        }
        catch(Exception ex)
        {
        	Util.show_and_log("setPrefs(): " + ex.getMessage());
    		ex.printStackTrace();
        } 
        
        try
        {
        	userPref.put("integ_colour", String.format("%d  %d  %d",
        			SW_main.gp.integ_colour.getRed(),
        			SW_main.gp.integ_colour.getGreen(),
        			SW_main.gp.integ_colour.getBlue()));
        }
        catch(Exception ex)
        {
        	Util.show_and_log("setPrefs(): " + ex.getMessage());
    		ex.printStackTrace();
        } 
        
        try
        {
        	userPref.put("cursor_colour", String.format("%d  %d  %d",
        			SW_main.gp.cursor_colour.getRed(),
        			SW_main.gp.cursor_colour.getGreen(),
        			SW_main.gp.cursor_colour.getBlue()));
        }
        catch(Exception ex)
        {
        	Util.show_and_log("setPrefs(): " + ex.getMessage());
    		ex.printStackTrace();
        } 
    }
    
//-------------------------------------------------------------------------------------------------
    /**
     * Read Preferences information from HKCU\Software\JavaSoft\Prefs\spinworks
     */
    public static void getPrefs() 
    {
        Preferences userPref = Preferences.userRoot().node("spinworks");
        
        // default data folder
        try{	SW_main.gp.default_folder = userPref.get("default_folder", 
        		System.getProperty("user.home"));	}
        catch(Exception ex)
        {
        	Util.show_and_log("getPrefs(): " + ex.getMessage());
    		ex.printStackTrace();
        }
        
        //TODO  Add OS dependent default folders, e.g. C:\Temp for windows
        // OS info should be aavailable at this point.
        
        // writable scratch folder
        String str = null;
        String defaultScratchFolder;
        
        if(SW_main.currentOS == SW_main.osTypes.WINDOWS)
        	defaultScratchFolder = "C:/Temp";
        else
        	defaultScratchFolder = System.getProperty("user.home");
        
        try{	str = userPref.get("scratch_folder", defaultScratchFolder);	}
        catch(Exception ex)
        {
        	Util.show_and_log("getPrefs(): " + ex.getMessage());
    		ex.printStackTrace();
        }
        
        if(str != null)
        {
	        File file = new File(str);     
	        if(file.exists())
	        	SW_main.gp.scratch_folder = str;
        }
        
        // external module folder
        String defaultModuleFolder;
        
        if(SW_main.currentOS == SW_main.osTypes.WINDOWS)
        	defaultModuleFolder = "C:/Program Files (X86)/SpinWorksJ";	// TODO check!!!
        else
        	defaultModuleFolder = System.getProperty("user.home");
        
        try{	SW_main.gp.module_folder = userPref.get("module_folder", defaultModuleFolder);	}
        catch(Exception ex)
        {
        	Util.show_and_log("getPrefs(): " + ex.getMessage());
    		ex.printStackTrace();
        }
        
        try{	SW_main.gp.auto_load = userPref.getBoolean("auto_load", true);	}
        catch(Exception ex)
        {
        	Util.show_and_log("getPrefs(): " + ex.getMessage());
    		ex.printStackTrace();
        }
        
        try{	SW_main.gp.auto_save = userPref.getBoolean("auto_save", true);	}
        catch(Exception ex)
        {
        	Util.show_and_log("getPrefs(): " + ex.getMessage());
    		ex.printStackTrace();
        }
        
        String temp = "";
        String delim = "[ ]+";
        String[] token;
        
        try
        {	
        	temp = userPref.get("back_colour", "0  0  0");	
        	temp = temp.trim();
        	token = temp.split(delim);
        	if(token.length == 3)
        	{
        		SW_main.gp.back_colour = new Color(Display.getCurrent(), 
        		 Integer.parseInt(token[0]), Integer.parseInt(token[1]), Integer.parseInt(token[2]));
        	}
        }
        catch(Exception ex)
        {
        	Util.show_and_log("getPrefs(): " + temp, ex.getMessage());
    		ex.printStackTrace();
        }
        
        try
        {	
        	temp = userPref.get("spect_colour", "255  255  0");	
        	temp = temp.trim();
        	token = temp.split(delim);
        	if(token.length == 3)
        	{
        		SW_main.gp.spect_colour = new Color(Display.getCurrent(), 
        		 Integer.parseInt(token[0]), Integer.parseInt(token[1]), Integer.parseInt(token[2]));
        	}
        }
        catch(Exception ex)
        {
        	Util.show_and_log("getPrefs(): " + temp, ex.getMessage());
    		ex.printStackTrace();
        }
        
        try
        {	
        	temp = userPref.get("sim_colour", "0  0  255");	
        	temp = temp.trim();
        	token = temp.split(delim);
        	if(token.length == 3)
        	{
        		SW_main.gp.sim_colour = new Color(Display.getCurrent(), 
        		 Integer.parseInt(token[0]), Integer.parseInt(token[1]), Integer.parseInt(token[2]));
        	}
        }
        catch(Exception ex)
        {
        	Util.show_and_log("getPrefs(): " + temp, ex.getMessage());
    		ex.printStackTrace();
        }
        
        try
        {	
        	temp = userPref.get("axis_colour", "0  255  255");	
        	temp = temp.trim();
        	token = temp.split(delim);
        	if(token.length == 3)
        	{
        		SW_main.gp.axis_colour = new Color(Display.getCurrent(), 
        		 Integer.parseInt(token[0]), Integer.parseInt(token[1]), Integer.parseInt(token[2]));
        	}
        }
        catch(Exception ex)
        {
        	Util.show_and_log("getPrefs(): " + temp, ex.getMessage());
    		ex.printStackTrace();
        }
        
        try
        {	
        	temp = userPref.get("integ_colour", "255  255  255");	
        	temp = temp.trim();
        	token = temp.split(delim);
        	if(token.length == 3)
        	{
        		SW_main.gp.integ_colour = new Color(Display.getCurrent(), 
        		 Integer.parseInt(token[0]), Integer.parseInt(token[1]), Integer.parseInt(token[2]));
        	}
        }
        catch(Exception ex)
        {
        	Util.show_and_log("getPrefs(): " + temp, ex.getMessage());
    		ex.printStackTrace();
        }
        
        try
        {	
        	temp = userPref.get("cursor_colour", "0  255  0");	
        	temp = temp.trim();
        	token = temp.split(delim);
        	if(token.length == 3)
        	{
        		SW_main.gp.cursor_colour = new Color(Display.getCurrent(), 
        		 Integer.parseInt(token[0]), Integer.parseInt(token[1]), Integer.parseInt(token[2]));
        	}
        }
        catch(Exception ex)
        {
        	Util.show_and_log("getPrefs(): " + temp, ex.getMessage());
    		ex.printStackTrace();
        } 
        
        try{	SW_main.gp.displayFontSize = userPref.getInt("display_font_size", -1);	  	}
        catch(Exception ex)
        {
        	Util.show_and_log("getPrefs(): ",  ex.getMessage());
    		ex.printStackTrace();
        }  
    }
    
//-------------------------------------------------------------------------------------------------
    /**
     * Set most recent files list into the "registry"
     */
    public static void setMru() 
    {
    	Preferences userPref = Preferences.userRoot().node("spinworks");
    	
    	for(int i = 0; i < 8; i++)
    	{
    		try {userPref.put(String.format("mru%d", i),
    				SW_main.file_obj.file_path[i] 
    						+ ";" + SW_main.file_obj.seq_name[i] 
    						+ ";" + SW_main.file_obj.short_text[i]);}
    		catch(Exception ex)
    		{
    			Util.log_error("setMru(): " + ex.getMessage());
    			ex.printStackTrace();
    			break;
    		}
    	}
    }
    
//-------------------------------------------------------------------------------------------------
    /**
     *  Get most recent files list from the "registry"
     */
    public static void getMru()
    {
    	Preferences userPref = Preferences.userRoot().node("spinworks");
    	String temp;
    	String delim = "[;]+";
    	String[] token;
    	
    	for(int i = 0; i < 8; i++)
    	{							
    		try{	temp = userPref.get(String.format("mru%d", i), "");	}
    		catch(Exception ex)
    		{
    			Util.show_and_log("getPrefs(): " + ex.getMessage());
    			ex.printStackTrace();
    			break;
    		} 
    		token = temp.split(delim);
    		
    		if(token.length == 3)
    		{
    			try
    			{
    				SW_main.file_obj.file_path[i] = token[0];
    				SW_main.file_obj.seq_name[i] = token[1];
    				SW_main.file_obj.short_text[i] = token[2];
    			}
    			catch (Exception ex) 
    			{	
    				ex.printStackTrace();
    				Util.show_and_log("getMru(): " + temp, ex.getMessage());
    			}
    		}
    	}
    }
    
//-------------------------------------------------------------------------------------------------
}	//  end class

