package spinworks;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Cursor;
import org.eclipse.swt.widgets.Display;

public class ProcessButton extends SW_main
{
	public static void processButtonClick()
    {

		if ((q.data_mode == modes.MODE_1D && gp.fid == null)
            || (q.data_mode == modes.MODE_2D && gp.ser == null)
            || (q.data_mode == modes.MODE_3D && gp.ser == null))			
        {
            // user has not selected a data set
            Util.show_and_log("Process button, you must select a data set first!");
	        return;
        }

//This may take a while, so...
	    shell.setCursor(new Cursor(Display.getDefault(), SWT.CURSOR_WAIT));
    	
        if(q.data_mode == modes.MODE_1D)						// process 1D data
        {
			/*try		// get LB and GB parameters from test boxes
            { p.LB = Convert.ToDouble(LB_textbox.Text, num_format); }
			catch (Exception ex)
			{               
                util.show_and_log(ex.Message + " invalid LB");
		    }*/ //TODO

			/*try
            { p.GB = Convert.ToDouble(GB_textbox.Text, num_format); }
			catch (Exception ex)
			{ 
                util.show_and_log(ex.Message + " invalid GF");
		    }*/  // TODO

			Proc_1D.proc_1D(gp, p, q);

	        statusStripLabel2.setText("1D Processing Complete");			
            if (SW_main.gp.log_on) Util.log_error("1D processing complete");

			if (gp.auto_save && (q.data_type != data_types.JEOL) )
			{
				FileUtil.saveProc1D(gp, q);
                if (gp.log_on) Util.log_error("1D processed data saved");
			}			
        }

		else if (q.data_mode == modes.MODE_2D)	    	// process 2D data
		{
			Proc_2D_Internal();
			
            /*if (!use_ext_proc)
                Proc_2D_Internal();                     // if using internal Java routines
            else
                Proc_2D_External(); */                  // if using external C++ based routines
		}	// TODO


        /*else if (q.data_mode == modes.MODE_3D)	    // process 3D data,
        {                                               // first XY of XZ plane
            if (gp.mode_3D == modes_3D.XY)         // link to 3D processing menu
                MenuProcessing3D_FirstXY_Plane_Click(sender, e);

            if (gp.mode_3D == modes_3D.XZ)
                MenuProcessing3D_FirstXZ_Plane_Click(sender, e);

            gp.expt_scale = (double)gp.dysize * 0.80 / gp.data_max_2D;
        }*/	// TODO

        InterfaceUtil.updateToolbar();     
        statusStripLabel1.setText("Ready");
        shell.setCursor(new Cursor(Display.getDefault(), SWT.CURSOR_ARROW));
        gp.cursor_flag = 0;
        update_spect = true;
        canvas.redraw();
    }
	
//-------------------------------------------------------------------------------------------------
// Process 2D data set with internal Java processing routines
	private static void Proc_2D_Internal()
	{
		statusStripLabel1.setText("Processing 2D");
		statusStripLabel2.setText("Processing Rows:");
		if (gp.log_on) Util.log_error("processing rows");

		// if F1 is complex and last pair is incomplete
		if ((q_f1.TD & 2) != 0 && p_f1.MC2 != det_modes_IND.QF)
		{
			Util.show_and_log("Incomplete last increment (F1)");
			q_f1.TD--;
		}

		if (gp.ea_sort_done && (p_f1.MC2 != SW_main.det_modes_IND.ECHO_ANTIECHO))
		{
			if (FileUtilBruker.get_ser(q.data_path, gp, q, q_f1) <= 0)
			{
				Util.show_and_log(String.format("Cancel EA sort: cannot open: ",
						q.data_path));
				statusStripLabel1.setText("Ready");
				statusStripLabel2.setText("Error Processing 2D");
				return;
			}
			gp.ea_sort_done = false;
		}

		Proc_2D.proc_rows(gp, p, q, p_f1, q_f1);			// FFT process the rows

		statusStripLabel2.setText("Processing Columns:");
		if (gp.log_on) Util.log_error("processing columns");

		Proc_2D.proc_columns(gp, p, q, p_f1, q_f1);			// FFT process the columns

		statusStripLabel2.setText("2D Processing Complete");
		statusStripLabel1.setText("Ready");
		if (gp.log_on) Util.log_error("2D processing complete");

		gp.block_2D = 0;							// re-set block (row) counter
		Util_2D.load_display_2D_direct(gp.block_2D, gp, p, q);	// load first row 		
		gp.display_mode = modes.MODE_2D;		    // switch to 2D display
		gp.new_2D_view = true;						// must re-contour
		InterfaceUtil.set_tool_tips();				// due to change in display mode
		slider.setVisible(false);					// no scroll bar in 2D mode

		if(gp.auto_save)
			FileUtil.saveProc2D(false, gp, q, q_f1);

		if (gp.v_rescale)                                    // if fresh data re-scale
		{
			gp.data_max_2D = Util_2D.max_2D(gp.rows_real, q.SI, q_f1.SI);	 // find global maximum
			Util_2D.calc_default_levels_2D(gp);
			gp.v_rescale = false;
		}

		// set reasonable 1D scaling factor for slices, etc.
		gp.expt_scale = (double)gp.dysize * 0.80 / gp.data_max_2D;
	}
//-------------------------------------------------------------------------------------------------
}
