package spinworks;

import java.io.PrintWriter;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MenuAdapter;
import org.eclipse.swt.events.MenuEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Cursor;
import org.eclipse.swt.widgets.Display;

public class ProcessingMenuListeners extends SW_main
{
			
//	Processing Menu
	public static void addProcessingMenuListeners()
	{		
		// process Menu, update menu items when dropped				
		processingMenu.addMenuListener  (new MenuAdapter() 
		{
			public void menuShown(MenuEvent e) 
			{
				procSeriesMenuItem.setEnabled(false);
				
				if(q.data_mode == modes.MODE_1D && gp.expt_read)
				{
					ftItem.setEnabled(true);
					efItem.setEnabled(true);
					efpItem.setEnabled(true);
				}
				else
				{
					ftItem.setEnabled(false);
					efItem.setEnabled(false);
					efpItem.setEnabled(false);
				}
				
				if(gp.display_mode == modes.MODE_1D && gp.data_array != null)
				{
					dcItem.setEnabled(true);
					splineBC_Item.setEnabled(true);
					leastSquaresBC_Item.setEnabled(true);
					leastSquaresBC_Item.setEnabled(true);
					clearBCPointsItem.setEnabled(true);
					fullyAutoBC_Item.setEnabled(true);
					hilbertTransformItem.setEnabled(true);
				}
				else
				{
					dcItem.setEnabled(false);
					splineBC_Item.setEnabled(false);
					leastSquaresBC_Item.setEnabled(false);
					leastSquaresBC_Item.setEnabled(false);
					clearBCPointsItem.setEnabled(false);
					fullyAutoBC_Item.setEnabled(false);
					hilbertTransformItem.setEnabled(false);
				}
						
				if(q.data_mode == modes.MODE_2D)
				{
					proc2D_MenuItem.setEnabled(true);
					autoReferenceF1.setEnabled(true);
					procSeriesMenuItem.setEnabled(true);
				}
				else
				{
					proc2D_MenuItem.setEnabled(false);
					autoReferenceF1.setEnabled(false);
				}
				
				/*if(q.data_mode == modes.MODE_3D && gp.expt_read)
					proc3D_MenuItem.setEnabled(true);
				else
					proc3D_MenuItem.setEnabled(false);*/
				
				if(q.data_mode == modes.MODE_1D && gp.expt_read)
					procSeriesMenuItem.setEnabled(true);
			}
		});
				
		ftItem.addSelectionListener  (new SelectionAdapter() // ft only
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				windows tempWDW = p.WDW;			// save current modes
				phasing tempPH_mod = p.PH_mod;
				p.WDW = windows.NONE;
				p.PH_mod = phasing.NONE;
				ProcessButton.processButtonClick();	// link to equivalent button
				p.WDW = tempWDW;					// restore current modes
				p.PH_mod = tempPH_mod;
			}
		});
		
		efItem.addSelectionListener  (new SelectionAdapter() // em + ft
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				phasing tempPH_mod = p.PH_mod;
				p.PH_mod = phasing.NONE;
				ProcessButton.processButtonClick();	// link to equivalent button
				p.PH_mod = tempPH_mod;
			}
		});
		
		efpItem.addSelectionListener  (new SelectionAdapter() // em + ft + pk
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				ProcessButton.processButtonClick();	// link to equivalent button
			}
		});
    
		dcItem.addSelectionListener  (new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				if (gp.data_array == null)
				{
					Util.show_and_log("No Processed Data!");
					return;
				}
				BaseLine.drift_corr(gp.data_array, q.SI);
				
				update_spect = true;
				canvas.redraw();
				statusStripLabel2.setText("1D Drift Correction Complete");
			}
		});

		splineBC_Item.addSelectionListener  (new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				if (gp.data_array == null)
				{
					Util.show_and_log("No Processed Data!");
					return;
				}
				BaseLine.bl_corr_spline(gp, q);
				update_spect = true;
				canvas.redraw();
				statusStripLabel2.setText("Baseline Correction Complete");
			}
		});

		leastSquaresBC_Item.addSelectionListener  (new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				if (gp.data_array == null)
				{
					Util.show_and_log("No Processed Data!");
					return;
				}
				BaseLine.bl_corr(gp, q);
				update_spect = true;
				canvas.redraw();
				statusStripLabel2.setText("Baseline Correction Complete");
			}
		});

		clearBCPointsItem.addSelectionListener  (new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				gp.n_bl_pts = 0;
				statusStripLabel2.setText("Baseline Points Cleared");
			}
		});

		fullyAutoBC_Item.addSelectionListener  (new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				if (gp.data_array == null)
				{
					Util.show_and_log("No Processed Data!");
					return;
				}
				
				shell.setCursor(new Cursor(Display.getDefault(), SWT.CURSOR_WAIT));

				// Whittaker requires imaginaries, regenerate if necessary.
				if(gp.i_data_array == null)
				    Fft.do_HT(gp, p, q);;

				BaseLine.whittaker_bl(gp.data_array, gp.i_data_array, q.SI,
						p.baseline_filter, p.baseline_thresh, p.baseline_lambda);

				q.baseline_filter = p.baseline_filter;
				q.baseline_thresh = p.baseline_thresh;
				q.baseline_lambda = p.baseline_lambda;

				statusStripLabel2.setText("auto. baseline correction complete");
				if (gp.auto_save)
				{
					FileUtil.saveProc1D(gp, q);
					String jdx_file;
					jdx_file = q.data_folder + "spectrum.dx";
					DX_Util.write_jdx(jdx_file, gp, q);
				}

				shell.setCursor(new Cursor(Display.getDefault(), SWT.CURSOR_ARROW));
				update_spect = true;
				canvas.redraw();
			}
		});

//------------------
		// Array sub-menu (perhaps move to its own class
		processSeriesExNoItem.addSelectionListener  (new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				shell.setCursor(new Cursor(Display.getDefault(), SWT.CURSOR_WAIT));
	            int exno = FileUtil.getExNo(q.data_folder);
	            int i;

	            double phase_0 = q.PHC0;        // let's process the series like the first
	            double phase_1 = q.PHC1;
	            phasing ph_mode = p.PH_mod;     // no status parameter set for this
	            windows wdw = q.WDW;
	            double lb = q.LB;
	            double gb = q.GB;
	            int ssb = q.SSB;
	            int si = q.SI;
	            boolean currentAutoLoad = gp.auto_load;	// save autoload status
	            gp.auto_load = true;

	            for (i = exno; i < 999; i++)
	            {
	                if (FileUtil.setExno(i, q, gp) == false)
	                    break;
	                FileOpen.fileOpenBruker1D(q.data_path);

	                p.PHC0 = phase_0;          // set processing parameters like first in series
	                p.PHC1 = phase_1;
	                p.PH_mod = ph_mode;
	                p.WDW = wdw;
	                p.LB = lb;
	                p.GB = gb;
	                p.SSB = ssb;
	                p.SI = si;

	                Proc_1D.proc_1D(gp, p, q);             // process it
		            FileUtil.saveProc1D(gp, q);      	   // and save it
		        }

	            if(FileUtil.setExno(exno, q, gp))
	            	FileOpen.fileOpenBruker1D(q.data_path);

	            shell.setCursor(new Cursor(Display.getDefault(), SWT.CURSOR_ARROW));
	            statusStripLabel1.setText("Ready");			// and update embelishments
	            statusStripLabel2.setText(
	                String.format("%d spectra processed", i - 1));
	            shell.setText(version + q.data_folder);
	            gp.display_mode = modes.MODE_1D;
	            update_spect = true;
				canvas.redraw();
				gp.auto_load = currentAutoLoad;	// restore autoload status
			}
		});
		
		processArrayBrukerItem.addSelectionListener  (new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				gp.n_traces = 0;
				shell.setCursor(new Cursor(Display.getDefault(), SWT.CURSOR_WAIT));
				p.PH_mod = phasing.CONSTANTS;						// we assume that the we want 
				// TODO toolBarPhasing.SelectedIndex = (int)phasing.CONSTANTS;	// to phase the array the same 
				// as the first block

				Proc_2D.proc_rows(gp, p, q, p_f1, q_f1);			    // FFT process the rows

				for (int i = 0; i < q_f1.TD; i++)
				{
					gp.stack_trace[gp.n_traces] = new Trace(gp, q);
					//	copy the current experimental spectrum into the trace

					for (int j = 0; j < q.SI; j++)
						gp.stack_trace[gp.n_traces].data[j] = gp.rows_real[i][j];

					gp.n_traces++;		// bump trace number
				}

				Util.alloc_proc(gp, p, q);

				for (int j = 0; j < q.SI; j++)
				{
					gp.data_array[j] = gp.rows_real[0][j];
					gp.i_data_array[j] = gp.rows_imag[0][j];
				}
				
				// TODO PrevButton.Visible = true;
				//NextButton.Visible = true;

				Util.rescale(gp, q);            

				if (gp.v_rescale)
					gp.expt_scale = (double)gp.dysize * 0.80 / gp.data_max;

				for (int i = 0; i < gp.n_traces; i++)
					gp.stack_trace[i].yscale = gp.expt_scale;

				gp.v_rescale = false;						// don't rescale on subsequent processing

				gp.block_2D = 0;
				gp.display_mode = modes.MODE_1D;
				update_spect = true;
				canvas.redraw();
				shell.setCursor(new Cursor(Display.getDefault(), SWT.CURSOR_ARROW));
			}
		});
		
		processArrayVarianItem.addSelectionListener  (new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				 if (q.nblocks >= SW_main.MAX_TRACES)
		            {
		                Util.show_and_log("Maximum number of 1024 traces exceeded");
		                return;
		            }

					gp.n_traces = 0;
					shell.setCursor(new Cursor(Display.getDefault(), SWT.CURSOR_WAIT));
					p.PH_mod = phasing.CONSTANTS;						// we assume that the we want 
					//  TODO toolBarPhasing.SelectedIndex = (int)phasing.CONSTANTS;	// to phase the array the same 
																			// as the first block

					for (gp.vblock = 1; gp.vblock <= q.nblocks; gp.vblock++)
					{
						Proc_1D.proc_1D(gp, p, q );

						//	create a stacked trace object
						gp.stack_trace[gp.n_traces] = new Trace(gp, q);

						//	copy the current experimental spectrum into the trace
						for (int i = 0; i < q.SI; i++)
							gp.stack_trace[gp.n_traces].data[i] = gp.data_array[i];

						gp.n_traces++;		// bump trace number
					}

					gp.vblock = 1;
					Proc_1D.proc_1D(gp, p, q );

					update_spect = true;
					canvas.redraw();
					shell.setCursor(new Cursor(Display.getDefault(), SWT.CURSOR_ARROW));
			}
		});
		
		autoBaselineSeriesExNoItem.addSelectionListener  (new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				shell.setCursor(new Cursor(Display.getDefault(), SWT.CURSOR_WAIT));
	            int exno = FileUtil.getExNo(q.data_folder);
	            int i;

	            int baseline_filter = p.baseline_filter;    // process all like the first one
	            double baseline_lambda = p.baseline_lambda;
	            double baseline_thresh = p.baseline_thresh;

	            for (i = exno; i < 999; i++)
	            {
	                if (FileUtil.setExno(i, q, gp) == false)
	                    break;
	                FileOpen.fileOpenBruker1D(q.data_path);
	                FileUtil.readProc1D(gp, p, q);

	                BaseLine.whittaker_bl(gp.data_array, gp.i_data_array, q.SI,
	                    baseline_filter, baseline_thresh, baseline_lambda);

	                q.baseline_filter = baseline_filter;    // update status parameters
	                q.baseline_thresh = baseline_thresh;
	                q.baseline_lambda = baseline_lambda;

	                FileUtil.saveProc1D(gp, q);          // and save it
	            }

	            shell.setCursor(new Cursor(Display.getDefault(), SWT.CURSOR_ARROW));
	            statusStripLabel1.setText("Ready");			// and update embelishments
	            statusStripLabel2.setText(
	                String.format("%d spectra processed", i - 1));
	            shell.setText(version + q.data_folder);
	            update_spect = true;
				canvas.redraw();
			}
		});
		
		autoBaselineArrayItem.addSelectionListener  (new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				shell.setCursor(new Cursor(Display.getDefault(), SWT.CURSOR_WAIT));

	            for (int i = 0; i < gp.n_traces; i++)
	            {
	                for (int j = 0; j < q.SI; j++)
	                    gp.data_array[j] = gp.stack_trace[i].data[j];

	                for (int j = 0; j < q.SI; j++)
	                    gp.i_data_array[j] = gp.stack_trace[i].idata[j];

	                BaseLine.whittaker_bl(gp.data_array, gp.i_data_array, q.SI,
	                    p.baseline_filter, p.baseline_thresh, p.baseline_lambda);

	                for (int j = 0; j < q.SI; j++)
	                    gp.stack_trace[i].data[j] = gp.data_array[j];
	            }

	            for (int j = 0; j < q.SI; j++)
	                gp.data_array[j] = gp.stack_trace[0].data[j];

	            gp.block_2D = 0;

	            update_spect = true;
				canvas.redraw();
				shell.setCursor(new Cursor(Display.getDefault(), SWT.CURSOR_ARROW));
			}
		});
		
//--------------------------		
		hilbertTransformItem.addSelectionListener  (new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				Fft.do_HT(gp, p, q);

	            gp.data_max = Math.abs(Util.dscan(gp.data_array, q.SI, 0, q.SI));
	            gp.expt_scale = gp.dysize * 0.80 / gp.data_max;

	            update_spect = true;	// redraw screen
				canvas.redraw();
			}
		});

//--------------------------
		subtractTrace1Item.addSelectionListener  (new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				if (gp.n_traces != 1)
				{
					Util.show_and_log("You must have 1 (and only 1) stacked trace for this function");
					return;
				}

				try
				{
	                for (int i = 0; i < q.SI; i++)
	                {
	                    gp.data_array[i] = gp.data_array[i] - gp.stack_trace[0].data[i];
	                    gp.i_data_array[i] = gp.i_data_array[i] - gp.stack_trace[0].idata[i];
	                }
				}
				catch (Exception ex)
				{
	                Util.show_and_log( 
	                    "Subtracting trace from experimental raised the following exception:",
	                    ex.getMessage());
				}

				if (gp.auto_save) FileUtil.saveProc1D(gp, q);
	            update_spect = true;	// redraw screen
				canvas.redraw();
			}
		});
		
		addTrace1Item.addSelectionListener  (new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				if (gp.n_traces != 1)
				{
	                Util.show_and_log("You must have 1 (and only 1) stacked trace for this function");
					return;
				}

				try
				{
	                for (int i = 0; i < q.SI; i++)
	                {
	                    gp.data_array[i] = gp.data_array[i] + gp.stack_trace[0].data[i];
	                    gp.i_data_array[i] = gp.i_data_array[i] + gp.stack_trace[0].idata[i];
	                }
				}
				catch (Exception ex)
				{
	                Util.show_and_log(
	                    "Adding trace to experimental raised the following exception:",
	                    ex.getMessage());
				}

				if (gp.auto_save) FileUtil.saveProc1D(gp, q);
				
	            update_spect = true;	// redraw screen
				canvas.redraw();
			}
		});
			
		
		testItem.addSelectionListener  (new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				PrintWriter pw;
				String fileName = q.data_folder + "synfid.txt";
				Util.show_and_log(fileName);
				double real = 0.0, imag = 0.0;
				double f = 200.0;
				double f2 = -1000.0;
				double t = 0.0;
				double T2 = 1.0;
				double twoPi = 2.0 * Math.PI;
				
//				open file
				try { pw = new PrintWriter(fileName); }
				catch (Exception ex)
				{
					Util.show_and_log("exportXY(): " + fileName, ex.getMessage());
					return;
				}
				
				double aqtime = 0.5 / (q.SW * q.SF) * q.TD;

				pw.println(String.format("acquisition time = %.6f", aqtime));

				for (int i = 0; i <= q.TD - 1; i = i + 2)
				{
					t = ((double)(i) / (double) q.TD) * aqtime;
					
					real = (10000.0 * Math.cos(twoPi * f * t) 
							+ 20000.0 * Math.cos(twoPi * f2 * t)) * Math.exp(-t / T2);
					
					imag = (10000.0 * Math.sin(twoPi * f * t)
					        + 20000.0 * Math.sin(twoPi * f2 * t)) * Math.exp(-t / T2);
					
					gp.fid[i] = real;
					gp.fid[i+1] = imag;
					gp.data_max = 10000.0;				
					
					pw.println(String.format("%.8f   %.3f   %.3f",
							t, real, imag));
				}
				
				Proc_1D.proc_1D(gp, p, q);
				
				pw.close();
				update_spect = true;	// redraw screen
				canvas.redraw();			
			}
		});
		
//-------------------------------------------------------------------------------------------------	
	}	// addProcessingMenuListeners()
//-------------------------------------------------------------------------------------------------
}
