package spinworks;

/// <copyright>
///	Copyright (c) 2006-2020

///	Kirk Marat
/// 2296 Selwyn Road
/// Victoria, BC, V9B 3K8, Canada

/// Previous:
///	The University of Manitoba
///	Winnipeg, Manitoba, Canada
///	R3T 2N2

///	All rights reserved.

///	This source may be distributed, provided that the author and the University are 
/// appropriately acknowledged.  However, incorporation of any part into any commercial product 
/// is prohibited without prior written authorization. 
///
/// see:  http://www.gnu.org/licenses/gpl.html
///
/// Note:
/// Distribution of this source or any of its components into the People's Republic of China 
/// is strictly prohibited.
/// 
///	The author disclaims all warranties with regard to this software, including all implied 
///	warranties of merchantability and fitness. In no event, shall the author or the University of 
///	Manitoba be liable for any special, indirect or consequential damages, or any damages whatsoever 
///	resulting from loss of use, data or profits, whether in an action of contract, negligence or 
///	other tortuous action, arising out of or in connection with the use or performance of this 
///	software.

///	All trademarks mentioned (e.g. XwinNMR, VNMR(J), Windows, etc.) are property of their 
///	respective owners.
/// </copyright>

import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Menu;

import java.awt.Desktop;

import java.io.File;
import java.net.URLDecoder;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;

import org.eclipse.swt.SWT;
import org.eclipse.swt.dnd.DND;
import org.eclipse.swt.dnd.DropTarget;
import org.eclipse.swt.dnd.DropTargetAdapter;
import org.eclipse.swt.dnd.DropTargetEvent;
import org.eclipse.swt.dnd.FileTransfer;
import org.eclipse.swt.dnd.Transfer;

import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.widgets.ToolBar;
import org.eclipse.swt.widgets.ToolItem;
import org.eclipse.ui.part.PluginTransfer;

import dialogs.IntegDialog;
import dialogs.StartupOptionsDialog;
//import osx.CocoaUIEnhancer;
//import osx.CocoaUIEnhancer;
import simulation.SimPar;

import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.events.FocusListener;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseListener;
import org.eclipse.swt.events.MouseMoveListener;
import org.eclipse.swt.events.MouseWheelListener;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.ShellEvent;
import org.eclipse.swt.events.ShellListener;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.widgets.ProgressBar;
import org.eclipse.swt.widgets.Slider;

public class SW_main
{
// some interface elements here for access purposes
    protected static Shell shell;    
    public static Canvas canvas;    
    protected static Slider slider;
    
    protected static Menu fileMenu;		// file menu
    protected static MenuItem fileOpenItem;			
    protected static MenuItem fileReadF1Item;
    protected static MenuItem fileReadF2Item;   
    protected static MenuItem fileSaveJDX_Item;
    protected static MenuItem fileSaveAsJDX_Item;
    protected static MenuItem fileSaveColumnsAsJDX_Item;
    protected static MenuItem fileSaveRowsAsJDX_Item;
    protected static MenuItem fileSaveItem;
    protected static MenuItem fileReadItem;
    protected static MenuItem fileExportXY_Item;
    protected static MenuItem filePrintItem;
    protected static MenuItem filePrintPreviewItem;
    protected static MenuItem fileRecentItem;
    protected static MenuItem fileExitItem;
    
    protected static Menu editMenu;		// edit menu
    protected static MenuItem editProcParsItem;		
    protected static MenuItem editPlotParsItem;
    protected static MenuItem editPlotTitleItem;
    protected static MenuItem editDisplayColoursItem;
    protected static MenuItem editCopyToFilePNG;
    protected static MenuItem editCopyToFilePNG_As;
    protected static MenuItem editCopyToFileJPG;
    
    protected static Menu viewMenu;		// view menu
    protected static MenuItem showSpectrumItem;		
    protected static MenuItem showSimulatedItem;
    protected static MenuItem showIntegralsItem;
    protected static MenuItem showPeaksItem;
    protected static MenuItem showZeroLineItem;
    protected static MenuItem showYaxisItem;
    protected static MenuItem showTitleItem;
    protected static MenuItem FID_DisplayItem;
    //TODO  Child window stuff here
    
    protected static MenuItem createChildWindowItem;
    
    protected static MenuItem contourSpacingLogItem;
    protected static MenuItem contourSpacingLinearItem;
    protected static MenuItem contourSpacingCoarseItem;
    protected static MenuItem contourSpacingFineItem;
    protected static MenuItem rotate2D_Item;
    protected static MenuItem showCOSY_Item;
    protected static MenuItem showTOCSY_Item;
    protected static MenuItem showNOESY_Item;
    protected static MenuItem showHMBC_Item;  
    protected static MenuItem XY_3D_Item;
    protected static MenuItem XZ_3D_Item;
    protected static MenuItem showF1TraceItem;
    protected static MenuItem showF2TraceItem;
    protected static MenuItem copyToBoxItem;
    protected static MenuItem exptToStackItem;
    protected static MenuItem simulatedToStackItem;
    protected static MenuItem addSimulatedToStackItem;
    protected static MenuItem seriesExnoToStackItem;
    protected static MenuItem dsshItem;
    protected static MenuItem deleteStackTraceItem;
    protected static MenuItem deleteStackTracesItem;
    protected static MenuItem stackedTraceDialogItem;
     
    protected static MenuItem unitsF2Hz;
    protected static MenuItem unitsF2PPM;
    protected static MenuItem unitsF1Hz;
    protected static MenuItem unitsF1PPM;
    
    protected static MenuItem defineROI_Item;		// ROI menu
    protected static MenuItem setFixedLimitsItem;
    protected static MenuItem protonSurveyItem;
    protected static MenuItem carbonSurveyItem;
    protected static MenuItem setFixedScaleItem;  
    protected static MenuItem scale5HzCmItem;
    protected static MenuItem scale10HzCmItem;
    protected static MenuItem scale20HzCmItem;
    protected static MenuItem scalep1ppmCmItem;
    protected static MenuItem scale1ppmCmItem;
    protected static MenuItem scale5ppmCmItem;
    protected static MenuItem scale10ppmCmItem;
    protected static MenuItem scale20ppmCmItem;
    protected static MenuItem scaleUserDefinedItem;
       
    protected static MenuItem dataTypeAutoItem;		// options menu
    protected static MenuItem dataTypeBrukerItem;	
    protected static MenuItem dataTypeVNMRItem;
    protected static MenuItem dataTypeJEOLItem;
    protected static MenuItem dataTypeJDXItem;
    protected static MenuItem dataTypeMagritek;
    protected static MenuItem dataType1DItem;
    protected static MenuItem dataType2DItem;
    protected static MenuItem dataType3DItem;
    protected static MenuItem dataTypeNMRpipeItem;
    protected static MenuItem startUpOptionsItem;
    protected static MenuItem extendedDebugLoggingItem;
    protected static MenuItem showLogFileItem;
    protected static MenuItem clearLogFileItem;
      
    protected static Menu processingMenu;		// processing menu
    protected static MenuItem ftItem;				
    protected static MenuItem efItem;
    protected static MenuItem efpItem;
    protected static MenuItem dcItem;
    protected static MenuItem splineBC_Item;
    protected static MenuItem leastSquaresBC_Item;
    protected static MenuItem clearBCPointsItem;
    protected static MenuItem fullyAutoBC_Item;
    
    protected static MenuItem proc2D_MenuItem;	// 2D processing
    protected static MenuItem symmetrizeMenuItem;	
    protected static MenuItem smoothMenuItem;
    protected static MenuItem baselineCorrectF2MenuItem;
    protected static MenuItem baselineCorrectF1MenuItem;
    protected static MenuItem driftCorrectF2MenuItem;
    protected static MenuItem driftCorrectF1MenuItem;
    protected static MenuItem calculateF2ProjectionMenuItem;
    protected static MenuItem calculateF1ProjectionMenuItem;
    protected static MenuItem calculateF2SumMenuItem;
    protected static MenuItem calculateF1SumMenuItem;
    protected static MenuItem clearImagMenuItem;
    protected static MenuItem hilbertTransformF2MenuItem;
    protected static MenuItem hilbertTransformF1MenuItem;
    protected static MenuItem tiltJResolvedMenuItem; 
    protected static MenuItem symmetrizeJResolvedMenuItem;
    protected static MenuItem autoReferenceF1;
    protected static MenuItem referenceF1_13CtoCDCl3;
    protected static MenuItem referenceF1_13CtoD2O_TSP;
    protected static MenuItem referenceF1_13CtoD2O_DSS;
    protected static MenuItem referenceF1_13CtoAcetone;
    protected static MenuItem referenceF1_13CtoDMSO;
    protected static MenuItem referenceF1_13CtoBenzene;
    protected static MenuItem referenceF1_15N_D2O;
    protected static MenuItem referenceF1_Homonuclear;
    
    protected static MenuItem proc3D_MenuItem;	//3D processing
    protected static MenuItem processFirstXY_Item;
    protected static MenuItem processXY_Item;
    protected static MenuItem processZofXY_Item;
    protected static MenuItem processFirstXZ_Item;
    protected static MenuItem processXZ_Item;
    protected static MenuItem processYofXZ_Item;
    protected static MenuItem bcPlanesDirectItem;
    protected static MenuItem bcPlanesIndirectItem;
    protected static MenuItem phasePlanesDirectItem;
    protected static MenuItem phasePlanesIndirectItem;
    protected static MenuItem hilbertTransformDirectItem;
    protected static MenuItem hilbertTransformIndirectItem;
    protected static MenuItem freeImaginariesItem;
    protected static MenuItem freeImaginariesOnDiskItem;
    protected static MenuItem autoReferenceCurrentIndirect;
    protected static MenuItem referenceIndirect15N;
    protected static MenuItem referenceIndirect13C;
    protected static MenuItem referenceIndirectHomonuclear;
    
    protected static MenuItem procSeriesMenuItem;	// array processing
    protected static MenuItem processSeriesExNoItem;	
    protected static MenuItem processArrayBrukerItem;
    protected static MenuItem processArrayVarianItem;
    protected static MenuItem autoBaselineSeriesExNoItem;
    protected static MenuItem autoBaselineArrayItem;
    
    protected static MenuItem hilbertTransformItem;
    protected static MenuItem subtractTrace1Item;
    protected static MenuItem addTrace1Item;
    
    protected static MenuItem testItem;
      
    protected static Menu peakPickMenu;		// Peaks and Integrals menu
    protected static MenuItem pickPeaksItem;		
    protected static MenuItem clearPeaksItem;
    protected static MenuItem clearRegionPeaksItem;
    protected static MenuItem peakPickStackItem;
    protected static MenuItem integrateStackItem;
    protected static MenuItem listPeaksItem;
    protected static MenuItem loadPeaksItem;
    protected static MenuItem interpolateItem;
    protected static MenuItem posOnlyPeaks;
    protected static MenuItem negOnlyPeaks;
    protected static MenuItem bothPeaks;
    protected static MenuItem unitsHz;
    protected static MenuItem unitsPPM;
    protected static MenuItem decimalDigitsItem;
    protected static MenuItem clearIntegralRegionsItem;
    protected static MenuItem retainIntegralRegionsItem;
    protected static MenuItem binDataItem;
    protected static MenuItem binStackedArrayItem;
    protected static MenuItem editBinningParametersItem;
    
    protected static Menu spinSystemMenu;			// spin system menu
    protected static MenuItem editShiftsItem;
    protected static MenuItem editJItem;
    protected static MenuItem editDItem;
    protected static MenuItem openSpinSystemItem;
    protected static MenuItem saveSpinSystemItem;
    protected static MenuItem clearSpinSystemItem;
       
    protected static Menu simulationMenu;			// simulation menu
    protected static MenuItem modeNUMMRIT_Item;
    protected static MenuItem modeDECON_Item;
    protected static MenuItem runSimulationItem;
    protected static MenuItem listSimulationOutputItem;
    protected static MenuItem editSimulationOptionsItem;  
    protected static MenuItem readAssignedTransitionsItem;
    protected static MenuItem saveAssignedTransitionsItem;
    protected static MenuItem autoAssignTransitionsItem;
    protected static MenuItem deleteAssignmentsItem;
    protected static MenuItem loadOptimizedParametersItem;
    protected static MenuItem openSimpsonFIDItem;
    protected static MenuItem openSimpsonSpectrumItem;
    
    protected static MenuItem editDeconParametersItem;
    protected static MenuItem copyDeconPeaksItem;
    protected static MenuItem interactiveDeconPanelItem;
    //protected static MenuItem calculateRMS_Item;
         
    protected static Menu helpMenu;		// help menu
    protected static MenuItem helpManualItem;		
    protected static MenuItem helpAboutItem;
    protected static MenuItem helpPathInfoItem;
    
    protected static ToolItem toolbarOpen;			// toolbar
    protected static ToolItem toolbarPrev;
    protected static ToolItem toolbarNext; 
    protected static ToolItem toolbar3DMinus;
    protected static ToolItem toolbar3DPlus;
    protected static ToolItem toolbarSave;
    protected static ToolItem toolbarPrint;
    protected static ToolItem[] toolBarWorkspace = new ToolItem[7];
    protected static ToolItem toolbarF2scan;
    protected static ToolItem toolbarF1scan;
    
       
    protected static Button vertScaleDownButton;	// button panel
    protected static Button vertScaleUpButton;
    protected static Button rangeScaleDownButton;
    protected static Button rangeScaleUpButton;
    protected static Button prevBlockButton;
    protected static Button nextBlockButton;
    protected static Button scale1D_UpButton;
    protected static Button scale1D_DownButton;
    protected static Button vertResetButton;		
    protected static Button zoomButton;
    protected static Button fullButton;
    protected static Button lastButton;
    protected static Button disp2DButton;
    protected static Button posOnlyButton;
    protected static Button contourButton;
    protected static Button colButton;
    protected static Button clearButton;
    protected static Button editParsButton;
    protected static Button processButton;
    
    protected static Button softButton1;
    protected static Button softButton2;
    protected static Button softButton3;
    protected static Button softButton4;
    protected static Button softButton5;
    protected static Button softButton6;
    
    protected static Button blPointButton;
    
    protected static Button phaseButton;
    protected static Button integrateButton;
    protected static Button calibrateButton;
       
    protected static ProgressBar progressBar;
    protected static Label statusStripLabel1;		// status strip
    protected static Label statusStripLabel2;
    protected static Label statusStripLabel3;
    protected static Label statusStripLabel4;
    
    public static int cursor_x, cursor_y;
    public static int cursor1_x, cursor1_y;
    public static int cursor2_x, cursor2_y;
    public static boolean mouse_down = false;
    public static double printScaleFactor = 23.622;	// converts mm. to printer units.
    												// updated by print routines   
    public static boolean update_spect;
    
    public static global_par gp = new global_par();
    
    public static SimPar sp = new SimPar();
    
    public static data_par p = new data_par();
    public static data_par q = new data_par();
    
    public static data_par p_f1 = new data_par();
    public static data_par q_f1 = new data_par();
    
    public static data_par p_f2 = new data_par();
    public static data_par q_f2 = new data_par();
    
    public static Workspace[] ws;		// workspace objects
    public static int aws = 0;			// active workspace, initial active workspace is 0
     
    public static ChildDataWindow[] childWindow;
    public static boolean[] childWindowActive;
    public static int nChildWindows = 0;
    
    static Image image;
    public static GC gcImage;
    
    public static Point windowLocation = new Point(0, 0);
    
    static IntegDialog integDialog;
    
//  Various program limits and settings
    protected final static int MAX_TRACES = 1024;			// maximum number of stacked traces
    protected final static int MAX_INTEGRALS = 1024;	    // maximum number of integrals
    public final static int MAX_DECON_PEAKS = 25;	    	// maximum number of deconvolution peaks
    protected final static int MAX_BOXES = 32;				// maximum number of inset boxes
    protected final static int MAX_LEVELS = 16;				// maximum number of contour levels
    protected final static int MAX_WS = 7;            		// maximum number of active workspaces
    protected final static int MAX_CHILD_WINDOWS = 5;		// maximum number of child data windows
    protected final static int SINE_TABLE_LENGTH = 20;      // sine table length
       
    protected final static boolean BIG_ENDIAN = true;		// JVM is BIG_ENDIAN only
    
    public static int SMALL_FONT = 10;
    public static int MEDIUM_FONT = 12;
    public static int BIG_FONT = 14;   

    public enum data_types      { BRUKER, VNMR, JEOL, TECMAG, JCAMP_DX, SIMPSON, NMRPIPE,
        						  CDFF, MAGRITEK };
	public enum modes           { MODE_1D, MODE_2D, MODE_3D, MODE_FID };
	public enum modes_3D        { XZ, XY, YZ };
	public enum display_modes   { IMAGE, CONTOUR };
	public enum trace_modes     { ROWS, COLUMNS, LABEL };
	public enum windows			{ NONE, EM, GM, SINE, QSINE, TRAF, TRAFS, GAUSSIAN };
	public enum phasing         { NONE, CONSTANTS, MAGNITUDE, POWER, AUTO };
	public enum det_modes       { SIM, SEQ, DSP, CUSTOM_DSP };  // acquisition dimension
	public enum det_modes_IND   { QF, SEQUENTIAL, TPPI, STATES, 
								  STATES_TPPI, ECHO_ANTIECHO }; // indirect dimensions
	
	public enum FnMODEs         { UNDEFINED, QF, SEQUENTIAL, TPPI, STATES, STATES_TPPI, 
	        					  ECHO_ANTIECHO };              // Bruker specific
	
	public enum LP_modes        { LP_OFF, FORWARD_COMPLEX, FORWARD_REAL, BACK_COMPLEX, BACK_REAL,
	        					  ZHU_BAX };
	public enum units           { HZ, PPM, SEC, KHZ };
	public enum byte_orders     { LITTLE, BIG };
	public enum direction       { INDIRECT, DIRECT };
	public enum shapes			{ LOREN, GAUSS };
	public enum corr            { COSY, TOCSY, NOESY, HMBC, HSQC };
	public enum level_spacing   { LINEAR, LOG };
	public enum BL_modes        { POLY, SPLINE, WHITTAKER };
	public enum filters 		{ FILT_NONE, FILT_SINE, FILT_GAUSS, FILT_TRIANGLE };
	
	
//  Please, why oh why doesn't Java have preprocessor directives???
	public enum osTypes			{ WINDOWS, MACOS, LINUX }
	public static osTypes currentOS = osTypes.WINDOWS;	
	protected static String userHome = "";
	protected static String osName = "";	
	protected static String parentFolder;	// parent to the jar file
	public static String version = "SpinWorks Java open source Windows 2020 02 26   ";
	public static final String APP_NAME = "SpinWorks";	// for MacOS
	public static String lineSep = System.getProperty( "line.separator" ); // OS dependent line separator
	public static String fileSep = System.getProperty( "file.separator" ); // OS dependent path separator	
	
//  if auto data type selection
    public static boolean auto_data_format = true;
    public static int current_row = 0, current_column = 0;
       
//	recent files object
	public static RecentFiles file_obj;
	
//-------------------------------------------------------------------------------------------------	    
/**
 * Launch the application.
 * @param args passed to main(), typically a data set path
 */
    public static void main(String[] args)
    { 	      	  	   	
    	Display.setAppName("SpinWorks");  		// try this, should fix "SWT" problem in MacOS
    	Display display = Display.getDefault();	// doesn't!!! 
    	getOS_Info();							// get some info on the current OS
    											// and set some defaults based on OS type
    	
    	if(currentOS == osTypes.MACOS)
    	{
    		System.setProperty("apple.laf.useScreenMenuBar", "true");	// nope, doesn't seem to work either
    		System.setProperty("com.apple.mjr.application.apple.menu.about.name", "SpinWorks");
    	}
    	
    	/*if(SWT.getPlatform().equals("cocoa"))
    	{
    		new CocoaUIEnhancer().earlyStartup();	// This doesn't seem to help either
    		System.out.println("CocoaUIEnhancer called");
    	}*/
    	  	
    	
    	// ensure decimal separator is "."
    	// TODO  Important: The decimal separator issue needs THOROUGH checking on non-NA machines
    	try{  Locale.setDefault(new Locale("en", "US"));  }
    	catch(	Exception ex){ex.printStackTrace();	}    		
    	       
        ws = new Workspace[MAX_WS];
        
        // create a set of blank workspaces  each workspace contains both "global" and data parameters
        for (int i = 0; i < MAX_WS; i++)
        {
        	ws[i] = new Workspace(gp, p, q, p_f1, q_f1 , sp );
        	ws[i].has_data = false;
        }
        
        childWindow = new ChildDataWindow[MAX_CHILD_WINDOWS];
        childWindowActive = new boolean[MAX_CHILD_WINDOWS];
        for(int i = 0; i < MAX_CHILD_WINDOWS; i++)
        	childWindowActive[i] = false;
        
        //Create sine table for faster (?) FFTs
        Fft.doSineTable(SINE_TABLE_LENGTH);
        if(gp.log_on)
        	Util.log_error("Sine table created");
 
        // Calculate defuault 2D contour colour scheme
    	Util_2D.calc_default_colours(gp);
    	
        // Create 2D pixel map
        GraphUtil2D.pix = new Pixel_2D[GraphUtil2D.MAX_PIXELS];
        for (int i = 0; i < GraphUtil2D.MAX_PIXELS; i++)
            GraphUtil2D.pix[i] = new Pixel_2D();
        
        // create recent files object and load list of recent files
    	file_obj = new RecentFiles(8);
    	PreferenceUtil.getPrefs();
    	PreferenceUtil.getMru();
    	
    	//set display font sizes based on registry settings
        if(gp.displayFontSize == 0)			// typical high res monitor
    	{	SMALL_FONT = 10;	MEDIUM_FONT = 12; 	BIG_FONT = 14;	}
    	else if(gp.displayFontSize == 1)
    	{	SMALL_FONT = 12;	MEDIUM_FONT = 14; 	BIG_FONT = 16;	}
    	else if(gp.displayFontSize == 2)	// Retina display??  or similar
    	{	SMALL_FONT = 14;	MEDIUM_FONT = 16; 	BIG_FONT = 18;	}
    	else if(gp.displayFontSize == 3)	// Retina display??  or similar
    	{	SMALL_FONT = 16;	MEDIUM_FONT = 18; 	BIG_FONT = 20;	}
    	
    	// start-up main window
        try
        {
            SW_main window = new SW_main();	// create SW_main object
            printStartInfo();				// Print and log some possibly useful info
            window.open(display);			// display now passed as an argument
        } 
        catch (Exception ex)
        {	
        	System.out.println("SpinWorks Java, exception in main window???");
        	ex.printStackTrace();
        } 
        System.exit(0);
    }
    
//-------------------------------------------------------------------------------------------------
/**
 * Open the window.
 */
    public void open(Display display)	// display now being passed from main()
    {	
        createContents();               		
        InterfaceUtil.set1D();         			// always start in 1D mode.
        
        shell.open();
        
     // try to get some display info, and adjust fonts accordingly
        try
        {
        	Rectangle rect = shell.getDisplay().getBounds();       	
        	
        	Point dpi = shell.getDisplay().getDPI();    	
        	Util.log_error(String.format("Display:  width = %d  height = %d", rect.width, rect.height));
        	Util.log_error(String.format("Display:  DPIx = %d  DPIy = %d", dpi.x, dpi.y));

        	// chose a display font size based on screen resolution, if user hasn't set a preference
        	if(gp.displayFontSize < 0)  // no registry entry
        	{
        		if(dpi.x > 90)			// typical high res monitor
        		{	SMALL_FONT = 10;	MEDIUM_FONT = 12; 	BIG_FONT = 14;	}
        		else if(dpi.x > 140)
        		{	SMALL_FONT = 12;	MEDIUM_FONT = 14; 	BIG_FONT = 16;	}
        		else if(dpi.x > 200)	// Retina display??  or similar
        		{	SMALL_FONT = 14;	MEDIUM_FONT = 16; 	BIG_FONT = 18;	}
        	}
        }
        catch(Exception ex)
        {	Util.show_and_log("Can't get display info", ex.getMessage());	}
     	
        shell.layout();
        
     // this is here (after createContents()) as shell has to be created in order for MessageBox to work
        if(currentOS == osTypes.WINDOWS)
        {
        	File fi = new File(gp.scratch_folder);
        	if (!fi.exists())
        	{
        		MessageBox messageBox = new MessageBox(shell, SWT.ICON_QUESTION
        				| SWT.YES | SWT.NO);
        		messageBox.setMessage("Scratch folder" + gp.scratch_folder
        				+ "doesn't exist\nDo you want to create it?");
        		messageBox.setText("SpinWorks Java: Scratch folder creation");
        		int response = messageBox.open();

        		if (response == SWT.YES)
        		{
        			try { fi.mkdir(); }
        			catch (Exception ex)
        			{
        				Util.show_and_log(String.format("Cannot create: %s", 
        						gp.scratch_folder), ex.getMessage());
        			}
        			if (fi.exists()) Util.log_error("created : " + gp.scratch_folder);
        		}
        	}
        }
             	
        while (!shell.isDisposed())
        {
            if (!display.readAndDispatch())
            {
                display.sleep();
            }
        }
    }

//-------------------------------------------------------------------------------------------------
/**
 * Create contents of the window.
 */
    protected void createContents()
    {
// shell
        shell = new Shell();
        shell.setSize(1200, 900);	// Perhaps dynamically size this according to display size?
        shell.setText(version);
        
        Rectangle rect = shell.getClientArea();
        gp.dxsize = rect.width - 100; gp.dysize = rect.height - 100;
        update_spect = true; 
    	  	             
// menu bar
        Menu menuBar = new Menu(shell, SWT.BAR);
        
// File menu
        MenuItem fileMenuHeader = new MenuItem(menuBar, SWT.CASCADE);
        fileMenuHeader.setText("&File");  
        fileMenu = new Menu(shell, SWT.DROP_DOWN);
        fileMenuHeader.setMenu(fileMenu);

        fileOpenItem = new MenuItem(fileMenu, SWT.PUSH);
        fileOpenItem.setText("&Open NMR Data Set...\tCtrl+O");
        fileOpenItem.setToolTipText("Select an NMR data set (fid, ser, .jdf, .dx/.jdx, or NMRPipe)");
        fileOpenItem.setAccelerator(SWT.MOD1 + 'O');
        
        @SuppressWarnings("unused")
		MenuItem separator1 = new MenuItem(fileMenu, SWT.SEPARATOR);
        
        fileReadF1Item = new MenuItem(fileMenu, SWT.PUSH);
        fileReadF1Item.setText("Read F1 Trace...");
        fileReadF1Item.setToolTipText("Read an F1 trace (JCAMP-DX) for display on 2D spectrum");
        
        fileReadF2Item = new MenuItem(fileMenu, SWT.PUSH);
        fileReadF2Item.setText("Read F2 Trace...");
        fileReadF2Item.setToolTipText("Read an F2 trace (JCAMP-DX) for display on 2D spectrum");
        
        @SuppressWarnings("unused")
		MenuItem separator19 = new MenuItem(fileMenu, SWT.SEPARATOR);
        
        fileSaveJDX_Item = new MenuItem(fileMenu, SWT.PUSH);
        fileSaveJDX_Item.setText("Save Processed 1D Data (JCAMP-DX)");
        fileSaveJDX_Item.setToolTipText("Saves the current 1D data as a JCAMP-DX file: \"spectrum.dx\"");
        
        fileSaveAsJDX_Item = new MenuItem(fileMenu, SWT.PUSH);
        fileSaveAsJDX_Item.setText("Save Processed Data 1D Data as (JCAMP-DX)...");
        fileSaveAsJDX_Item.setToolTipText("Saves the current 1D data as a JCAMP-DX file \nwith a name you select");
               
        fileSaveColumnsAsJDX_Item = new MenuItem(fileMenu, SWT.PUSH);
        fileSaveColumnsAsJDX_Item.setText("Save Displayed Columns as JCAMP-DX");
        fileSaveColumnsAsJDX_Item.setToolTipText("Save the displayed 2D columns as 1D JCAMP-DX files");
        
        fileSaveRowsAsJDX_Item = new MenuItem(fileMenu, SWT.PUSH);
        fileSaveRowsAsJDX_Item.setText("Save Displayed Rows as JCAMP-DX");
        fileSaveRowsAsJDX_Item.setToolTipText("Save the displayed 2D rows as 1D JCAMP-DX files");
             
        fileSaveItem = new MenuItem(fileMenu, SWT.PUSH);
        fileSaveItem.setText("&Save Processed Data (SpinWorks Format)\tCtrl+S");
        fileSaveItem.setAccelerator(SWT.MOD1 + 'S');
                
        fileReadItem = new MenuItem(fileMenu, SWT.PUSH);
        fileReadItem.setText("&Read Processed Data (SpinWorks Format) For This Data Set\tCtrl+R");
        fileReadItem.setToolTipText("Read processed data in SpinWorks format\nRead FID file first!");
        fileReadItem.setAccelerator(SWT.MOD1 + 'R');
        
        fileExportXY_Item = new MenuItem(fileMenu, SWT.PUSH);
        fileExportXY_Item.setText("Export XY Points to File...");
        fileExportXY_Item.setToolTipText("Dumps the current data (spectrum or FID) \nto atext file as XY pairs");
        
        @SuppressWarnings("unused")
		MenuItem separator2 = new MenuItem(fileMenu, SWT.SEPARATOR);
        
        filePrintItem = new MenuItem(fileMenu, SWT.PUSH);
        filePrintItem.setText("&Print Spectrum\tCtrl+P");
        filePrintItem.setAccelerator(SWT.MOD1 + 'P');
        
        filePrintPreviewItem = new MenuItem(fileMenu, SWT.PUSH);
        filePrintPreviewItem.setText("Print Preview...");
        filePrintPreviewItem.setToolTipText("Display the spectrum as it will be printed");
        
        @SuppressWarnings("unused")
		MenuItem separator20 = new MenuItem(fileMenu, SWT.SEPARATOR);
        
        fileRecentItem = new MenuItem(fileMenu, SWT.PUSH);
        fileRecentItem.setText("Recent Files...");
        fileRecentItem.setToolTipText("Select from a list of recently opened\ndata sets");
        
        @SuppressWarnings("unused")
		MenuItem separator21 = new MenuItem(fileMenu, SWT.SEPARATOR);
        
        fileExitItem = new MenuItem(fileMenu, SWT.PUSH);
        fileExitItem.setText("E&xit");
                
// Edit menu
        MenuItem editMenuHeader = new MenuItem(menuBar, SWT.CASCADE);
        editMenuHeader.setText("&Edit");               
        editMenu = new Menu(shell, SWT.DROP_DOWN);
        editMenuHeader.setMenu(editMenu);
        
        editProcParsItem = new MenuItem(editMenu, SWT.PUSH);
        editProcParsItem.setText("Edit Processing Parameters...");
        
        editPlotParsItem = new MenuItem(editMenu, SWT.PUSH);
        editPlotParsItem.setText("Edit Plot Parameters and Options...");
        
        editDisplayColoursItem = new MenuItem(editMenu, SWT.PUSH);
        editDisplayColoursItem.setText("Edit the Display Colours...");
            
        editPlotTitleItem = new MenuItem(editMenu, SWT.PUSH);
        editPlotTitleItem.setText("Edit Plot Title...");
        
        @SuppressWarnings("unused")
		MenuItem separator5 = new MenuItem(editMenu, SWT.SEPARATOR);
        
        editCopyToFilePNG = new MenuItem(editMenu, SWT.PUSH);
        editCopyToFilePNG.setText("Copy Spectrum Graphics to File (PNG)");
        editCopyToFilePNG.setToolTipText("Copy Spectrum Graphics to File (PNG) with preview\nas spect.png in current data folder");
        
        editCopyToFilePNG_As = new MenuItem(editMenu, SWT.PUSH);
        editCopyToFilePNG_As.setText("Copy Spectrum Graphics to Named File (PNG) As...");
        editCopyToFilePNG_As.setToolTipText("Copy Spectrum Graphics to File (PNG) with preview\nas with user defined name");
        
        editCopyToFileJPG = new MenuItem(editMenu, SWT.PUSH);
        editCopyToFileJPG.setText("Copy Spectrum Graphics to File (JPEG)");
                
// View menu
        MenuItem viewMenuHeader = new MenuItem(menuBar, SWT.CASCADE);
        viewMenuHeader.setText("&View");      
        viewMenu = new Menu (shell, SWT.DROP_DOWN);
        viewMenuHeader.setMenu(viewMenu);
        
        showSpectrumItem = new MenuItem(viewMenu, SWT.CHECK);
        showSpectrumItem.setText("Show Spectrum");
        if(gp.show_spectrum)showSpectrumItem.setSelection(true);
        
        showSimulatedItem = new MenuItem(viewMenu, SWT.CHECK);
        showSimulatedItem.setText("Show Simulated");
        if(gp.show_simulated)showSimulatedItem.setSelection(true);
        
        showIntegralsItem = new MenuItem(viewMenu, SWT.CHECK);
        showIntegralsItem.setText("Show Integrals");
        if(gp.show_integrals)showIntegralsItem.setSelection(true);
        
        showPeaksItem = new MenuItem(viewMenu, SWT.CHECK);
        showPeaksItem.setText("Show Picked Peaks");
        if(gp.match_on)showPeaksItem.setSelection(true);	// change name???
        
        showZeroLineItem = new MenuItem(viewMenu, SWT.CHECK);
        showZeroLineItem.setText("Show Zero Line");
        if(gp.show_zero_line)showZeroLineItem.setSelection(true);
        
        showYaxisItem = new MenuItem(viewMenu, SWT.CHECK);
        showYaxisItem.setText("Show 1D Y Axis");
        if(gp.show_yaxis)showYaxisItem.setSelection(true);
        
        showTitleItem = new MenuItem(viewMenu, SWT.CHECK);
        showTitleItem.setText("Show Title");
        if(gp.show_yaxis)showTitleItem.setSelection(true);
        
        FID_DisplayItem = new MenuItem(viewMenu, SWT.CHECK);
        FID_DisplayItem.setText("FID Display");
        
        @SuppressWarnings("unused")
        MenuItem separator6 = new MenuItem(viewMenu, SWT.SEPARATOR);
  
        
        MenuItem childWindowsItem = new MenuItem(viewMenu, SWT.CASCADE);
        childWindowsItem.setText("Child Windows");
        
        Menu subMenuChildWindows = new Menu(shell, SWT.DROP_DOWN);
        childWindowsItem.setMenu(subMenuChildWindows);
        
        createChildWindowItem = new MenuItem(subMenuChildWindows, SWT.PUSH);
        createChildWindowItem.setText("Create Child Window");
        createChildWindowItem.setToolTipText("Create a child window from the current data set");
        
        @SuppressWarnings("unused")
        MenuItem separator45 = new MenuItem(viewMenu, SWT.SEPARATOR);
        
        rotate2D_Item = new MenuItem(viewMenu, SWT.CHECK);
        rotate2D_Item.setText("Rotate 2D");         
        
        showF1TraceItem = new MenuItem(viewMenu, SWT.CHECK);
        showF1TraceItem.setText("Show F1 trace on 2D");
        showF1TraceItem.setSelection(true);
        
        showF2TraceItem = new MenuItem(viewMenu, SWT.CHECK);
        showF2TraceItem.setText("Show F2 trace on 2D");   
        showF2TraceItem.setSelection(true);
        
        MenuItem contourSpacing2D_Item = new MenuItem(viewMenu, SWT.CASCADE);
        contourSpacing2D_Item.setText("2D Contour Spacing");
        
        Menu subMenuContourSpacing = new Menu(shell, SWT.DROP_DOWN);
        contourSpacing2D_Item.setMenu(subMenuContourSpacing);
        
        contourSpacingLogItem = new MenuItem(subMenuContourSpacing, SWT.CHECK);
        contourSpacingLogItem.setText("Log");
        contourSpacingLogItem.setSelection(true);	// default
        
        contourSpacingLinearItem = new MenuItem(subMenuContourSpacing, SWT.CHECK);
        contourSpacingLinearItem.setText("Linear");
        
        @SuppressWarnings("unused")
        MenuItem separator9 = new MenuItem(subMenuContourSpacing, SWT.SEPARATOR);
        
        contourSpacingCoarseItem = new MenuItem(subMenuContourSpacing, SWT.CHECK);
        contourSpacingCoarseItem.setText("Coarse");
        contourSpacingCoarseItem.setSelection(true);	// default
        
        contourSpacingFineItem = new MenuItem(subMenuContourSpacing, SWT.CHECK);
        contourSpacingFineItem.setText("Fine");
        
        showCOSY_Item = new MenuItem(viewMenu, SWT.CHECK);
        showCOSY_Item.setText("Show Assigned COSY Correlations");    
        showCOSY_Item.setToolTipText("Show any COSY correlations from the 2D peak assignment tool\ntypically on an HSQC spectrum");
        
        showTOCSY_Item = new MenuItem(viewMenu, SWT.CHECK);
        showTOCSY_Item.setText("Show Assigned TOCSY Correlations");    
        showTOCSY_Item.setToolTipText("Show any TOCSY correlations from the 2D peak assignment tool\ntypically on an HSQC spectrum");
        
        showNOESY_Item = new MenuItem(viewMenu, SWT.CHECK);
        showNOESY_Item.setText("Show Assigned NOESY Correlations");  
        showNOESY_Item.setToolTipText("Show any NOESY correlations from the 2D peak assignment tool\ntypically on an HSQC spectrum");
        
        showHMBC_Item = new MenuItem(viewMenu, SWT.CHECK);
        showHMBC_Item.setText("Show Assigned HMBC Correlations");    
        showHMBC_Item.setToolTipText("Show any HMBC correlations from the 2D peak assignment tool\ntypically on an HSQC spectrum");
        
        @SuppressWarnings("unused")
        MenuItem separator42 = new MenuItem(viewMenu, SWT.SEPARATOR);
        
        XY_3D_Item = new MenuItem(viewMenu, SWT.CHECK);
        XY_3D_Item.setText("3D Display Mode: XY");
        
        XZ_3D_Item = new MenuItem(viewMenu, SWT.CHECK);
        XZ_3D_Item.setText("3D Display Mode: XZ");   
        
        @SuppressWarnings("unused")
        MenuItem separator10 = new MenuItem(viewMenu, SWT.SEPARATOR);
       
        copyToBoxItem = new MenuItem(viewMenu, SWT.PUSH);
        copyToBoxItem.setText("Copy to Inset Box");
        copyToBoxItem.setToolTipText("Copy the currently selected region to an inset box");
        
        @SuppressWarnings("unused")
        MenuItem separator29 = new MenuItem(viewMenu, SWT.SEPARATOR);
        
        exptToStackItem = new MenuItem(viewMenu, SWT.PUSH);
        exptToStackItem.setText("Copy Experimental to Stack");
        exptToStackItem.setToolTipText("Copy the current experimental data to a stack trace");
       
        simulatedToStackItem = new MenuItem(viewMenu, SWT.PUSH);
        simulatedToStackItem.setText("Copy Simulated to Stack");
        simulatedToStackItem.setToolTipText("Copy the current simulated data to a stack trace");
        
        addSimulatedToStackItem = new MenuItem(viewMenu, SWT.PUSH);
        addSimulatedToStackItem.setText("Add Simulated to Stack");
        addSimulatedToStackItem.setToolTipText("Add the current simulated data to stack trace 1");
        
        seriesExnoToStackItem = new MenuItem(viewMenu, SWT.PUSH);
        seriesExnoToStackItem.setText("Copy a Bruker Series of Experiment Numbers to Stack");
        seriesExnoToStackItem.setToolTipText("Copy Bruker Series of processed 1D\nExperiment Numbers to Stack");
        
        dsshItem = new MenuItem(viewMenu, SWT.PUSH);
        dsshItem.setText("\"dssh\" Type Stack Trace");
        dsshItem.setToolTipText("A varian \"dssh\" type stack trace of current stack");
        

        deleteStackTraceItem = new MenuItem(viewMenu, SWT.PUSH);
        deleteStackTraceItem.setText("Delete the Last Trace Added to the Stack");
        deleteStackTraceItem.setToolTipText("Delete the Last Trace Added to the Stack");
        
        deleteStackTracesItem = new MenuItem(viewMenu, SWT.PUSH);
        deleteStackTracesItem.setText("Delete All Stacked Traces");
        deleteStackTracesItem.setToolTipText("Delete All Stacked Traces");
        
        stackedTraceDialogItem = new MenuItem(viewMenu, SWT.PUSH);
        stackedTraceDialogItem.setText("Stacked Trace Dialog...");
        stackedTraceDialogItem.setToolTipText("Start a dialog for adjusting the scaling, offset, etc. \nof the stacked traces");
              
        @SuppressWarnings("unused")
        MenuItem separator22 = new MenuItem(viewMenu, SWT.SEPARATOR);
        
        MenuItem axisF2UnitsMenuItem = new MenuItem(viewMenu, SWT.CASCADE);
        axisF2UnitsMenuItem.setText("F2 Axis Units");
        
        Menu subMenuF2Units = new Menu(shell, SWT.DROP_DOWN);	// axis units F2
        axisF2UnitsMenuItem.setMenu(subMenuF2Units);
        
        unitsF2Hz = new MenuItem(subMenuF2Units, SWT.CHECK);
        unitsF2Hz.setText("Hz.");
        
        unitsF2PPM = new MenuItem(subMenuF2Units, SWT.CHECK);
        unitsF2PPM.setText("PPM");
        unitsF2PPM.setSelection(true);	// default
        
        MenuItem axisF1UnitsMenuItem = new MenuItem(viewMenu, SWT.CASCADE);
        axisF1UnitsMenuItem.setText("F1 Axis Units");
        
        Menu subMenuF1Units = new Menu(shell, SWT.DROP_DOWN);	// axis units F1
        axisF1UnitsMenuItem.setMenu(subMenuF1Units);
        
        unitsF1Hz = new MenuItem(subMenuF1Units, SWT.CHECK);
        unitsF1Hz.setText("Hz.");
        
        unitsF1PPM = new MenuItem(subMenuF1Units, SWT.CHECK);
        unitsF1PPM.setText("PPM");
        unitsF1PPM.setSelection(true);	// default
             
// ROI menu
        MenuItem roiMenuHeader = new MenuItem(menuBar, SWT.CASCADE);
        roiMenuHeader.setText("&ROI");        
        Menu roiMenu = new Menu(shell, SWT.DROP_DOWN);
        roiMenuHeader.setMenu(roiMenu);
        
        setFixedLimitsItem = new MenuItem(roiMenu, SWT.CASCADE);
        setFixedLimitsItem.setText("Set Fixed Limits");      
        setFixedLimitsItem.setToolTipText("Set display limits \nto a number of fixed standard regions");
        Menu subMenuFixedLimits = new Menu(shell, SWT.DROP_DOWN);
        setFixedLimitsItem.setMenu(subMenuFixedLimits);
        
        protonSurveyItem = new MenuItem(subMenuFixedLimits, SWT.PUSH);
        protonSurveyItem.setText("Proton Survey (9.5 to -.5 ppm)");
        
        carbonSurveyItem = new MenuItem(subMenuFixedLimits, SWT.PUSH);
        carbonSurveyItem.setText("Carbon Survey (210 to -10 ppm)");
        
        setFixedScaleItem = new MenuItem(roiMenu, SWT.CASCADE);
        setFixedScaleItem.setText("Set Fixed Scale");
        setFixedScaleItem.setToolTipText("Set the print horizontal scaling \nto a fixed Hz/cm or ppm/cm");
        Menu subMenuFixedScale = new Menu(shell, SWT.DROP_DOWN);
        setFixedScaleItem.setMenu(subMenuFixedScale);
        
        scale5HzCmItem = new MenuItem(subMenuFixedScale, SWT.PUSH);
        scale5HzCmItem.setText("5 Hz/cm");
        
        scale10HzCmItem = new MenuItem(subMenuFixedScale, SWT.PUSH);
        scale10HzCmItem.setText("10 Hz/cm");
        
        scale20HzCmItem = new MenuItem(subMenuFixedScale, SWT.PUSH);
        scale20HzCmItem.setText("20 Hz/cm");
        
        @SuppressWarnings("unused")
        MenuItem separator27 = new MenuItem(subMenuFixedScale, SWT.SEPARATOR);
        
        scalep1ppmCmItem = new MenuItem(subMenuFixedScale, SWT.PUSH);
        scalep1ppmCmItem.setText("0.1 ppm/cm");
        
        scale1ppmCmItem = new MenuItem(subMenuFixedScale, SWT.PUSH);
        scale1ppmCmItem.setText("1 ppm/cm");
        
        scale5ppmCmItem = new MenuItem(subMenuFixedScale, SWT.PUSH);
        scale5ppmCmItem.setText("5 ppm/cm");
        
        scale10ppmCmItem = new MenuItem(subMenuFixedScale, SWT.PUSH);
        scale10ppmCmItem.setText("10 ppm/cm");
        
        scale20ppmCmItem = new MenuItem(subMenuFixedScale, SWT.PUSH);
        scale20ppmCmItem.setText("20 ppm/cm");
        
        @SuppressWarnings("unused")
        MenuItem separator28 = new MenuItem(subMenuFixedScale, SWT.SEPARATOR);
        
        scaleUserDefinedItem = new MenuItem(subMenuFixedScale, SWT.PUSH);
        scaleUserDefinedItem.setText("User Defined Scale");
        
// Options menu
        MenuItem optionsMenuHeader = new MenuItem(menuBar, SWT.CASCADE);
        optionsMenuHeader.setText("&Options");        
        Menu optionsMenu = new Menu(shell, SWT.DROP_DOWN);
        optionsMenuHeader.setMenu(optionsMenu);    
        
        MenuItem dataTypeMenuItem = new MenuItem(optionsMenu, SWT.CASCADE);
        dataTypeMenuItem.setText("Data Type");              
        Menu subMenuDataType = new Menu(shell, SWT.DROP_DOWN);	// data type
        dataTypeMenuItem.setMenu(subMenuDataType);
        
        dataTypeAutoItem = new MenuItem(subMenuDataType, SWT.CHECK);
        dataTypeAutoItem.setText("Auto");
        dataTypeAutoItem.setSelection(true);
        
        dataTypeBrukerItem = new MenuItem(subMenuDataType, SWT.CHECK);
        dataTypeBrukerItem.setText("Bruker (UXNMR/XwinNMR/TopSpin");;
        
        dataTypeVNMRItem = new MenuItem(subMenuDataType, SWT.CHECK);
        dataTypeVNMRItem.setText("Varian/Agilent (VNMR/VNMRJ)");
        
        dataTypeJEOLItem = new MenuItem(subMenuDataType, SWT.CHECK);
        dataTypeJEOLItem.setText("JEOL");
        
        dataTypeJDXItem = new MenuItem(subMenuDataType, SWT.CHECK);
        dataTypeJDXItem.setText("JCAMP DX");
        
        dataTypeMagritek = new MenuItem(subMenuDataType, SWT.CHECK);
        dataTypeMagritek.setText("Magritek");
        
        dataTypeNMRpipeItem = new MenuItem(subMenuDataType, SWT.CHECK);
        dataTypeNMRpipeItem.setText("NMRpipe");
        
        @SuppressWarnings("unused")
        MenuItem separator8 = new MenuItem(subMenuDataType, SWT.SEPARATOR);
        
        dataType1DItem = new MenuItem(subMenuDataType, SWT.CHECK);
        dataType1DItem.setText("1D");
        
        dataType2DItem = new MenuItem(subMenuDataType, SWT.CHECK);
        dataType2DItem.setText("2D");
        
        dataType3DItem = new MenuItem(subMenuDataType, SWT.CHECK);
        dataType3DItem.setText("3D");
        
        startUpOptionsItem = new MenuItem(optionsMenu, SWT.PUSH);
        startUpOptionsItem.setText("Set Start-up Options...");
        
        @SuppressWarnings("unused")
        MenuItem separator11 = new MenuItem(optionsMenu, SWT.SEPARATOR);
        
        extendedDebugLoggingItem = new MenuItem(optionsMenu, SWT.CHECK);
        extendedDebugLoggingItem.setText("Extended Debug Logging");
        
        showLogFileItem = new MenuItem(optionsMenu, SWT.PUSH);
        showLogFileItem.setText("Show Log File");
        
        clearLogFileItem = new MenuItem(optionsMenu, SWT.PUSH);
        clearLogFileItem.setText("Clear Log File");
        
// Processing menu
        MenuItem processingMenuHeader = new MenuItem(menuBar, SWT.CASCADE);
        processingMenuHeader.setText("&Processing");        
        processingMenu = new Menu(shell, SWT.DROP_DOWN);
        processingMenuHeader.setMenu(processingMenu);
        
        ftItem = new MenuItem(processingMenu, SWT.PUSH);
        ftItem.setText("Fourier Transform");
        
        efItem = new MenuItem(processingMenu, SWT.PUSH);
        efItem.setText("Window + Fourier Transform");
        
        efpItem = new MenuItem(processingMenu, SWT.PUSH);
        efpItem.setText("Window + Fourier Transform + Phase");
        
        @SuppressWarnings("unused")
        MenuItem separator7 = new MenuItem(processingMenu, SWT.SEPARATOR);
        
        dcItem = new MenuItem(processingMenu, SWT.PUSH);
        dcItem.setText("Drift Correct Processed Data");
        
        splineBC_Item = new MenuItem(processingMenu, SWT.PUSH);
        splineBC_Item.setText("Cubic Spline Baseline Correction");
        
        leastSquaresBC_Item = new MenuItem(processingMenu, SWT.PUSH);
        leastSquaresBC_Item.setText("Least Squares Baseline Correction");
        
        clearBCPointsItem = new MenuItem(processingMenu, SWT.PUSH);
        clearBCPointsItem.setText("Clear Baseline Points");
        
        fullyAutoBC_Item = new MenuItem(processingMenu, SWT.PUSH);
        fullyAutoBC_Item.setText("Fully Automatic Baseline Correction");
        
        @SuppressWarnings("unused")
        MenuItem separator3 = new MenuItem(processingMenu, SWT.SEPARATOR);
        
// 2D processing sub-menu
        proc2D_MenuItem = new MenuItem(processingMenu, SWT.CASCADE);
        proc2D_MenuItem.setText("2D");
        
        Menu subMenu2D = new Menu(shell, SWT.DROP_DOWN);
        proc2D_MenuItem.setMenu(subMenu2D);
        
        symmetrizeMenuItem = new MenuItem(subMenu2D, SWT.PUSH);
        symmetrizeMenuItem.setText("Symmetrize");
        symmetrizeMenuItem.setToolTipText("Apply a symmetrization to the data/ndata must have equal size, SW and referencing in both dimensions\ne.g. COSY");
        
        smoothMenuItem = new MenuItem(subMenu2D, SWT.PUSH);
        smoothMenuItem.setText("Smooth");
        smoothMenuItem.setToolTipText("Apply a smoothing to both dimensions of the data\nimproves S:N but decreases resolution");
        
        @SuppressWarnings("unused")
        MenuItem separator12 = new MenuItem(subMenu2D, SWT.SEPARATOR);
        
        baselineCorrectF2MenuItem = new MenuItem(subMenu2D, SWT.PUSH);
        baselineCorrectF2MenuItem.setText("Baseline Correct (F2)");
        baselineCorrectF2MenuItem.setToolTipText("Apply a fully automatic (Whittaker) baseline correction\nto the acquisition dimension");
        
        baselineCorrectF1MenuItem = new MenuItem(subMenu2D, SWT.PUSH);
        baselineCorrectF1MenuItem.setText("Baseline Correct (F1)");
        baselineCorrectF1MenuItem.setToolTipText("Apply a fully automatic (Whittaker) baseline correction\nto the indirect dimension");
        
        @SuppressWarnings("unused")
        MenuItem separator13 = new MenuItem(subMenu2D, SWT.SEPARATOR);
        
        driftCorrectF2MenuItem = new MenuItem(subMenu2D, SWT.PUSH);
        driftCorrectF2MenuItem.setText("Drift Correct (F2)");
        driftCorrectF2MenuItem.setToolTipText("Apply a simple linear tilt (Varian type \"drift correction\")\nto the acquisition dimension" );
        
        driftCorrectF1MenuItem = new MenuItem(subMenu2D, SWT.PUSH);
        driftCorrectF1MenuItem.setText("Drift Correct (F1)");
        driftCorrectF1MenuItem.setToolTipText("Apply a simple linear tilt (Varian type \"drift correction\")\nto the indirect dimension" );
        
        @SuppressWarnings("unused")
        MenuItem separator14 = new MenuItem(subMenu2D, SWT.SEPARATOR);
        
        calculateF2ProjectionMenuItem = new MenuItem(subMenu2D, SWT.PUSH);
        calculateF2ProjectionMenuItem.setText("Calculate F2 Projection");
        calculateF2ProjectionMenuItem.setToolTipText("Calculate a \"skyline\" projection of the acquisition dimension,\nsaved as a JCAMP-DX file");
           
        calculateF1ProjectionMenuItem = new MenuItem(subMenu2D, SWT.PUSH);
        calculateF1ProjectionMenuItem.setText("Calculate F1 Projection");
        calculateF1ProjectionMenuItem.setToolTipText("Calculate a \"skyline\" projection of the indirect dimension,\nsaved as a JCAMP-DX file");
        
        calculateF2SumMenuItem = new MenuItem(subMenu2D, SWT.PUSH);
        calculateF2SumMenuItem.setText("Calculate F2 Sum");
        calculateF2SumMenuItem.setToolTipText("Calculate a sum of the acquisition dimension,\nsaved as a JCAMP-DX file");
        
        calculateF1SumMenuItem = new MenuItem(subMenu2D, SWT.PUSH);
        calculateF1SumMenuItem.setText("Calculate F1 Sum");
        calculateF1SumMenuItem.setToolTipText("Calculate a sum of the indirect dimension,\nsaved as a JCAMP-DX file");
        
        @SuppressWarnings("unused")
        MenuItem separator15 = new MenuItem(subMenu2D, SWT.SEPARATOR);
        
        clearImagMenuItem = new MenuItem(subMenu2D, SWT.PUSH);
        clearImagMenuItem.setText("Clear Imaginary Quadrants");
        clearImagMenuItem.setToolTipText("Clear imaginary quadrants to save memory.\nCan regenerate with a Hilbert transform");
        
        @SuppressWarnings("unused")
        MenuItem separator16 = new MenuItem(subMenu2D, SWT.SEPARATOR);
        
        hilbertTransformF2MenuItem = new MenuItem(subMenu2D, SWT.PUSH);
        hilbertTransformF2MenuItem.setText("Hilbert Transform F2");
        hilbertTransformF2MenuItem.setToolTipText("Regenerate imaginary data in acquisition dimension");
        
        hilbertTransformF1MenuItem = new MenuItem(subMenu2D, SWT.PUSH);
        hilbertTransformF1MenuItem.setText("Hilbert Transform F1");
        hilbertTransformF1MenuItem.setToolTipText("Regenerate imaginary data in indirect dimension");
        
        @SuppressWarnings("unused")
        MenuItem separator17 = new MenuItem(subMenu2D, SWT.SEPARATOR);
        
        tiltJResolvedMenuItem = new MenuItem(subMenu2D, SWT.PUSH);
        tiltJResolvedMenuItem.setText("Tilt J Resolved Spectrum");
        tiltJResolvedMenuItem.setToolTipText("Tilt a homonuclear J spectrum so that the F2 axis contains only shifts");
        
        symmetrizeJResolvedMenuItem = new MenuItem(subMenu2D, SWT.PUSH);
        symmetrizeJResolvedMenuItem.setText("Symmetrize J Resolved");
        symmetrizeJResolvedMenuItem.setToolTipText("Apply a symmetrization to the data/nabout F1 = 0");

        autoReferenceF1 = new MenuItem(processingMenu, SWT.CASCADE);
        autoReferenceF1.setText("Auto Reference F1");
        autoReferenceF1.setToolTipText("Reference the indirect dimension based on the\nreferencing in the acquisition dimension");
        
        Menu autoRefList = new Menu(shell, SWT.DROP_DOWN);
        autoReferenceF1.setMenu(autoRefList);
        
        referenceF1_13CtoCDCl3 = new MenuItem(autoRefList, SWT.PUSH);
        referenceF1_13CtoCDCl3.setText("13C CDCl3");
        
        referenceF1_13CtoD2O_TSP = new MenuItem(autoRefList, SWT.PUSH);
        referenceF1_13CtoD2O_TSP.setText("13C D2O (TSP)");
        
        referenceF1_13CtoD2O_DSS = new MenuItem(autoRefList, SWT.PUSH);
        referenceF1_13CtoD2O_DSS.setText("13C D2O (DSS)");
        
        referenceF1_13CtoAcetone = new MenuItem(autoRefList, SWT.PUSH);
        referenceF1_13CtoAcetone.setText("13C Acetone-d6");
        
        referenceF1_13CtoDMSO = new MenuItem(autoRefList, SWT.PUSH);
        referenceF1_13CtoDMSO.setText("13C DMSO-d6");
        
        referenceF1_13CtoBenzene = new MenuItem(autoRefList, SWT.PUSH);
        referenceF1_13CtoBenzene.setText("13C Benzene-d6");
        
        referenceF1_15N_D2O = new MenuItem(autoRefList, SWT.PUSH);
        referenceF1_15N_D2O.setText("15N in D2O");
        
        referenceF1_Homonuclear = new MenuItem(autoRefList, SWT.PUSH);
        referenceF1_Homonuclear.setText("Homonuclear (F1 = F2)");
 
        @SuppressWarnings("unused")
        MenuItem separator18 = new MenuItem(processingMenu, SWT.SEPARATOR);
        
// 3D processing sub-menu
        proc3D_MenuItem = new MenuItem(processingMenu, SWT.CASCADE);
        proc3D_MenuItem.setText("3D");
        
        Menu subMenu3D = new Menu(shell, SWT.DROP_DOWN);
        proc3D_MenuItem.setMenu(subMenu3D);
        
        processFirstXY_Item = new MenuItem(subMenu3D, SWT.PUSH);
        processFirstXY_Item.setText("Process First XY Plane");
        processFirstXY_Item.setToolTipText("Process only the first XY plane");
        
        processXY_Item = new MenuItem(subMenu3D, SWT.PUSH);
        processXY_Item.setText("Process XY Planes");
        processXY_Item.setToolTipText("Process all planes in the XY direction");
        
        processZofXY_Item = new MenuItem(subMenu3D, SWT.PUSH);
        processZofXY_Item.setText("Process Z of XY");
        processZofXY_Item.setToolTipText("Process the Z dimension of data already processed in XY");
        
        @SuppressWarnings("unused")
        MenuItem separator37 = new MenuItem(subMenu3D, SWT.SEPARATOR);
        
        processFirstXZ_Item = new MenuItem(subMenu3D, SWT.PUSH);
        processFirstXZ_Item.setText("Process First XZ Plane");
        processFirstXZ_Item.setToolTipText("Process only the first XZ plane");
        
        processXZ_Item = new MenuItem(subMenu3D, SWT.PUSH);
        processXZ_Item.setText("Process XZ Planes");
        processXZ_Item.setToolTipText("Process all planes in the XZ direction");
        
        processYofXZ_Item = new MenuItem(subMenu3D, SWT.PUSH);
        processYofXZ_Item.setText("Process Y of XZ");
        processYofXZ_Item.setToolTipText("Process the Y dimension of data already processed in XZ");
        
        @SuppressWarnings("unused")
        MenuItem separator38 = new MenuItem(subMenu3D, SWT.SEPARATOR);
        
        bcPlanesDirectItem = new MenuItem(subMenu3D, SWT.PUSH);
        bcPlanesDirectItem.setText("Baseline Correct Direct");
        bcPlanesDirectItem.setToolTipText("Automatic baseline correction of the \ndirect (acquisition) dimension");
        
        bcPlanesIndirectItem = new MenuItem(subMenu3D, SWT.PUSH);
        bcPlanesIndirectItem.setText("Baseline Correct Current Indirect");
        bcPlanesIndirectItem.setToolTipText("Automatic baseline correction of the \ncurrent indirect (evolution) dimension");
        
        @SuppressWarnings("unused")
        MenuItem separator39 = new MenuItem(subMenu3D, SWT.SEPARATOR);
        
        phasePlanesDirectItem = new MenuItem(subMenu3D, SWT.PUSH);
        phasePlanesDirectItem.setText("Phase Correct Direct");
        phasePlanesDirectItem.setToolTipText("Apply phase correction to the \ndirect (acquisition) dimension");
        
        phasePlanesIndirectItem = new MenuItem(subMenu3D, SWT.PUSH);
        phasePlanesIndirectItem.setText("Phase Correct Current Indirect");
        phasePlanesIndirectItem.setToolTipText("Apply phase correction to the \ncurrent indirect (evolution) dimension");
        
        @SuppressWarnings("unused")
        MenuItem separator40 = new MenuItem(subMenu3D, SWT.SEPARATOR);
        
        hilbertTransformDirectItem = new MenuItem(subMenu3D, SWT.PUSH);
        hilbertTransformDirectItem.setText("Hilbert Transform Direct");
        hilbertTransformDirectItem.setToolTipText("Regenerate imaginary quadrant with a Hilbert Transform");
        
        hilbertTransformIndirectItem = new MenuItem(subMenu3D, SWT.PUSH);
        hilbertTransformIndirectItem.setText("Hilbert Transform Current Indirect");
        hilbertTransformIndirectItem.setToolTipText("Regenerate imaginary quadrant with a Hilbert Transform");
        
        @SuppressWarnings("unused")
        MenuItem separator41 = new MenuItem(subMenu3D, SWT.SEPARATOR);
        
        freeImaginariesItem =  new MenuItem(subMenu3D, SWT.PUSH);
        freeImaginariesItem.setText("Free Imaginary Space (rri cube)");
        freeImaginariesItem.setToolTipText("Free up the memory occupied by the rri cube.\n Can be regenerated with Hilbert Transform");
        
        freeImaginariesOnDiskItem =  new MenuItem(subMenu3D, SWT.PUSH);
        freeImaginariesOnDiskItem.setText("Free Imaginary (XYt and XZt) Planes from Disk");
        freeImaginariesOnDiskItem.setToolTipText("Clear unecessary planes from disk after final transform");
        
        autoReferenceCurrentIndirect = new MenuItem(processingMenu, SWT.CASCADE);
        autoReferenceCurrentIndirect.setText("Auto Reference Current Indirect");
        autoReferenceCurrentIndirect.setToolTipText("Reference current indirect dimension\nbased on the acquisition dimensikon");
        
        Menu autoRefIndirectList = new Menu(shell, SWT.DROP_DOWN);
        autoReferenceCurrentIndirect.setMenu(autoRefIndirectList);
        
        referenceIndirect15N = new MenuItem(autoRefIndirectList, SWT.PUSH);
        referenceIndirect15N.setText("15N D2O");
        
        referenceIndirect13C = new MenuItem(autoRefIndirectList, SWT.PUSH);
        referenceIndirect13C.setText("13C D2O");
        
        referenceIndirectHomonuclear = new MenuItem(autoRefIndirectList, SWT.PUSH);
        referenceIndirectHomonuclear.setText("Homonuclear (= Direct)");
        
        @SuppressWarnings("unused")
        MenuItem separator4 = new MenuItem(processingMenu, SWT.SEPARATOR);
         
// Array processing sub-menu
        procSeriesMenuItem = new MenuItem(processingMenu, SWT.CASCADE);
        procSeriesMenuItem.setText("Arrays and Series");
        procSeriesMenuItem.setToolTipText("Tools for processing arrays and series of spectra");
        
        Menu subMenuSeries = new Menu(shell, SWT.DROP_DOWN);
        procSeriesMenuItem.setMenu(subMenuSeries);
        
        processSeriesExNoItem = new MenuItem(subMenuSeries, SWT.PUSH);
        processSeriesExNoItem.setText("Process a Series of Experiment Numbers (Bruker)");
        processSeriesExNoItem.setToolTipText("Process a series of 1D Bruker experiment numbers\neg. a kinetics run");
        
        processArrayBrukerItem = new MenuItem(subMenuSeries, SWT.PUSH);
        processArrayBrukerItem.setText("Process a Bruker Array (ser file)");
        processArrayBrukerItem.setToolTipText("Process a series of 1D Bruker experiments saved in an ser file\neg. a T1 run");
        
        processArrayVarianItem = new MenuItem(subMenuSeries, SWT.PUSH);
        processArrayVarianItem.setText("Process a Varian Array");
        processArrayVarianItem.setToolTipText("Process a series of 1D Varian experiments\neg. a T1 run, pulse calibration, etc.");
        
        autoBaselineSeriesExNoItem = new MenuItem(subMenuSeries, SWT.PUSH);
        autoBaselineSeriesExNoItem.setText("Automatic Baseline Correct a Series of Experiment Numbers (Bruker)");
        autoBaselineSeriesExNoItem.setToolTipText("Baseline correct (Whittaker) a series of 1D Bruker experiment numbers\neg. a kinetics run");
        
        autoBaselineArrayItem = new MenuItem(subMenuSeries, SWT.PUSH);
        autoBaselineArrayItem.setText("Automatic Baseline Correct a Processed Array");
        autoBaselineArrayItem.setToolTipText("Baseline correct (Whittaker) a series of 1D experiments stored as an array\neg. a T1 run or pulse calibration");
        
        @SuppressWarnings("unused")
        MenuItem separator23 = new MenuItem(processingMenu, SWT.SEPARATOR);
        
        hilbertTransformItem = new MenuItem(processingMenu, SWT.PUSH);
        hilbertTransformItem.setText("Hilbert Transform");
        hilbertTransformItem.setToolTipText("Perform Hilbert transform to regenerate imaginary data\nusually JCAMP-DX");
        
        @SuppressWarnings("unused")
        MenuItem separator44 = new MenuItem(processingMenu, SWT.SEPARATOR);
        
        subtractTrace1Item = new MenuItem(processingMenu, SWT.PUSH);
        subtractTrace1Item.setText("Subtract Stack Trace 1 from Experimental");
        subtractTrace1Item.setToolTipText("Subtract a spectrum in stacked trace 1 from the experimental, e.g. for difference spectroscopy");
        
        addTrace1Item = new MenuItem(processingMenu, SWT.PUSH);
        addTrace1Item.setText("Add Trace 2 to Experimental");
        addTrace1Item.setToolTipText("Add a spectrum in stacked trace 1 to the experimental, e.g. for summing experiments");
        
        // for code testing
        testItem = new MenuItem(processingMenu, SWT.PUSH);
        testItem.setText("Test");
        //testItem.setText("");
        testItem.setEnabled(true);
     
// Peak Pick menu
        MenuItem peakPickMenuHeader = new MenuItem(menuBar, SWT.CASCADE);
        peakPickMenuHeader.setText("Peaks and Integrals");        
        peakPickMenu = new Menu(shell, SWT.DROP_DOWN);
        peakPickMenuHeader.setMenu(peakPickMenu);
        
        pickPeaksItem = new MenuItem(peakPickMenu, SWT.PUSH);
        pickPeaksItem.setText("Pick Peaks and Append to List");
        pickPeaksItem.setToolTipText("Pick peaks in currently displayed region\nand add to the peak list");
        
        clearPeaksItem = new MenuItem(peakPickMenu, SWT.PUSH);
        clearPeaksItem.setText("Clear Entire Peak List");
        
        clearRegionPeaksItem = new MenuItem(peakPickMenu, SWT.PUSH);
        clearRegionPeaksItem.setText("Clear Peaks in Display Region");
        
        @SuppressWarnings("unused")
        MenuItem separator24 = new MenuItem(peakPickMenu, SWT.SEPARATOR);
        
        peakPickStackItem = new MenuItem(peakPickMenu, SWT.PUSH);
        peakPickStackItem.setText("Peak Pick Stacked Array");
        peakPickStackItem.setToolTipText("Peak pick (1 cursor) or integrate (2 cursors) a stacked array");
        
        integrateStackItem = new MenuItem(peakPickMenu, SWT.PUSH);
        integrateStackItem.setText("Integrate Stacked Array");
        integrateStackItem.setToolTipText("Integrate a stacked array based on the integral regions defined in the first spectrum");     
           
        listPeaksItem = new MenuItem(peakPickMenu, SWT.PUSH);
        listPeaksItem.setText("List Peaks (1D and 2D)");
        listPeaksItem.setToolTipText("List (on screen) and possibly print the current peak list");
        
        loadPeaksItem = new MenuItem(peakPickMenu, SWT.PUSH);
        loadPeaksItem.setText("Load Any Picked Peaks or 2D peak assignments");
        loadPeaksItem.setToolTipText("Load 1D picked peaks \nor load any 2D peaks and assignments\nespecially on HSQC type experiments");
        
        @SuppressWarnings("unused")
        MenuItem separator25 = new MenuItem(peakPickMenu, SWT.SEPARATOR);
        
        interpolateItem = new MenuItem(peakPickMenu, SWT.CHECK);
        interpolateItem.setText("Interpolation");
        interpolateItem.setToolTipText("Turn on/off parabolic interpolation \nfor peak picking and calibration");
        interpolateItem.setSelection(true);
        		
        MenuItem signMenuItem = new MenuItem(peakPickMenu, SWT.CASCADE);
        signMenuItem.setText("Peak Pick Sign");
        
        Menu subMenuSign = new Menu(shell, SWT.DROP_DOWN);
        signMenuItem.setMenu(subMenuSign);
        
        posOnlyPeaks = new MenuItem(subMenuSign, SWT.CHECK);
        posOnlyPeaks.setText("Pos. Only");
              
        negOnlyPeaks = new MenuItem(subMenuSign, SWT.CHECK);
        negOnlyPeaks.setText("Neg. Only");
        
        bothPeaks = new MenuItem(subMenuSign, SWT.CHECK);
        bothPeaks.setText("Both");
        bothPeaks.setSelection(true);
               
        MenuItem unitsMenuItem = new MenuItem(peakPickMenu, SWT.CASCADE);
        unitsMenuItem.setText("Peak Pick Units");
        
        Menu subMenuUnits = new Menu(shell, SWT.DROP_DOWN);
        unitsMenuItem.setMenu(subMenuUnits);
        
        unitsHz = new MenuItem(subMenuUnits, SWT.CHECK);
        unitsHz.setText("Hz.");
        
        unitsPPM = new MenuItem(subMenuUnits, SWT.CHECK);
        unitsPPM.setText("PPM");
        unitsPPM.setSelection(true);
        
        decimalDigitsItem = new MenuItem(peakPickMenu, SWT.PUSH);
        decimalDigitsItem.setText("Decimal Digits...");
        decimalDigitsItem.setToolTipText("Digits to the right of the decimal point\nfor peak and integral listings");
        
        @SuppressWarnings("unused")
        MenuItem separator26 = new MenuItem(peakPickMenu, SWT.SEPARATOR);
        
        clearIntegralRegionsItem = new MenuItem(peakPickMenu, SWT.PUSH);
        clearIntegralRegionsItem.setText("Clear All Integral Regions");
        clearIntegralRegionsItem.setToolTipText("Clears all previously defined integral regions");
        
        retainIntegralRegionsItem = new MenuItem(peakPickMenu, SWT.CHECK);
        retainIntegralRegionsItem.setText("Retain Integral Regions on New Data");
        retainIntegralRegionsItem.setToolTipText("Retain the current integral regions when reading a new data set");
        if(gp.retain_integral_regions)
        	 retainIntegralRegionsItem.setSelection(true);
        
        @SuppressWarnings("unused")
        MenuItem separator43 = new MenuItem(peakPickMenu, SWT.SEPARATOR);
        
        binDataItem = new MenuItem(peakPickMenu, SWT.PUSH);
        binDataItem.setText("Bin Data");
        binDataItem.setToolTipText("Collect Data into bins and report result");
        
        binStackedArrayItem = new MenuItem(peakPickMenu, SWT.PUSH);
        binStackedArrayItem.setText("Bin a Stacked Array of Spectra");
        binStackedArrayItem.setToolTipText("Collect Data ot a stacked array \ninto bins and report result");
        
        editBinningParametersItem = new MenuItem(peakPickMenu, SWT.PUSH);
        editBinningParametersItem.setText("Edit the Binning Parameters");
        editBinningParametersItem.setToolTipText("Select the parameters (bin width, etc.)\nused for data binning");
        
// Spin System menu
        MenuItem spinSystemMenuHeader = new MenuItem(menuBar, SWT.CASCADE);
        spinSystemMenuHeader.setText("Spin System");        
        spinSystemMenu = new Menu(shell, SWT.DROP_DOWN);
        spinSystemMenuHeader.setMenu(spinSystemMenu);
             
        editShiftsItem = new MenuItem(spinSystemMenu, SWT.PUSH);
        editShiftsItem.setText("Edit Chemical Shifts...");
        editShiftsItem.setToolTipText(
        		"Edit the chemical shifts and nucleus data for a simulation");
        
        @SuppressWarnings("unused")
        MenuItem separator30 = new MenuItem(spinSystemMenu, SWT.SEPARATOR);
        
        editJItem = new MenuItem(spinSystemMenu, SWT.PUSH);
        editJItem.setText("Edit Scalar (J) Couplings...");
        editJItem.setToolTipText(
        		"Edit the scalar (J) couplings for a simulation");
        
        editDItem = new MenuItem(spinSystemMenu, SWT.PUSH);
        editDItem.setText("Edit Dipolar (D) Couplings...");
        editDItem.setToolTipText(
        		"Edit the dipolar (D) couplings for a simulation");
        
        @SuppressWarnings("unused")
        MenuItem separator31 = new MenuItem(spinSystemMenu, SWT.SEPARATOR);
        
        openSpinSystemItem = new MenuItem(spinSystemMenu, SWT.PUSH);
        openSpinSystemItem.setText("Open a Spin System File...");
        openSpinSystemItem.setToolTipText("Load an existing Sspin system file from disk");
        
        saveSpinSystemItem = new MenuItem(spinSystemMenu, SWT.PUSH);
        saveSpinSystemItem.setText("Save the Spin System to a File...");
        saveSpinSystemItem.setToolTipText("Save the currently defined spin \nsystem to a named file on disk");
        
        @SuppressWarnings("unused")
        MenuItem separator33 = new MenuItem(spinSystemMenu, SWT.SEPARATOR);
        
        clearSpinSystemItem = new MenuItem(spinSystemMenu, SWT.PUSH);
        clearSpinSystemItem.setText("Clear Spin System");
        clearSpinSystemItem.setToolTipText("Clears the currently defined spin system.\nSets number of spins to 0");      
        
     /* MenuItem processingMenuHeader = new MenuItem(menuBar, SWT.CASCADE);
        processingMenuHeader.setText("&Processing");        
        processingMenu = new Menu(shell, SWT.DROP_DOWN);
        processingMenuHeader.setMenu(processingMenu);*/
        
// Simulation menu
        MenuItem simulationMenuHeader = new MenuItem(menuBar, SWT.CASCADE);
        simulationMenuHeader.setText("Simulation");     
        simulationMenuHeader.setToolTipText("Abandon all hope, ye who enter here");
        simulationMenu = new Menu(shell, SWT.DROP_DOWN);
        simulationMenuHeader.setMenu(simulationMenu);
                    
        MenuItem simModeItem = new MenuItem(simulationMenu, SWT.CASCADE);
        simModeItem.setText("Simulation Mode");
        Menu subMenuSimMode = new Menu(shell, SWT.DROP_DOWN);
        simModeItem.setMenu(subMenuSimMode);
        
        modeNUMMRIT_Item = new MenuItem(subMenuSimMode, SWT.CHECK);
        modeNUMMRIT_Item.setText("NUMMRIT (Spin Simulation");
        if(sp.calc_mode == SimPar.HIRES)
        {
        	modeNUMMRIT_Item.setSelection(true);
        }
        
        modeDECON_Item = new MenuItem(subMenuSimMode, SWT.CHECK);
        modeDECON_Item.setText("DECONVOLUTION (Band Fitting)");
        if(sp.calc_mode == SimPar.DECON)
        {
        	modeDECON_Item.setSelection(true);
        }
        
        runSimulationItem = new MenuItem(simulationMenu, SWT.PUSH);
        runSimulationItem.setText("Run Simulation");
        runSimulationItem.setToolTipText( "Run a Simulation (NUMMRIT algorithm)");
        
        listSimulationOutputItem = new MenuItem(simulationMenu, SWT.PUSH);
        listSimulationOutputItem.setText("List Simulation Output");
        listSimulationOutputItem.setToolTipText( "List the output of a simulation");
        
        @SuppressWarnings("unused")
        MenuItem separator32 = new MenuItem(simulationMenu, SWT.SEPARATOR);
        
        editSimulationOptionsItem = new MenuItem(simulationMenu, SWT.PUSH);
        editSimulationOptionsItem.setText("Edit Simulation Options...");
        editSimulationOptionsItem.setToolTipText(
        		"Edit assorted options for a simulation");
        
        @SuppressWarnings("unused")
        MenuItem separator34 = new MenuItem(simulationMenu, SWT.SEPARATOR);
        
        readAssignedTransitionsItem = new MenuItem(simulationMenu, SWT.PUSH);
        readAssignedTransitionsItem.setText("Read Assigned Transitions...");
        readAssignedTransitionsItem.setToolTipText(
        		"Read any previously assigned transitions for this simulation");
        
        saveAssignedTransitionsItem = new MenuItem(simulationMenu, SWT.PUSH);
        saveAssignedTransitionsItem.setText("Save Assigned Transitions As...");
        saveAssignedTransitionsItem.setToolTipText(
        		"Save the assigned transitions to a named file");
        
        @SuppressWarnings("unused")
        MenuItem separator35 = new MenuItem(simulationMenu, SWT.SEPARATOR);
        
        autoAssignTransitionsItem = new MenuItem(simulationMenu, SWT.PUSH);
        autoAssignTransitionsItem.setText("&Auto Assign Transitions\tCtrl+A");
        autoAssignTransitionsItem.setToolTipText(
        		"Automatically assign transitions \nin the currently displayed region");
        autoAssignTransitionsItem.setAccelerator(SWT.MOD1 + 'A');
        
        
        deleteAssignmentsItem = new MenuItem(simulationMenu, SWT.PUSH);
        deleteAssignmentsItem.setText("&Delete Assignments in Region\tCtrl+D");
        deleteAssignmentsItem.setToolTipText(
        		"Delete transition assignments \nin the currently displayed region");
        deleteAssignmentsItem.setAccelerator(SWT.MOD1 + 'D');
        
        loadOptimizedParametersItem = new MenuItem(simulationMenu, SWT.PUSH);
        loadOptimizedParametersItem.setText("Load Optimized Parameters");
        loadOptimizedParametersItem.setToolTipText( "Load the optimized shifts and couplings\ninto the spin system editors");
        
        @SuppressWarnings("unused")
        MenuItem separator36 = new MenuItem(simulationMenu, SWT.SEPARATOR);
        
        openSimpsonFIDItem = new MenuItem(simulationMenu, SWT.PUSH);
        openSimpsonFIDItem.setText("Open a Simpson FID File...");
        openSimpsonFIDItem.setToolTipText( "Open an FID file generated by the Simpson program)");
        
        openSimpsonSpectrumItem = new MenuItem(simulationMenu, SWT.PUSH);
        openSimpsonSpectrumItem.setText("Open a Simpson Spectrum File...");
        openSimpsonSpectrumItem.setToolTipText( "Open a spectrum file generated by the Simpson program)");
        
        @SuppressWarnings("unused")
		MenuItem separator46 = new MenuItem(simulationMenu, SWT.SEPARATOR);
        
        editDeconParametersItem = new MenuItem(simulationMenu, SWT.PUSH);
        editDeconParametersItem.setText("Edit Deconvolution Peak Parameters...");
        editDeconParametersItem.setToolTipText("edit the peak list for deconvolution (band fitting)");
        
        copyDeconPeaksItem = new MenuItem(simulationMenu, SWT.PUSH);
        copyDeconPeaksItem.setText("Copy Picked Peaks to Deconvolution List");
        copyDeconPeaksItem.setToolTipText("Copy the peak pick list to the deconvolution list");
        
        interactiveDeconPanelItem = new MenuItem(simulationMenu, SWT.PUSH);
        interactiveDeconPanelItem.setText("Start the Interactive Deconvolution Dialog...");
        interactiveDeconPanelItem.setToolTipText("Start a dialog to interactively optimize the fitted peaks");
        
       /* @SuppressWarnings("unused")
		MenuItem separator47 = new MenuItem(simulationMenu, SWT.SEPARATOR);
        
        calculateRMS_Item = new MenuItem(simulationMenu, SWT.PUSH);
        calculateRMS_Item.setText("Calculate RMS Deviation");
        calculateRMS_Item.setToolTipText("calculate RMS deviation between experimental and simulated spectra");*/
        
// Help menu
        MenuItem helpMenuHeader = new MenuItem(menuBar, SWT.CASCADE);
        helpMenuHeader.setText("&Help");        
        helpMenu = new Menu(shell, SWT.DROP_DOWN);
        helpMenuHeader.setMenu(helpMenu);
        
        helpManualItem = new MenuItem(helpMenu, SWT.PUSH);
        helpManualItem.setText("Display SpinWorks Manual (PDF)");
        helpManualItem.setToolTipText(
        		"Display SpinWorks manual in PDF format\nPDF reader required");
        
        helpAboutItem = new MenuItem(helpMenu, SWT.PUSH);
        helpAboutItem.setText("About");
        helpAboutItem.setToolTipText("General information on the\nJava version of SpinWorks");
        
        helpPathInfoItem = new MenuItem(helpMenu, SWT.PUSH);
        helpPathInfoItem.setText("Java Runtime Information");
        helpPathInfoItem.setToolTipText("Display the Java Paths (for simulation debugging)");
              
        shell.setMenuBar(menuBar);
   
//-------------------------------------------------------------------------------------------------
// drawing canvas (for all spectral data)
// updated by resize events
        canvas = new Canvas(shell, SWT.NO_BACKGROUND | SWT.BORDER); // NO_BACKGROUND for no flicker
        if(currentOS == osTypes.WINDOWS || currentOS == osTypes.MACOS)
			canvas.setBounds(0, 34, gp.dxsize, gp.dysize);
		else	// LINUX or whatever
			canvas.setBounds(0, 38, gp.dxsize, gp.dysize);  
        
//-------------------------------------------------------------------------------------------------
// tool bar
        final ToolBar toolBar = new ToolBar(shell, SWT.FLAT | SWT.RIGHT );
        toolBar.setBounds(0, 0, 1008, 34);
             
        toolbarOpen = new ToolItem(toolBar, SWT.PUSH);
        toolbarOpen.setToolTipText("Open an NMR data set");
        try
        {
	        Image imageOpen = new Image(Display.getDefault(), parentFolder + "/images/FileOpen.bmp");
	        toolbarOpen.setImage(imageOpen);
        }
        catch (Exception ex)
        {
        	toolbarOpen.setText("Open");
        }
        
        toolbarPrev = new ToolItem(toolBar, SWT.PUSH);
        toolbarPrev.setToolTipText("Previous Bruker experiment number");    
        toolbarPrev.setText("Prev.");
        
        toolbarNext = new ToolItem(toolBar, SWT.PUSH);
        toolbarNext.setToolTipText("Next Bruker experiment number");    
        toolbarNext.setText("Next");
        
        toolbarSave = new ToolItem(toolBar, SWT.PUSH);
        toolbarSave.setToolTipText("Save processed NMR data");
        try
        {
	        Image imageSave = new Image(Display.getDefault(), parentFolder + "/images/FileSave.bmp");
	        toolbarSave.setImage(imageSave);
        }
        catch (Exception ex)
        {
        	toolbarSave.setText("Save");
        }
        
        SW_main.toolbarSave.setEnabled(false);
        
        toolbarPrint = new ToolItem(toolBar, SWT.PUSH);
        toolbarPrint.setToolTipText("Print current NMR spectrum");
        try
        {
	        Image imagePrint = new Image(Display.getDefault(), parentFolder + "/images/FilePrnt.bmp");
	        toolbarPrint.setImage(imagePrint);
        }
        catch (Exception ex)
        {
        	toolbarPrint.setText("Print");
        }
        
        toolbar3DMinus = new ToolItem(toolBar, SWT.PUSH);
        toolbar3DMinus.setToolTipText("Previous 3D Plane");    
        toolbar3DMinus.setText("3D -");
        
        toolbar3DPlus = new ToolItem(toolBar, SWT.PUSH);
        toolbar3DPlus.setToolTipText("Next 3D Plane");    
        toolbar3DPlus.setText("3D +");
        
        ToolItem workspaceLabel = new ToolItem(toolBar, SWT.NONE);
        workspaceLabel.setText("  Workspace:");
            
        ToolItem[] toolSep = new ToolItem[8];
        toolSep[0] = new ToolItem(toolBar, SWT.SEPARATOR);
        for(int i = 0; i < 7; i++)
        {
        	toolBarWorkspace[i] = new ToolItem(toolBar, SWT.CHECK);
        	toolBarWorkspace[i].setText(String.format("%d", i + 1));
        	toolBarWorkspace[i].setToolTipText(String.format("Select Workspace %d", i + 1));  
        	toolSep[i+1] = new ToolItem(toolBar, SWT.SEPARATOR);
        }
        toolBarWorkspace[0].setSelection(true);
        
        // dummy item for spacing
        ToolItem toolSpace = new ToolItem(toolBar, SWT.PUSH);
        toolSpace.setText("  ");
        
        toolbarF2scan = new ToolItem(toolBar, SWT.CHECK);
        toolbarF2scan.setToolTipText("Scan the rows of a 2D experiment");    
        toolbarF2scan.setText("F2 Scan");
        
        toolbarF1scan = new ToolItem(toolBar, SWT.CHECK);
        toolbarF1scan.setToolTipText("Scan the columns of a 2D experiment");    
        toolbarF1scan.setText("F1 Scan");
        
        toolBar.pack();

//-------------------------------------------------------------------------------------------------
// Progress bar
        progressBar = new ProgressBar(shell, SWT.NONE);
        progressBar.setBounds(720, gp.dysize + 75, 170, 17);
 
//-------------------------------------------------------------------------------------------------
// Status strip
        
        // current program status.  e.g "Ready"
        statusStripLabel1 = new Label(shell, SWT.NONE);
        statusStripLabel1.setBounds(10, gp.dysize + 75, 150, 17);
        statusStripLabel1.setText("Ready");
        
        // result of last command
        statusStripLabel2 = new Label(shell, SWT.NONE);
        statusStripLabel2.setBounds(160, gp.dysize + 75, 280, 17);
        statusStripLabel2.setText("");
        
        // for progress bar e.g "processing column 27 of 256"
        statusStripLabel3 = new Label(shell, SWT.NONE);
        statusStripLabel3.setBounds(440, gp.dysize + 75, 280, 17);
        statusStripLabel3.setAlignment(SWT.RIGHT);
        statusStripLabel3.setText("Processing:");
        
        // right mouse button function
        statusStripLabel4 = new Label(shell, SWT.NONE);
        statusStripLabel4.setBounds(gp.dxsize - 300, gp.dysize + 75, 300, 17);
        statusStripLabel4.setAlignment(SWT.RIGHT);
        statusStripLabel4.setForeground(new Color(Display.getCurrent(), 255, 0, 0));
        statusStripLabel4.setText("Mouse: (set cursor,  zoom,  pick nearest peak)");
 
//-------------------------------------------------------------------------------------------------
// button panel
        final int buttonBase;
        if(currentOS == osTypes.WINDOWS || currentOS == osTypes.MACOS)
        	buttonBase = 35;
        else	// Linux or whatever
        	buttonBase = 39;
        
        final int buttonOffset = 25;
        int buttonLocation;
        final int buttonHeight = 25;
        final int buttonWidth = 85;		
         
        buttonLocation = buttonBase;
        vertScaleDownButton = new Button(shell, SWT.FLAT);
        vertScaleDownButton.setBounds(gp.dxsize + 7, buttonLocation, 40, buttonHeight);
        vertScaleDownButton.setText("-");
        vertScaleDownButton.setBackground(new Color(Display.getCurrent(), 0, 255, 255));
        
        vertScaleUpButton = new Button(shell, SWT.FLAT);
        vertScaleUpButton.setBounds(gp.dxsize + 52, buttonLocation, 40, buttonHeight);
        vertScaleUpButton.setText("+");
        vertScaleUpButton.setBackground(new Color(Display.getCurrent(), 0, 255, 255));
        buttonLocation += buttonOffset;
        
        rangeScaleDownButton = new Button(shell, SWT.FLAT);
        rangeScaleDownButton.setBounds(gp.dxsize + 7, buttonLocation, 40, buttonHeight);
        rangeScaleDownButton.setText("-");
        rangeScaleDownButton.setBackground(new Color(Display.getCurrent(), 0, 255, 255));
        
        rangeScaleUpButton = new Button(shell, SWT.FLAT);
        rangeScaleUpButton.setBounds(gp.dxsize + 52, buttonLocation, 40, buttonHeight);
        rangeScaleUpButton.setText("+");
        rangeScaleUpButton.setBackground(new Color(Display.getCurrent(), 0, 255, 255));
        buttonLocation += buttonOffset;
        
        prevBlockButton = new Button(shell, SWT.FLAT);
        prevBlockButton.setBounds(gp.dxsize + 7, buttonLocation, 40, buttonHeight);
        prevBlockButton.setText("Prv");
        prevBlockButton.setBackground(new Color(Display.getCurrent(), 0, 255, 255));
        
        nextBlockButton = new Button(shell, SWT.FLAT);
        nextBlockButton.setBounds(gp.dxsize + 52, buttonLocation, 40, buttonHeight);
        nextBlockButton.setText("Nxt");
        nextBlockButton.setBackground(new Color(Display.getCurrent(), 0, 255, 255));
        buttonLocation += buttonOffset;
                            
        scale1D_DownButton = new Button(shell, SWT.FLAT);
        scale1D_DownButton.setBounds(gp.dxsize + 7, buttonLocation, 40, buttonHeight);
        scale1D_DownButton.setText("-");
        scale1D_DownButton.setBackground(new Color(Display.getCurrent(), 0, 255, 255));
        
        scale1D_UpButton = new Button(shell, SWT.FLAT);
        scale1D_UpButton.setBounds(gp.dxsize + 52, buttonLocation, 40, buttonHeight);
        scale1D_UpButton.setText("+");
        scale1D_UpButton.setBackground(new Color(Display.getCurrent(), 0, 255, 255));
        buttonLocation += buttonOffset;
                                      
        vertResetButton = new Button(shell, SWT.FLAT);
        vertResetButton.setToolTipText("Vertical reset");
        vertResetButton.setBounds(gp.dxsize + 7, buttonLocation, buttonWidth, buttonHeight);
        vertResetButton.setText("Vert. Reset");
        vertResetButton.setBackground(new Color(Display.getCurrent(), 0, 255, 255));
        buttonLocation += buttonOffset;
           
        fullButton = new Button(shell, SWT.FLAT);
        fullButton.setToolTipText("Show full spectrum");
        fullButton.setBounds(gp.dxsize + 7, buttonLocation, buttonWidth, buttonHeight);
        fullButton.setText("Full");
        fullButton.setBackground(new Color(Display.getCurrent(), 0, 255, 255));
        
        zoomButton = new Button(shell, SWT.FLAT);
        buttonLocation = buttonLocation + buttonOffset;
        zoomButton.setToolTipText("Zoom between cursors");
        zoomButton.setBounds(gp.dxsize + 7, buttonLocation, buttonWidth, buttonHeight);
        zoomButton.setText("Zoom");
        zoomButton.setBackground(new Color(Display.getCurrent(), 0, 255, 255));
        
        lastButton = new Button(shell, SWT.FLAT);
        buttonLocation = buttonLocation + buttonOffset;
        lastButton.setToolTipText("Show last expanded region");
        lastButton.setBounds(gp.dxsize + 7, buttonLocation, buttonWidth, buttonHeight);
        lastButton.setText("Last Exp.");
        lastButton.setBackground(new Color(Display.getCurrent(), 0, 255, 255));
        
        disp2DButton = new Button(shell, SWT.FLAT);
        buttonLocation = buttonLocation + buttonOffset;
        disp2DButton.setToolTipText("Switch to 1D display");
        disp2DButton.setBounds(gp.dxsize + 7, buttonLocation, buttonWidth, buttonHeight);
        disp2DButton.setText("1D Displ.");
        disp2DButton.setBackground(new Color(Display.getCurrent(), 0, 255, 255));
        
        posOnlyButton = new Button(shell, SWT.FLAT);
        buttonLocation = buttonLocation + buttonOffset;
        posOnlyButton.setToolTipText("Display positive contours only");
        posOnlyButton.setBounds(gp.dxsize + 7, buttonLocation, buttonWidth, buttonHeight);
        posOnlyButton.setText("Pos Only");
        posOnlyButton.setBackground(new Color(Display.getCurrent(), 0, 255, 255));
        
        contourButton = new Button(shell, SWT.FLAT);
        buttonLocation = buttonLocation + buttonOffset;
        contourButton.setToolTipText("Switch to contour mode");
        contourButton.setBounds(gp.dxsize + 7, buttonLocation, buttonWidth, buttonHeight);
        contourButton.setText("Contour");
        contourButton.setBackground(new Color(Display.getCurrent(), 0, 255, 255));
        
        colButton = new Button(shell, SWT.FLAT);
        buttonLocation = buttonLocation + buttonOffset;
        colButton.setToolTipText("Switch to column mode");
        colButton.setBounds(gp.dxsize + 7, buttonLocation, buttonWidth, buttonHeight);
        colButton.setText("Col");
        colButton.setBackground(new Color(Display.getCurrent(), 0, 255, 255));
        
        clearButton = new Button(shell, SWT.FLAT);
        buttonLocation = buttonLocation + buttonOffset;
        clearButton.setToolTipText("Clear rows and columns");
        clearButton.setBounds(gp.dxsize + 7, buttonLocation, buttonWidth, buttonHeight);
        clearButton.setText("Clear");
        clearButton.setBackground(new Color(Display.getCurrent(), 0, 255, 255));
        
        editParsButton = new Button(shell, SWT.FLAT);
        buttonLocation = buttonLocation + buttonOffset;
        editParsButton.setToolTipText("Edit processing parameters");
        editParsButton.setBounds(gp.dxsize + 7, buttonLocation, buttonWidth, buttonHeight);
        editParsButton.setText("Edit Pars");
        editParsButton.setBackground(new Color(Display.getCurrent(), 80, 255, 80));
        
        processButton = new Button(shell, SWT.FLAT);
        buttonLocation = buttonLocation + buttonOffset;
        processButton.setToolTipText("Process the data");
        processButton.setBounds(gp.dxsize + 7, buttonLocation, buttonWidth, buttonHeight);
        processButton.setText("Process");
        processButton.setBackground(new Color(Display.getCurrent(), 80, 255, 80));
          
// soft buttons
        softButton1 = new Button(shell, SWT.FLAT); 
        buttonLocation = buttonLocation + buttonOffset;
        softButton1.setBounds(gp.dxsize + 7, buttonLocation, buttonWidth, buttonHeight);
        softButton1.setText("Button 1");
        softButton1.setBackground(new Color(Display.getCurrent(), 80, 255, 80));
        
        softButton2 = new Button(shell, SWT.FLAT); 
        buttonLocation = buttonLocation + buttonOffset;
        softButton2.setBounds(gp.dxsize + 7, buttonLocation, buttonWidth, buttonHeight);
        softButton2.setText("Button 2");
        softButton2.setBackground(new Color(Display.getCurrent(), 80, 255, 80));
        
        softButton3 = new Button(shell, SWT.FLAT); 
        buttonLocation = buttonLocation + buttonOffset;
        softButton3.setBounds(gp.dxsize + 7, buttonLocation, buttonWidth, buttonHeight);
        softButton3.setText("Button 3");
        softButton3.setBackground(new Color(Display.getCurrent(), 80, 255, 80));
        
        softButton4 = new Button(shell, SWT.FLAT); 
        buttonLocation = buttonLocation + buttonOffset;
        softButton4.setBounds(gp.dxsize + 7, buttonLocation, buttonWidth, buttonHeight);
        softButton4.setText("Button 4");
        softButton4.setBackground(new Color(Display.getCurrent(), 80, 255, 80));
        
        softButton5 = new Button(shell, SWT.FLAT); 
        buttonLocation = buttonLocation + buttonOffset;
        softButton5.setBounds(gp.dxsize + 7, buttonLocation, buttonWidth, buttonHeight);
        softButton5.setText("Button 5");
        softButton5.setBackground(new Color(Display.getCurrent(), 80, 255, 80));
        
        softButton6 = new Button(shell, SWT.FLAT); 
        buttonLocation = buttonLocation + buttonOffset;
        softButton6.setBounds(gp.dxsize + 7, buttonLocation, buttonWidth, buttonHeight);
        softButton6.setText("Button 6");
        softButton6.setBackground(new Color(Display.getCurrent(), 80, 255, 80));
        
        blPointButton = new Button(shell, SWT.FLAT); 
        buttonLocation = buttonLocation + buttonOffset;
        blPointButton.setBounds(gp.dxsize + 7, buttonLocation, buttonWidth, buttonHeight);
        blPointButton.setText("BL Point");
        blPointButton.setToolTipText("Define points for polynomial or\nspline baseline correction");
        blPointButton.setBackground(new Color(Display.getCurrent(), 80, 255, 80));
        
        
        phaseButton = new Button(shell, SWT.FLAT);
        buttonLocation = buttonLocation + buttonOffset;
        phaseButton.setToolTipText("Interactive phasing");
        phaseButton.setBounds(gp.dxsize + 7, buttonLocation, buttonWidth, buttonHeight);
        phaseButton.setText("Phase");
        phaseButton.setBackground(new Color(Display.getCurrent(), 255, 255, 0));
        
        integrateButton = new Button(shell, SWT.FLAT);
        buttonLocation = buttonLocation + buttonOffset;
        integrateButton.setToolTipText("Interactive integration");
        integrateButton.setBounds(gp.dxsize + 7, buttonLocation, buttonWidth, buttonHeight);
        integrateButton.setText("Integrate");
        integrateButton.setBackground(new Color(Display.getCurrent(), 255, 255, 0));
        
        calibrateButton = new Button(shell, SWT.FLAT);
        buttonLocation = buttonLocation + buttonOffset;
        calibrateButton.setToolTipText("Calibrate spectrum");
        calibrateButton.setBounds(gp.dxsize + 7, buttonLocation, buttonWidth, buttonHeight);
        calibrateButton.setText("Calibrate");
        calibrateButton.setBackground(new Color(Display.getCurrent(), 255, 255, 0));

// slider
        slider = new Slider(shell, SWT.HORIZONTAL);
        slider.setBounds(0, gp.dysize + 40, gp.dxsize, 17);
        slider.setMinimum(0);
        slider.setMaximum(100);
        slider.setIncrement(1);
        slider.setSelection(50);
        slider.setThumb(2);

//-------------------------------------------------------------------------------------------------
// event listeners below
//------------------------------------------------------------------------------------------------- 
// resize listener
        shell.addListener (SWT.Resize,  new Listener () 
        {   
        	@Override
        	public void handleEvent(Event arg0)
        	{ 
        		if(image != null) image.dispose();
        		if(gcImage != null)gcImage.dispose();

        		Rectangle rect = shell.getClientArea();
        		gp.dxsize = rect.width - 100; gp.dysize = rect.height - 100;      		
        		
        		// try this here
        		if(currentOS == osTypes.WINDOWS || currentOS == osTypes.MACOS)
        			canvas.setBounds(0, 34, gp.dxsize, gp.dysize);
        		else	// LINUX or whatever
        			canvas.setBounds(0, 38, gp.dxsize, gp.dysize);        		
        		
        		image = new Image(shell.getDisplay(), canvas.getBounds());
        		gcImage = new GC(image);
        		
        		windowLocation.x = shell.getBounds().x;
        		windowLocation.y = shell.getBounds().y;
        		
        		int buttonLocation;
        	    buttonLocation = buttonBase;

                vertScaleDownButton.setBounds(rect.width - 93, buttonLocation, 40, buttonHeight);
                vertScaleUpButton.setBounds(rect.width -48, buttonLocation, 40, buttonHeight);       	          	    
        	    buttonLocation += buttonOffset;
        	    rangeScaleDownButton.setBounds(rect.width - 93, buttonLocation, 40, buttonHeight);
                rangeScaleUpButton.setBounds(rect.width -48, buttonLocation, 40, buttonHeight);       	          	    
        	    buttonLocation += buttonOffset;       	    
        	    prevBlockButton.setBounds(rect.width - 93, buttonLocation, 40, buttonHeight);
                nextBlockButton.setBounds(rect.width -48, buttonLocation, 40, buttonHeight);     
        	    buttonLocation += buttonOffset;            	    
        	    scale1D_DownButton.setBounds(rect.width - 93, buttonLocation, 40, buttonHeight);
                scale1D_UpButton.setBounds(rect.width -48, buttonLocation, 40, buttonHeight);     
        	    buttonLocation += buttonOffset + 10;          
        	    
        		vertResetButton.setBounds(/*gp.dxsize + 7*/ rect.width - 93, buttonLocation, buttonWidth, buttonHeight);
        		buttonLocation += buttonOffset;
        		fullButton.setBounds(rect.width - 93, buttonLocation, buttonWidth, buttonHeight);
        		buttonLocation += buttonOffset;
        		zoomButton.setBounds(rect.width - 93, buttonLocation, buttonWidth, buttonHeight);
        		buttonLocation += buttonOffset;
        		lastButton.setBounds(rect.width - 93, buttonLocation, buttonWidth, buttonHeight);
        		buttonLocation += buttonOffset;
        		disp2DButton.setBounds(rect.width - 93, buttonLocation, buttonWidth, buttonHeight);
        		buttonLocation += buttonOffset;
        		posOnlyButton.setBounds(rect.width - 93, buttonLocation, buttonWidth, buttonHeight);
        		buttonLocation += buttonOffset;
        		contourButton.setBounds(rect.width - 93, buttonLocation, buttonWidth, buttonHeight);
        		buttonLocation += buttonOffset;
        		colButton.setBounds(rect.width - 93, buttonLocation, buttonWidth, buttonHeight);
        		buttonLocation += buttonOffset;
        		clearButton.setBounds(rect.width - 93, buttonLocation, buttonWidth, buttonHeight);
        		buttonLocation += buttonOffset + 10;
        		
        		editParsButton.setBounds(rect.width - 93, buttonLocation, buttonWidth, buttonHeight);
        		buttonLocation += buttonOffset;
        		processButton.setBounds(rect.width - 93, buttonLocation, buttonWidth, buttonHeight);
        		buttonLocation += buttonOffset;
        		
        		softButton1.setBounds(rect.width - 93, buttonLocation, buttonWidth, buttonHeight);       		
        		buttonLocation += (buttonOffset);
        		softButton2.setBounds(rect.width - 93, buttonLocation, buttonWidth, buttonHeight);       		
        		buttonLocation += (buttonOffset);
        		softButton3.setBounds(rect.width - 93, buttonLocation, buttonWidth, buttonHeight);       		
        		buttonLocation += (buttonOffset);
        		softButton4.setBounds(rect.width - 93, buttonLocation, buttonWidth, buttonHeight);       		
        		buttonLocation += (buttonOffset);
        		softButton5.setBounds(rect.width - 93, buttonLocation, buttonWidth, buttonHeight);       		
        		buttonLocation += (buttonOffset);
        		softButton6.setBounds(rect.width - 93, buttonLocation, buttonWidth, buttonHeight);  
        		buttonLocation += (buttonOffset);
        		blPointButton.setBounds(rect.width - 93, buttonLocation, buttonWidth, buttonHeight);
        		buttonLocation += (buttonOffset + 10);
        		
        		phaseButton.setBounds(rect.width - 93, buttonLocation, buttonWidth, buttonHeight);
        		buttonLocation += buttonOffset;
        		integrateButton.setBounds(rect.width - 93, buttonLocation, buttonWidth, buttonHeight);
        		buttonLocation += buttonOffset;
        		calibrateButton.setBounds(rect.width - 93, buttonLocation, buttonWidth, buttonHeight);
        		
        		progressBar.setBounds(570, rect.height - 25, 170, 17);
        		statusStripLabel1.setBounds(10, rect.height - 25, 120, 17);
        		statusStripLabel2.setBounds(130, rect.height - 25, 200, 17);
        		statusStripLabel3.setBounds(340, rect.height - 25, 220, 17);
        		statusStripLabel4.setBounds(rect.width - 400, rect.height - 25, 300, 17);
        		
        		slider.setBounds(0, rect.height - 60, gp.dxsize, 17);

        		toolBar.setBounds(0, 0, rect.width - 400, 34);
        		
        		gp.new_2D_view = true;
        		update_spect = true;
        		canvas.redraw();  		// triggers paint listener
        	}
        });

//-------------------------------------------------------------------------------------------------
// window moved listener
        shell.addListener (SWT.Move,  new Listener () 
        {   
        	@Override
        	public void handleEvent(Event arg0)
        	{ 
        		windowLocation.x = shell.getBounds().x;
        		windowLocation.y = shell.getBounds().y;
        	}
        });

//-------------------------------------------------------------------------------------------------
// paint listener
        canvas.addPaintListener(new PaintListener()
        { 
            public void paintControl(PaintEvent e)
            {                   
                if(update_spect)
                {  
                	//	Fix for MacOS Graphics bug! //////////////
                	//	necessary to dispose and re-create spectral bitmap every time spectrum is updated.
                	// TODO put this in if(currentOS == osType.MacOS)  block??
                	
                	if(image != null) image.dispose();
            		if(gcImage != null)gcImage.dispose();
            		image = new Image(shell.getDisplay(), canvas.getBounds());
            		gcImage = new GC(image);
            		///////////////////
            		
                	if (gp.display_mode == modes.MODE_1D)				// draw 1D view
                    {
                        GraphUtil.draw_1D_view(gcImage, gp, sp, q, q_f1); 
                    }
                	else if (gp.display_mode == modes.MODE_FID)			// draw FID view
                    {
                        GraphUtil.draw_FID_view(gcImage, gp, q);
                    }
                	else if (gp.display_mode == modes.MODE_2D)			// draw 2D/3D view 
                    {
                		if (q.data_mode == modes.MODE_3D && gp.mode_3D == modes_3D.XY)
                			GraphUtil2D.draw_2D_view(gcImage, gp, q, q_f2, false);
                		else
                			GraphUtil2D.draw_2D_view(gcImage, gp, q, q_f1, false);
                    }
                	update_spect = false;
                	             	
                	for(int j = 0; j < MAX_CHILD_WINDOWS; j++)
                	{
                		if(childWindow[j] != null && childWindowActive[j])
                		{
                			try{childWindow[j].updateLimits();}
                			catch(Exception ex){ ex.printStackTrace();}
                		}
                	}
                }
   
                e.gc.drawImage(image, 0, 0);				// map bitmap to screen
                               
                if (q.data_mode == modes.MODE_3D && gp.mode_3D == modes_3D.XY)
                	MouseHandler.drawCursors(e, q_f2);		// draw live information (cursors, etc.)
                else
                	MouseHandler.drawCursors(e, q_f1);		// draw live information (cursors, etc.)
            }     
        }); 
        
        
//-------------------------------------------------------------------------------------------------
// mouse listeners
        canvas.addMouseListener(new MouseListener() 
        {
        	@Override
        	public void mouseDown(MouseEvent e) 
        	{
        		MouseHandler.MouseDown(e);
        	}

        	@Override
			public void mouseDoubleClick(MouseEvent e) // currently unused
			{	
				MouseHandler.do_mouse_double_click(e);
			}
        	
        	@Override
        	public void mouseUp(MouseEvent e) 
        	{
        		MouseHandler.MouseUp(e);
        		update_spect = true;

        		if(gp.display_mode == modes.MODE_1D) // should be moved to MouseHandler
        			slider.setSelection((int)(100.0 * 
        					(q.offset - (gp.freq1 + gp.freq2) / 2.0) 
        					/ (q.SFO1 * q.SW)));
        		else if(gp.display_mode == modes.MODE_FID)
        			slider.setSelection((int)(100.0 
        					* (gp.t1 + gp.t2) / 2.0 / (q.dwell * q.TD / 2)));

        		canvas.redraw();
        	}			
        });  // add addMouseListener
               
        canvas.addMouseWheelListener(new MouseWheelListener() 
        {
			@Override
			public void mouseScrolled(MouseEvent e) 
			{       		
        		if(gp.display_mode == modes.MODE_1D)	// TODO move this block to MouseHandler?
        		{
        			MouseHandler.do_mouse_wheel_1D(e);
        		}
        		else if (gp.display_mode == modes.MODE_FID)
        		{
        			MouseHandler.do_mouse_wheel_FID(e);
        		}
        		else if (gp.display_mode == modes.MODE_2D)
        		{
        			MouseHandler.do_mouse_wheel_2D(e);
        		}
			}
        });
        	           
        canvas.addMouseMoveListener(new MouseMoveListener() 
        {
        	@Override
        	public void mouseMove(MouseEvent e) 
        	{ 
        		MouseHandler.MouseMove(e);       		
        	}
        });
 
// keyboard listeners
        canvas.addKeyListener(new KeyAdapter()
        {	
        	@Override
        	public void keyPressed(KeyEvent e)
        	{
        		KeyHandler.keyPressed(e);
        	}
        });
  
// focus listeners
        canvas.addFocusListener(new FocusListener()
        {	
        	@Override
        	public void focusGained(FocusEvent event) 
        	{
        		// needed whenever there is a "child window", because of the way cloning is done.
        		// need to refresh 2D pixels as 2D pixel map ends up being common to both
        		// may need to create duplicate 2D pixmap and contour segments for the child window
        		if(childWindow != null)
        		{
        			gp.new_2D_view = true;	// may slow things down in contour mode
        			update_spect = true;
        			canvas.redraw();
        		}
        	}

			@Override
			public void focusLost(FocusEvent arg0) 
			{
				//currently unused	
			}
        });

//-------------------------------------------------------------------------------------------------     
// menu item listeners in other files  
        FileMenuListeners.addFileMenuListeners();
        EditMenuListeners.addEditMenuListeners();  
        ViewMenuListeners.addViewMenuListeners();
        ROI_MenuListeners.addROI_MenuListeners();
        OptionsMenuListeners.addOptionsMenuListeners();
        ProcessingMenuListeners.addProcessingMenuListeners();
        Processing2DMenuListeners.addProcessingMenuListeners();
        Processing3DMenuListeners.addProcessingMenuListeners();
        PeaksMenuListeners.addPeaksMenuListeners();  
        SpinSystemMenuListeners.addSpinSystemMenuListeners();
        SimulationMenuListeners.addSimulationMenuListeners();
        HelpMenuListeners.addHelpMenuListeners();
        
// Toolbar listeners
        ToolbarListeners.addToolbarListeners();
                   
// add button listeners                       
       ButtonListeners.addButtonListeners();	// add listeners for button panel
 
// 	slider listener
       slider.addSelectionListener(new SelectionAdapter() 
       {
    	   public void widgetSelected(SelectionEvent e) 
    	   {
    		   SliderHandler.doScroll();
    	   }
       });
       
// shell listeners
       shell.addShellListener(new ShellListener() 
       {
    	   @Override
    	   public void shellActivated(ShellEvent arg0) 		// unused
    	   {
    	   }

    	   @Override
    	   public void shellClosed(ShellEvent arg0) 
    	   {
    		   PreferenceUtil.setPrefs();
    		   PreferenceUtil.setMru();
    		   // Want to add confirmation dialog!
    	   }

    	   @Override
    	   public void shellDeactivated(ShellEvent arg0)	// unused
    	   {}

    	   @Override
    	   public void shellDeiconified(ShellEvent arg0) 	// unused
    	   {}

    	   @Override
    	   public void shellIconified(ShellEvent arg0) 		// unused
    	   {}
       });
       
 //	Special MacOS menu item listeners       
       if(currentOS == osTypes.MACOS)
       {
       
    	   addMenuItem("Quit", menuBar, new Listener()				// Quit menu item
           {
    		   @Override
    		   public void handleEvent(Event event)
    		   {
    			   PreferenceUtil.setPrefs();
        		   PreferenceUtil.setMru();
    			   System.out.println("Quit");	
    		   }
    	   }, SWT.ID_QUIT);

    	   addMenuItem("About", menuBar, new Listener()				// About menu item
    	   {
    		   @Override
    		   public void handleEvent(Event event)
    		   {
    			   if (Desktop.isDesktopSupported()) 
    			   {
    				   try 
    				   {
    					   Desktop.getDesktop().open(new File(SW_main.parentFolder + "/docs/About.pdf"));
    				   }  
    				   catch (Exception ex) // IO Exception and nullPointerException??
    				   {
    					   Util.show_and_log("no application for this file type?? " +
    							   SW_main.parentFolder + "/docs/About.pdf", ex.getMessage());
    				   }			    
    			   }
    			   else
    				   Util.show_and_log("Current desktop not supported");
    		   }
           }, SWT.ID_ABOUT);

    	   addMenuItem("Preferences", menuBar, new Listener()		// Preferences menu item
    	   {
    		   @Override
    		   public void handleEvent(Event event)
    		   {
    			   StartupOptionsDialog dlg 
    			   = new StartupOptionsDialog(shell, 
    					   SWT.APPLICATION_MODAL | SWT.TITLE | SWT.BORDER );

    			   dlg.open();
    		   }
    	   }, SWT.ID_PREFERENCES);
       }
 
//	set-up drag and drop in canvas 
//TODO Linux (MacOS  OK)
       if(currentOS == osTypes.WINDOWS || currentOS == osTypes.MACOS)
       {
	       DropTarget dt = new DropTarget(canvas, DND.DROP_COPY | DND.DROP_MOVE | DND.DROP_LINK );
	       dt.setTransfer(new Transfer[] { FileTransfer.getInstance(), PluginTransfer.getInstance() });
	       
	       dt.addDropListener(new DropTargetAdapter() 
	       {
	    	   public void drop(DropTargetEvent event) 
	    	   {
	    		   String fileList[] = null;
	               FileTransfer ft = FileTransfer.getInstance();
	               
	               if (ft.isSupportedType(event.currentDataType)) 
	               {
	                   fileList = (String[]) event.data;
	               }
	               else
	            	   return;
	               
	               String fileName = fileList[0];   
	               if(fileName == null)
	            	   return;
	               
	               System.out.println("Opening file: " + fileName);            
	               FileOpen.openFromDragDrop(fileName);
	    	   }
	       });
       }
       
 //------------------------------------------------------------------------------------------------
    }   // createContents  

//-------------------------------------------------------------------------------------------------
/**
 * obtain some useful OS/Platform information
 */
    private static void getOS_Info()
    {  	
    	try 	// "There is no try, only do or not do" -Yoda
    	{
    		osName = System.getProperty("os.name");
    		userHome = System.getProperty("user.home");
    		  		  		
    		if(osName.contains("Windows"))
    			currentOS = osTypes.WINDOWS;
    		else if(osName.contains("Mac") && osName.contains("OS"))
    		{
    			gp.scratch_folder = userHome;
    			currentOS = osTypes.MACOS; 
    		}
    		else if(osName.contains("Linux"))
    		{
    	        gp.scratch_folder = userHome;
    			currentOS = osTypes.LINUX;
    		}
    		 		
    	}  
    	catch(Exception ex){	ex.printStackTrace();	}			
    }

//-------------------------------------------------------------------------------------------------
    private static void printStartInfo()
    {
    	try
    	{
    		Util.log_error("---------------------------------------------------------------------------");
    		Util.log_error("Starting " + version);
    		DateFormat df = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");
    		Date dateobj = new Date();
    		Util.log_error("  at " + df.format(dateobj) + lineSep);       	
    		Util.log_error("arch = " + System.getProperty("os.arch"));
    		Util.log_error("type = " + System.getProperty("os.type"));
    		Util.log_error("name = " + osName);  	
    		if(currentOS == osTypes.WINDOWS)
    			Util.log_error("current OS is Windows");
    		else if(currentOS == osTypes.MACOS)
    			Util.log_error("current OS is MacOS");
    		else if(currentOS == osTypes.LINUX)
    			Util.log_error("current OS is Linux");
    		else
    			Util.log_error("OS type UNKNOWN!");
    		Util.log_error("file separator = " + fileSep);

    		Util.log_error("user home = " + userHome);     		
    		Util.log_error("JRE = " + System.getProperty("java.version"));  		

    		String path 
    		= SW_main.class.getProtectionDomain().getCodeSource().getLocation().getPath();   
    		path = URLDecoder.decode(path, "UTF-8");	// necessary???
    		Util.log_error("path = " + path);

    		parentFolder = (new File(path)).getParentFile().getPath();
    		Util.log_error("parentFolder = " + parentFolder);  		

    		String classLoaderPath 
    		=  URLDecoder.decode(ClassLoader.getSystemClassLoader().getResource(".").getPath(),
    				"UTF-8");
    		Util.log_error("classLoaderPath = " + classLoaderPath);
    	}
    	catch(Exception ex){	ex.printStackTrace();	}
    }
//-------------------------------------------------------------------------------------------------
/**
 * Convenience method that takes care of special MacOS menu items (About, Preferences, Quit...)
 *
 * @param name     The name of the menu item
 * @param parent   The parent {@link Menu}
 * @param listener The {@link Listener} to add to the item
 * @param id       The <code>SWT.ID_*</code> id
 */
    private void addMenuItem(String name, Menu parent, Listener listener, int id)
    {
        if (currentOS == osTypes.MACOS)
        {
            Menu systemMenu = Display.getDefault().getSystemMenu();

            for (MenuItem systemItem : systemMenu.getItems())
            {
                if (systemItem.getID() == id)
                {
                    systemItem.addListener(SWT.Selection, listener);
                    return;
                }
            }
        }

    //	We get here if we're not running on a Mac, or if we're running on a Mac, 
    //	but the menu item with the given id hasn't been found 
        MenuItem item = new MenuItem(parent, SWT.NONE);
        item.setText(name);
        item.addListener(SWT.Selection, listener);
    }
        
//-------------------------------------------------------------------------------------------------
}   // class SW_Main


