/**
 * 
 */
package spinworks;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MenuAdapter;
import org.eclipse.swt.events.MenuEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.FileDialog;

import simulation.DCouplingEditor;
import simulation.JCouplingEditor;
import simulation.ReadSpins;
import simulation.SS_util;
import simulation.ShiftEditor;
import simulation.SimPar;

/**
 * @author marat
 *
 */
public class SpinSystemMenuListeners extends SW_main
{
	public static void addSpinSystemMenuListeners()
	{
		
		// Spin System Menu, update menu items when dropped				
		spinSystemMenu.addMenuListener  (new MenuAdapter() 
		{
			public void menuShown(MenuEvent e) 
			{
				
			}
		});
				
		editShiftsItem.addSelectionListener  (new SelectionAdapter() 
		{		
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				if (sp.n_shifts == 0)
					SS_util.init_sim(SimPar.MAX_SHIFTS, sp);
				
				ShiftEditor dlg = new ShiftEditor(shell, 
  						SWT.APPLICATION_MODAL | SWT.TITLE | SWT.BORDER);
				dlg.open();
			}
		});
		
		editJItem.addSelectionListener  (new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				JCouplingEditor dlg = new JCouplingEditor(shell, 
						SWT.APPLICATION_MODAL | SWT.TITLE | SWT.BORDER);
				dlg.open();
			}
		});
		
		editDItem.addSelectionListener  (new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				DCouplingEditor dlg = new DCouplingEditor(shell, 
						SWT.APPLICATION_MODAL | SWT.TITLE | SWT.BORDER);
				dlg.open();
			}
		});
		
		openSpinSystemItem.addSelectionListener  (new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				FileDialog fd = new FileDialog(shell, SWT.OPEN);
	            fd.setText("Choose a spin system file to open");
	             
	             
	             try	// Just so File Open doesn't fail if something is strange
	             {
	            	 if (gp.data_array != null && q.data_folder.length() > 2)
	            		 fd.setFilterPath(q.data_folder);
	            	 else 
	            		 fd.setFilterPath(gp.scratch_folder);
	             }
	             catch(Exception ex) 
	             { 
	            	 ex.printStackTrace();
	            	 return;
	             }
	             
	             String selected = fd.open();   

	             if(selected == null)
	             {
	            	 statusStripLabel1.setText("Ready");
	            	 return;
	             }
	             ReadSpins.read(selected, gp, sp, q);

	             // update "current" spin system
	             String target;
	             if (gp.data_array == null || q.data_folder.length() < 2)
	             	target = gp.scratch_folder + "/spin_system";
	             else
	            	 target = 	q.data_folder + "spin_system";	// data_folder already has trailing "/"
	             
	             SS_util.write_spins(target, gp, sp, q);
	        
	 			 statusStripLabel2.setText("Spin System Read");
	 			 statusStripLabel1.setText("Ready");
			}
		});
		
		saveSpinSystemItem.addSelectionListener  (new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				FileDialog fd = new FileDialog(shell, SWT.SAVE);
	            fd.setText("Save the current spin system to a file.");
	             
	             
	             try	// Just so File Save doesn't fail if something is strange
	             {
	            	 if (gp.data_array != null && q.data_folder.length() > 2)
	            		 fd.setFilterPath(q.data_folder);
	            	 else 
	            		 fd.setFilterPath(gp.scratch_folder);
	             }
	             catch(Exception ex) 
	             { 
	            	 ex.printStackTrace();
	            	 return;
	             }
	             
	             String selected = fd.open(); 
	             if(selected != null)
	            	 SS_util.write_spins(selected, gp, sp, q);
			}
		});
		
		clearSpinSystemItem.addSelectionListener  (new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				sp.n_shifts = 0;
	            if (gp.log_on) Util.log_error("spin system cleared");
	            statusStripLabel2.setText("spin system cleared");
			}
		});
		
	}	// end addSpinSystemMenuListeners
//-------------------------------------------------------------------------------------------------
}
