/**
 * 
 */
package spinworks;

/**
 * @author marat
 *
 */
public class Util_3D 
{
	
//-------------------------------------------------------------------------------------------------
// load an XY plane from the processed XYZ cube into 2D plane
	public static void load_XY_plane(int plane, float[][][] cube, float[][] matrix,
			int xmax, int ymax)
	     //     X         Y (F2)
	{
		int i, j;

		for (i = 0; i < xmax; i++)
			for (j = 0; j < ymax; j++)
				matrix[j][i] = cube[i][j][plane];
	}

//-------------------------------------------------------------------------------------------------
// load an XZ plane from the processed XYZ cube into 2D plane     
	public static void load_XZ_plane(int plane, float[][][] cube, float[][] matrix,
			int xmax, int zmax)
	//          X         Z(F1)
	{
		int i, j;

		for (i = 0; i < xmax; i++)
			for (j = 0; j < zmax; j++)
				matrix[j][i] = cube[i][plane][j];
	}
        
//-------------------------------------------------------------------------------------------------
// store an XY plane from the 2D plane into the processed XYZ cube
	public static void store_XY_plane(int plane, float[][][] cube, float[][] matrix,
			int xmax, int ymax)
	//          X         Y(F2)
	{
		int i, j;

		for (i = 0; i < xmax; i++)
			for (j = 0; j < ymax; j++)
				cube[i][j][plane] = matrix[j][i];
	}
        
//-------------------------------------------------------------------------------------------------
// store an XZ plane from the 2D plane into the processed XYZ cube
	public static void store_XZ_plane(int plane, float[][][] cube, float[][] matrix,
			int xsize, int ysize)
	//          X          Z
	{
		int i, j;

		for (i = 0; i < xsize; i++)
			for (j = 0; j < ysize; j++)
				cube[i][plane][j] = matrix[j][i];
	}

//-------------------------------------------------------------------------------------------------
// find the global absolute maximum of a 3D data set, real-real quadrant only
	public static double max_3D(float[][][] cube, int xmax, int ymax, int zmax)
	{   //                                            X         Y         Z
		double max = 0.0;

		try
		{
			for (int i = 0; i < xmax; i++)  // X
				for (int j = 0; j < ymax; j++)  // Y
					for (int k = 0; k < zmax; k++)  // Z
						if (Math.abs((double)cube[i][j][k]) > max)
							max = Math.abs((double)cube[i][j][k]);
		}
		catch (Exception ex)
		{
			Util.log_error("max_3D(): " + ex.getMessage());
			return 1.0e4;       // return a default max for scaling
		}

		return max;
	}
//-------------------------------------------------------------------------------------------------
}
