package spinworks;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MenuAdapter;
import org.eclipse.swt.events.MenuEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Cursor;
import org.eclipse.swt.widgets.Display;

import dialogs.ExnoRangeDialog;
import dialogs.StackTraceDialog;

public class ViewMenuListeners extends SW_main
{
	public static int exno;
	public static int last_exno;
	
	public static void addViewMenuListeners()
	{			
		// view Menu, update menu items when dropped				
		viewMenu.addMenuListener  (new MenuAdapter() // menuListener??  Listener??
		{
			public void menuShown(MenuEvent e) 
			{
				// TODO  Clean-up ordering, etc.
				if(gp.display_mode == modes.MODE_1D && gp.data_array != null)
				{
					exptToStackItem.setEnabled(true);
				}
				else
				{
					exptToStackItem.setEnabled(false);
				}
				
				if(gp.display_mode == modes.MODE_1D && gp.n_traces != 0)
				{
					deleteStackTraceItem.setEnabled(true);
					deleteStackTracesItem.setEnabled(true);
					stackedTraceDialogItem.setEnabled(true);
				}
				else
				{
					deleteStackTraceItem.setEnabled(false);
					deleteStackTracesItem.setEnabled(false);
					stackedTraceDialogItem.setEnabled(false);
				}
				
				if(gp.display_mode == modes.MODE_1D && gp.data_array != null
						&& gp.cursor_flag == 2)
					copyToBoxItem.setEnabled(true);
				else
					copyToBoxItem.setEnabled(false);
				
				showCOSY_Item.setEnabled(false);
				showTOCSY_Item.setEnabled(false);
				showNOESY_Item.setEnabled(false);
				showHMBC_Item.setEnabled(false);
				
				if(gp.display_mode == modes.MODE_2D && !gp.rotate_2D)
				{
					showCOSY_Item.setEnabled(true);
					showTOCSY_Item.setEnabled(true);
					showNOESY_Item.setEnabled(true);
					showHMBC_Item.setEnabled(true);
				}
				
				if(gp.showCOSYcorr)
					showCOSY_Item.setSelection(true);
				
				if(gp.showTOCSYcorr)
					showTOCSY_Item.setSelection(true);
				
				if(gp.showNOESYcorr)
					showNOESY_Item.setSelection(true);
				
				if(gp.showHMBCcorr)
					showHMBC_Item.setSelection(true);
				
				XY_3D_Item.setEnabled(false);
				XZ_3D_Item.setEnabled(false);
				if(q.data_mode == modes.MODE_3D)
				{
					XY_3D_Item.setEnabled(true);
					XZ_3D_Item.setEnabled(true);
				}
				
				if(gp.mode_3D == SW_main.modes_3D.XY)
				{
					XY_3D_Item.setSelection(true);
					XZ_3D_Item.setSelection(false);
				}				
				
				else if(gp.mode_3D == SW_main.modes_3D.XZ)
				{
					XZ_3D_Item.setSelection(true);
					XY_3D_Item.setSelection(false);
				}
			}
		});	// menu shown
				
		showSpectrumItem.addSelectionListener  (new SelectionAdapter() // show spectrum
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				//TODO  add all setSelection stuff to menu shown!!!
				if(gp.show_spectrum)
				{
					gp.show_spectrum = false;
					showSpectrumItem.setSelection(false);
				}
				else
				{
					gp.show_spectrum = true;
					showSpectrumItem.setSelection(true);
				}
				update_spect = true;
				canvas.redraw();
			}
		});
		
		showSimulatedItem.addSelectionListener  (new SelectionAdapter() // show simulated
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				if(gp.show_simulated)
				{
					gp.show_simulated = false;
					showSimulatedItem.setSelection(false);
				}
				else
				{
					gp.show_simulated = true;
					showSimulatedItem.setSelection(true);
				}
				update_spect = true;
				canvas.redraw();
			}
		});

		showIntegralsItem.addSelectionListener  (new SelectionAdapter() // show integrals
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				if(gp.show_integrals)
				{
					gp.show_integrals = false;
					showIntegralsItem.setSelection(false);
				}
				else
				{
					gp.show_integrals = true;
					showIntegralsItem.setSelection(true);
				}
				update_spect = true;
				canvas.redraw();
			}
		});
		
		showPeaksItem.addSelectionListener  (new SelectionAdapter() // show picked peaks
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				if(gp.match_on)
				{
					gp.match_on = false;
					showPeaksItem.setSelection(false);
				}
				else
				{
					gp.match_on = true;
					showPeaksItem.setSelection(true);
				}
				update_spect = true;
				canvas.redraw();
			}
		});

		showZeroLineItem.addSelectionListener  (new SelectionAdapter() // show zero line
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				if(gp.show_zero_line)
				{
					gp.show_zero_line = false;
					showZeroLineItem.setSelection(false);
				}
				else
				{
					gp.show_zero_line = true;
					showZeroLineItem.setSelection(true);
				}
				update_spect = true;
				canvas.redraw();
			}
		});
		
		showYaxisItem.addSelectionListener  (new SelectionAdapter() // show zero line
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				if(gp.show_yaxis)
				{
					gp.show_yaxis = false;
					showYaxisItem.setSelection(false);
				}
				else
				{
					gp.show_yaxis = true;
					showYaxisItem.setSelection(true);
				}
				update_spect = true;
				canvas.redraw();
			}
		});
		
		showTitleItem.addSelectionListener  (new SelectionAdapter() // show zero line
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				if(gp.show_title)
				{
					gp.show_title = false;
					showTitleItem.setSelection(false);
				}
				else
				{
					gp.show_title = true;
					showTitleItem.setSelection(true);
				}
				update_spect = true;
				canvas.redraw();
			}
		});

		FID_DisplayItem.addSelectionListener  (new SelectionAdapter() // switch to FID display
		{
			@Override
			public void widgetSelected(SelectionEvent e) // TODO
			{
				 if (gp.display_mode != modes.MODE_FID)
		            {
		                gp.t1 = 0; gp.t2 = (double)(q.TD / 2) * q.dwell;
		                gp.display_mode = modes.MODE_FID;
		                gp.fid_scale = (double)gp.dysize * 0.80 / gp.raw_max;
		            }
		            else
		            {
		                gp.freq1 = q.offset;    gp.freq2 = q.offset - q.SW * q.SF;
		                if (q.data_mode == modes.MODE_1D)
		                {
		                    gp.display_mode = modes.MODE_1D;
		                }
		                else if (q.data_mode == modes.MODE_2D)
		                {
		                    if (q.data_mode == modes.MODE_3D && gp.mode_3D == modes_3D.XY)
		                    {
		                        gp.freq1_indirect = q_f2.offset;
		                        gp.freq2_indirect = q_f2.offset - q_f2.SW * q_f2.SFO1;
		                    }
		                    else
		                    {
		                        gp.freq1_indirect = q_f1.offset;
		                        gp.freq2_indirect = q_f1.offset - q_f1.SW * q_f1.SF;
		                    }
		                    gp.display_mode = modes.MODE_2D;
		                }
		            }
				update_spect = true;
				canvas.redraw();
			}
		});
		
		createChildWindowItem.addSelectionListener  (new SelectionAdapter() // 2D spacing Log
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				if(gp.display_mode == modes.MODE_2D && gp.rotate_2D)
				{
					Util.show_and_log("Child windows not currently available in rotated 2D mode");
					return;
				}
				int i;
				for(i = 0; i < MAX_CHILD_WINDOWS; i++)	// find unoccupied child window
					if(!SW_main.childWindowActive[i])
						break;
					
				childWindow[i] = new ChildDataWindow(shell, i, SW_main.aws,  SWT.NONE | SWT.TITLE | SWT.BORDER);	
				SW_main.childWindowActive[i] = true;
				childWindow[i].open();
				childWindow[i] = null;
			}
		});
		
		rotate2D_Item.addSelectionListener  (new SelectionAdapter() // show simulated
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				if(gp.rotate_2D)
				{
					gp.rotate_2D = false;
					rotate2D_Item.setSelection(false);
				}
				else
				{
					gp.rotate_2D = true;
					rotate2D_Item.setSelection(true);
				}
				
				gp.nslices = 0;
				gp.new_2D_view = true;
				update_spect = true;
				canvas.redraw();
			}
		});
			
		contourSpacingLogItem.addSelectionListener  (new SelectionAdapter() // 2D spacing Log
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				contourSpacingLinearItem.setSelection(false);
				gp.level_spacing_increment = SW_main.level_spacing.LOG;		
				Util_2D.calc_default_levels_2D(gp);
				gp.new_2D_view = true;
				update_spect = true;
				canvas.redraw();
			}
		});

		contourSpacingLinearItem.addSelectionListener  (new SelectionAdapter() // 2D spacing linear
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				contourSpacingLogItem.setSelection(false);
				gp.level_spacing_increment = SW_main.level_spacing.LINEAR;	
				Util_2D.calc_default_levels_2D(gp);
				gp.new_2D_view = true;
				update_spect = true;
				canvas.redraw();
			}
		});
		
		contourSpacingCoarseItem.addSelectionListener  (new SelectionAdapter() // 2D spacing coarse
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				contourSpacingFineItem.setSelection(false);
				gp.contour_spacing = 2;		
				gp.new_2D_view = true;
				update_spect = true;
				canvas.redraw();
			}
		});

		contourSpacingFineItem.addSelectionListener  (new SelectionAdapter() // 2D spacing fine
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				contourSpacingCoarseItem.setSelection(false);
				gp.contour_spacing = 1;	
				gp.new_2D_view = true;
				update_spect = true;
				canvas.redraw();
			}
		});
		
		showCOSY_Item.addSelectionListener  (new SelectionAdapter() // show COSY correlations
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				if(gp.showCOSYcorr)
					gp.showCOSYcorr = false;
				else
					gp.showCOSYcorr = true;
				
				gp.new_2D_view = true;
				update_spect = true;
				canvas.redraw();
			}
		});
		
		showTOCSY_Item.addSelectionListener  (new SelectionAdapter() // show TOCSY correlations
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				if(gp.showTOCSYcorr)
					gp.showTOCSYcorr = false;
				else
					gp.showTOCSYcorr = true;
				
				gp.new_2D_view = true;
				update_spect = true;
				canvas.redraw();
			}
		});
		
		showNOESY_Item.addSelectionListener  (new SelectionAdapter() // show NOESY correlations
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				if(gp.showNOESYcorr)
					gp.showNOESYcorr = false;
				else
					gp.showNOESYcorr = true;
				
				gp.new_2D_view = true;
				update_spect = true;
				canvas.redraw();
			}
		});
		
		showHMBC_Item.addSelectionListener  (new SelectionAdapter() // show HMBC correlations
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				if(gp.showHMBCcorr)
					gp.showHMBCcorr = false;
				else
					gp.showHMBCcorr = true;
				
				gp.new_2D_view = true;
				update_spect = true;
				canvas.redraw();
			}
		});
		
		showF2TraceItem.addSelectionListener  (new SelectionAdapter() // show spectrum
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				if(gp.f2_trace_on)
				{
					gp.f2_trace_on = false;
					showF2TraceItem.setSelection(false);
				}
				else
				{
					gp.f2_trace_on = true;
					showF2TraceItem.setSelection(true);
				}
				gp.new_2D_view = true;
				update_spect = true;
				canvas.redraw();
			}
		 });
		
		 showF1TraceItem.addSelectionListener  (new SelectionAdapter() // show spectrum
		 {
			 @Override
			 public void widgetSelected(SelectionEvent e) 
			 {
				 if(gp.f1_trace_on)
				 {
					 gp.f1_trace_on = false;
					 showF1TraceItem.setSelection(false);
				 }
				 else
				 {
					 gp.f1_trace_on = true;
					 showF1TraceItem.setSelection(true);
				 }
				 gp.new_2D_view = true;
				 update_spect = true;
				 canvas.redraw();
			 }
		 });
		 
		 XY_3D_Item.addSelectionListener  (new SelectionAdapter() // show spectrum
		 {
			 @Override
			 public void widgetSelected(SelectionEvent e) 
			 {
				 if (gp.mode_3D != modes_3D.XY)
					 gp.mode_3D = modes_3D.XY;

				 if (gp.dimensions_processed != 3) return;

				 gp.current_plane = 0;
				 Util_2D.alloc_rows(q_f2.SI, q.SI, gp, q, q_f2);

				 Util_3D.load_XY_plane(gp.current_plane, Proc_3D.XYZ, gp.rows_real, q.SI, q_f2.SI);

				 double plane_shift = 0.0;
				 plane_shift = (q_f1.offset - gp.current_plane * q_f1.hzperpt)
						 / q_f1.SF;
				 statusStripLabel2.setText(String.format("Plane %d: %f.2 ppm", gp.current_plane + 1,
						 plane_shift));

				 // need 3D versions
				 Util_2D.calc_scale_factors_2D(gp, q, q_f2);	// calculate scaling factors, etc.
				 Util_2D.calc_default_levels_2D(gp);	        // calculate default display levels         
				 gp.expt_scale = (double)gp.dysize * 0.80 / gp.data_max_2D;

				 gp.new_2D_view = true;
				 DisplayButtons.fullButtonClick();              // forces update 	
			 }
		 });
		 
		 XZ_3D_Item.addSelectionListener  (new SelectionAdapter() // show spectrum
		 {	// set 3D XZ (F3-F1) mode
			 @Override
			 public void widgetSelected(SelectionEvent e) 
			 {
				 if (gp.mode_3D != modes_3D.XZ)
					 gp.mode_3D = modes_3D.XZ;

				 if (gp.dimensions_processed != 3) return;

				 gp.current_plane = 0;
				 Util_2D.alloc_rows(q_f1.SI, q.SI, gp, q, q_f1);

				 Util_3D.load_XZ_plane(gp.current_plane, Proc_3D.XYZ, gp.rows_real, q.SI, q_f1.SI);

				 double plane_shift = 0.0;
				 plane_shift = (q_f2.offset - gp.current_plane * q_f2.hzperpt)
						 / q_f2.SF;
				 statusStripLabel2.setText(String.format("Plane %d: %f.2 ppm", gp.current_plane + 1,
						 plane_shift));

				 // need 3D versions
				 Util_2D.calc_scale_factors_2D(gp, q, q_f2);	// calculate scaling factors, etc.
				 Util_2D.calc_default_levels_2D(gp);	        // calculate default display levels         
				 gp.expt_scale = (double)gp.dysize * 0.80 / gp.data_max_2D;

				 gp.new_2D_view = true;
				 DisplayButtons.fullButtonClick();              // forces update 	         
			 }
		 });
			
		copyToBoxItem.addSelectionListener  (new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				if(gp.cursor_flag != 2) return;
				
//				create an inset box object for plotting
				gp.printInsetBox[gp.n_boxes] = new PrintInsetBox(gp);
				InsetBox inset = new InsetBox(shell, SWT.NONE | SWT.TITLE | SWT.BORDER, gp.n_boxes - 1);	
				inset.open();
			}
		});
		
		exptToStackItem.addSelectionListener  (new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				if (gp.n_traces >= MAX_TRACES - 1)
				{
	                Util.show_and_log("Maximum number of stacked traces exceeded");
					return;
				}

//		create a stacked trace object
				gp.stack_trace[gp.n_traces] = new Trace(gp, q);

//		copy the current experimental trace into the trace
	            for (int i = 0; i < q.SI; i++)
	            {
	                gp.stack_trace[gp.n_traces].data[i] = gp.data_array[i];
	                if(gp.i_data_array != null)     // may be no imaginary data (e.g. JCAMP-DX)
	                    gp.stack_trace[gp.n_traces].idata[i] = gp.i_data_array[i];
	            }

				gp.n_traces++;		// bump trace number
				update_spect = true;
				canvas.redraw();
				if(!gp.stack_dlg_on)
				{
					StackTraceDialog dlg = new StackTraceDialog(shell, SWT.NONE | SWT.TITLE | SWT.BORDER );			
					dlg.open();
				}
			}
		});
		
		simulatedToStackItem.addSelectionListener  (new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				if (gp.n_traces >= MAX_TRACES - 1)
				{
	                Util.show_and_log("Maximum number of stacked traces exceeded");
					return;
				}

//		create a stacked trace object
				gp.stack_trace[gp.n_traces] = new Trace(gp, q);

//		copy the current simulated trace into the trace
	            for (int i = 0; i < q.SI; i++)
	            {
	                gp.stack_trace[gp.n_traces].data[i] = gp.calc_array[i];
	                if(gp.i_calc_array != null)     // may be no imaginary data (e.g. JCAMP-DX)
	                    gp.stack_trace[gp.n_traces].idata[i] = gp.i_calc_array[i];
	            }
	            
	            gp.stack_trace[gp.n_traces].yscale = gp.calc_scale;
				gp.n_traces++;		// bump trace number
				update_spect = true;
				canvas.redraw();
				if(!gp.stack_dlg_on)
				{
					StackTraceDialog dlg = new StackTraceDialog(shell, SWT.NONE | SWT.TITLE | SWT.BORDER );			
					dlg.open();
				}
			}
		});
		
		addSimulatedToStackItem.addSelectionListener  (new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				if (gp.n_traces == 0 || gp.calc_array == null) return;
				
				for (int i = 0; i < q.SI; i++)
					gp.stack_trace[gp.n_traces - 1].data[i]
						= gp.stack_trace[gp.n_traces - 1].data[i] + gp.calc_array[i];
				
				update_spect = true;
				canvas.redraw();
				if(!gp.stack_dlg_on)
				{
					StackTraceDialog dlg = new StackTraceDialog(shell, SWT.NONE | SWT.TITLE | SWT.BORDER );			
					dlg.open();
				}
			}
		});
		
		seriesExnoToStackItem.addSelectionListener  (new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				shell.setCursor(new Cursor(Display.getDefault(), SWT.CURSOR_WAIT));
	            int i;          
	            exno = FileUtil.getExNo(q.data_folder);	// get current experiment number
	            double currentFreq1 = gp.freq1;			// keep current plot limits as 
	            double currentFreq2 = gp.freq2;			// they may be updated by file open
	            boolean currentAutoLoad = gp.auto_load;
	            gp.auto_load = true;
	            
	            for (i = exno; i < 999; i++)			// get the last contiguous 
	            {										// experiment number
	            	if (FileUtil.setExno(i, q, gp) == false)
	                    break;
	            }
	            last_exno = i - 1;
	            
	            ExnoRangeDialog dlg = new ExnoRangeDialog(shell, 
 						SWT.APPLICATION_MODAL | SWT.TITLE | SWT.BORDER );
	            dlg.open();
	            	            
	            for (i = exno; i <= last_exno && i < 999; i++)
	            {
	                if (FileUtil.setExno(i, q, gp) == false)
	                    break;

	                FileOpen.fileOpenBruker1D(q.data_path);

	                //	create a stacked trace object
	                gp.stack_trace[gp.n_traces] = new Trace(gp, q);

	                //	copy the current experimental trace into the trace
	                for (int j = 0; j < q.SI; j++)
	                {
	                    gp.stack_trace[gp.n_traces].data[j] = gp.data_array[j];
	                    if (gp.i_data_array != null)     // may be no imaginary data (e.g. JCAMP-DX)
	                        gp.stack_trace[gp.n_traces].idata[j] = gp.i_data_array[j];
	                }

	                gp.n_traces++;		// bump trace number
	            }

	            FileUtil.setExno(exno, q, gp);            	// reload first trace
	            FileOpen.fileOpenBruker1D(q.data_path);

	            gp.freq1 = currentFreq1;					// restore display limits
	            gp.freq2 = currentFreq2;
	            gp.display_mode = modes.MODE_1D;
	            shell.setCursor(new Cursor(Display.getDefault(), SWT.CURSOR_ARROW));
				update_spect = true;
				canvas.redraw();
				gp.auto_load = currentAutoLoad;
				
				if(!gp.stack_dlg_on)	// start the stacked trace dialog
				{
					StackTraceDialog stackDlg = new StackTraceDialog(shell, SWT.NONE | SWT.TITLE | SWT.BORDER );			
					stackDlg.open();
				}
			}
		});
		
		dsshItem.addSelectionListener  (new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{

				if (gp.n_traces == 0) return;

	            gp.stack_x_size_auto = false;
	            gp.stack_y_offset = 0;
	            gp.stack_x_size = (gp.dxsize / gp.n_traces) - 20;
	            gp.stack_x_offset = gp.dxsize / gp.n_traces;
	            
				update_spect = true;				
				canvas.redraw();
				
				if(!gp.stack_dlg_on)
				{
					StackTraceDialog dlg = new StackTraceDialog(shell, SWT.NONE | SWT.TITLE | SWT.BORDER );			
					dlg.open();
				}
			}
		});
		
		deleteStackTraceItem.addSelectionListener  (new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				if (gp.n_traces == 0) return;
				gp.stack_trace[gp.n_traces - 1] = null;
				gp.n_traces--;
				update_spect = true;
				canvas.redraw();
			}
		});
		
		deleteStackTracesItem.addSelectionListener  (new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				// TODO add confirmation dialog???
				for (int i = 0; i < gp.n_traces; i++)
					gp.stack_trace[i] = null;
															
				gp.n_traces = 0;

				update_spect = true;
				canvas.redraw();
			}
		});

		stackedTraceDialogItem.addSelectionListener  (new SelectionAdapter() 
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{	
				if(!gp.stack_dlg_on)
				{
					StackTraceDialog dlg = new StackTraceDialog(shell, SWT.NONE | SWT.TITLE | SWT.BORDER );			
					dlg.open();
				}
			}
		});
		
		unitsF2Hz.addSelectionListener  (new SelectionAdapter() // F2 axis units to Hz
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				unitsF2PPM.setSelection(false);
				gp.axis_unit = units.HZ;
				update_spect = true;
				canvas.redraw();
			}
		});

		unitsF2PPM.addSelectionListener  (new SelectionAdapter() // F2 axis units to PPM
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				unitsF2Hz.setSelection(false);
				gp.axis_unit = units.PPM;
				update_spect = true;
				canvas.redraw();
			}
		});	
					
		unitsF1Hz.addSelectionListener  (new SelectionAdapter() // indirect axis units to Hz
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				unitsF1PPM.setSelection(false);
				gp.axis_unit_indirect = units.HZ;
				update_spect = true;
				canvas.redraw();
			}
		});

		unitsF1PPM.addSelectionListener  (new SelectionAdapter() // F1 axis units to PPM
		{
			@Override
			public void widgetSelected(SelectionEvent e) 
			{
				unitsF1Hz.setSelection(false);
				gp.axis_unit_indirect = units.PPM;
				update_spect = true;
				canvas.redraw();
			}
		});					
	}
//-------------------------------------------------------------------------------------------------
}
